#!/usr/bin/python
# -*- coding: utf-8 -*-

from ErrorsHandler import *
import  LoadConfig
config = LoadConfig.LoadConfig()
import wx
import os
import MySQLdb
import shutil
import urllib
import decoder
from tools import cleanlist, which, filecopy, mkdirtree, touch, listmatch, rm, escapedfilename
import datetime
import Msg

class BurnNow(wx.Frame):
    def __init__(self, parent, burnType, playlistID, FocusManager):
        print "BurnNow object instantiated"
	self.parent     = parent
        self.playlistID = playlistID
	self.FocusManager = FocusManager
	wx.Frame.__init__(self, None, -1, "BurnNow")
        self.w = wx.Window(self, style=wx.WANTS_CHARS)
        logger.debug("************************************** : %s" % self.playlistID)


        logger.debug("BurnNow() called... will use burnType: %s, self.playlistID: %s" % (burnType, self.playlistID))
        self.targetPath = config.spoolPath + str(self.playlistID)
        if os.path.isdir(self.targetPath):
	    # if spool dir for this self.playlistID exists (should not!) we remove it
            logmsg_info = "spool directory existed... deleting"
            logger.info(logmsg_info)
            logmsg_info = "listing spool dir"
	    lsspool_cmd = "ls -la %s" % self.targetPath
	    logmsg_info = os.system(lsspool_cmd)
            logger.info(logmsg_info)
            shutil.rmtree(self.targetPath)
        os.mkdir(self.targetPath)
	
        db = MySQLdb.connect(host=config.DBhost, user=config.DBuser, passwd=config.DBpass, db=config.DB)
        cursor = db.cursor()
        cursor.execute("SELECT tr_id FROM netjuke_plists_tracks WHERE pl_id=%s ORDER BY id", self.playlistID)
        tracksListResult = cursor.fetchall()
        burnCount = int(cursor.rowcount)
	logger.info("about to burn %d tracks" % burnCount)

	# start progress dialog for decoding status
        ProgDlg = wx.ProgressDialog("Burn CD",
                                "-> creating your compilation...wait", maximum = burnCount,
                                style = wx.PD_CAN_ABORT | wx.PD_APP_MODAL | wx.PD_ESTIMATED_TIME
				| wx.PD_REMAINING_TIME | wx.PD_ELAPSED_TIME | wx.PD_AUTO_HIDE)

	self.FocusManager.Register("ProgressDialog", ProgDlg)
        self.FocusManager.SetFocus("ProgressDialog")

	keepGoing = True
	count = -1
        keepGoing = ProgDlg.Update(count)
	
	playlistTracks = ''
        lista = ''
        listaWav = ''
        # define array to insert wav .inf files for CDTEXT
        self.wavInfFileList = []

        for record in tracksListResult:
            filesToBurnID = record[0]
            playlistTracks += str(filesToBurnID)
	    playlistTracks += " "

            cursor2 = db.cursor()
            cursor2.execute("SELECT tr.name, tr.location, ar.name FROM netjuke_tracks tr, netjuke_artists ar WHERE tr.ar_id=ar.id AND tr.id=%s", filesToBurnID)
            result2 = cursor2.fetchall()
	    #logmsg = "filesToBurnID = %s " % filesToBurnID
	    
	    # decode to wav 44.100 before burning
            for record2 in result2:
                count = count + 1
                TrackName0 = record2[0]
                TrackName = unicode(TrackName0, 'iso-8859-1')
                locationURL = record2[1]
                TrackArtist = record2[2]
                location = urllib.url2pathname(locationURL)
                location_escaped = escapedfilename(location)
                wavBaseName = os.path.basename(location)[:-4]
                lista += '"' + TrackArtist + '__' + wavBaseName + '.ogg"' + '="' + config.musicPath + location_escaped + '"' + ' '
                wavFullName = self.targetPath + '/' + wavBaseName
                listaWav += '"' + wavFullName + '.wav" '
                self.wavInfFileList.append(self.targetPath + '/' + wavBaseName + '.inf')
		#logmsg = 'appended to self.wavInfFileList array this: %s' % self.wavInfFileList
                if burnType is 'audio':
                    doDecode = decoder.convert2wav(config.musicPath + location_escaped, self.targetPath)
                    if doDecode:
                        logger.debug("" + location_escaped + " converted successfully :)")
                        keepGoing = ProgDlg.Update(count, "Successfully decoded: %s" % TrackName)
                    else:
                        logger.debug("Error while decoding" + location_escaped + " :(")
                        keepGoing = ProgDlg.Update(count, "Error while decoding %s successfully" % TrackName)
        db.close()
        
	#-----------------------------------------------------------
	# cdrecord global parameters
	#-----------------------------------------------------------
        cdrecord_cmd_args = 'dev=%s' % config.burnDevice
        #cdrecord_cmd_args += ' speed=40'
        #cdrecord_cmd_args += ' speed=%d' % config.burnSpeed
        cdrecord_cmd_args += ' gracetime=2'
        cdrecord_cmd_args += ' -tao'
        cdrecord_cmd_args += ' -v'
        cdrecord_cmd_args += ' -driveropts=burnfree'
        cdrecord_cmd_args += ' -fs=32m'
        #cdrecord_cmd_args += ' -s'
        cdrecord_cmd_args += config.cdrecord_dummy
        cdrecord_cmd_args += ' -eject '
	#-----------------------------------------------------------

        #ProgDlg.Destroy()
        
        # burn NOW, really NOW !
        if burnType is 'audio':
            keepGoing = ProgDlg.Update(count, "Finished decoding, starting AUDIO-CD burn..wait")

            keepGoing = True
            count = -1
            keepGoing = ProgDlg.Update(count)
	    
            ## produce html ##
            count = count + 1
            keepGoing = ProgDlg.Update(count, 'Wait..now generating content information')
            self.produceHtmlInfo(tracksListResult)

            # burn the audio tracks
            count = count + 1
            keepGoing = ProgDlg.Update(count, 'Wait..now burning audio tracks')
	    #cdrecord_cmd = "cdrecord %s -defpregap=0 -multi -audio -pad -useinfo -text %s" % (cdrecord_cmd_args, listaWav) # this was used with -multi to handle InfoTrack burning.. disabled below

	    # disabled code from pi, textinfo was not lately tested
	    #cdrecord_cmd = "cdrecord %s -defpregap=0 -audio -pad -useinfo -text %s" % (cdrecord_cmd_args, listaWav)

	    cdrecord_cmd = "cdrecord %s -defpregap=0 -audio -pad %s" % (cdrecord_cmd_args, listaWav)

	    logger.info("executing cdrecord with the following options: %s" % cdrecord_cmd)

            # actually execute it
            CdrecordStatus = os.system(cdrecord_cmd)
	    logger.debug("CdrecordStatus before burning InfoTrack was: %s" % CdrecordStatus)

            #if False and CdrecordStatus is 0:
            if False:
                #----------------------------------------------------------------------------
                ## start code by pi@modular-t.org ##

                ## make isofilesystem ##
                count = count + 1
                #mkiso = 'mkisofs -V "Burnstation" -JR -hfs -hide-hfs AUTORUN.INF -auto index.htm -map /usr/local/burnstation/isosrc/mkisofs.map -o %s -C `/usr/bin/cdrecord dev=0,0 -msinfo` %s' % (config.tmpiso, config.tmpdir)
                mkiso = 'mkhybrid -J -R -o %s -V "BurnS%s" -C `/usr/bin/cdrecord dev=0,0 -msinfo` %s' % (config.tmpiso, self.playlistID, config.tmpdir)
		logmsg = "making iso using command: %s" % mkiso
		logger.debug(logmsg)
                os.system(mkiso)
            
                # burn the datatrack
                count = count + 1
                keepGoing = ProgDlg.Update(count, 'Wait..now burning content information')
                cdrecord_cmd = "cdrecord %s -data -pad %s" % (cdrecord_cmd_args, config.tmpiso)
		logmsg = "writing iso track: %s" % cdrecord_cmd
		logger.debug(logmsg)
                CdrecordStatus = os.system(cdrecord_cmd)

                # fixate the CD
                count = count + 1
                keepGoing = ProgDlg.Update(count, 'Wait..now finishing CD. DO NOT REMOVE it until I tell you!')
                cdrecord_cmd = "cdrecord %s -fix" % cdrecord_cmd_args
                CdrecordStatus = os.system(cdrecord_cmd)
                ## end code by pi@modular-t.org ##
	    
        elif burnType is 'data':
            keepGoing = ProgDlg.Update(count, "Creating ISO for DATA-CD burn..wait")
            # define where to dump the created .iso to be burnt
	    ISOfile = config.spoolPath + '/burnstation.iso'
            
	    # produce html
	    self.produceHtmlInfo(tracksListResult)
            
	    # add HTML page plus contents to ISO list
            lista += ' ' + config.tmpdir + '/*'
	    
            logger.debug("*** ISOfile: %s" % ISOfile)
            
            # prepare mkisofs command to create image
            mkiso_cmd = 'mkisofs -R -o'
            mkiso_cmd += ' ' + ISOfile
            mkiso_cmd += ' -graft-points ' + lista
            
            logger.debug("*** running mkiso_cmd = %s" % mkiso_cmd)
            
            # now run it
            mkisoResult = os.system(mkiso_cmd)
            logger.debug('-------------> mkisoResult: %s' % mkisoResult)

            count = count + 1
            keepGoing = ProgDlg.Update(count, "Starting DATA-CD burn..wait")
            #cdrecord_cmd = "cdrecord -dummy dev=0,0,0 gracetime=2 -s -eject -data speed=8 %s" % ISOfile
            cdrecord_cmd = "cdrecord %s -data %s" % (cdrecord_cmd_args, ISOfile)
            CdrecordStatus = os.system(cdrecord_cmd)
	
        logger.debug("cdrecord_cmd: %s" % cdrecord_cmd)

	if CdrecordStatus == 0:
            # eject the CD now
	    #os.system('eject')
		
            # Set label to display burn result
            BurnResult = "Burnt successfully!"
            BurnResult += "\n\nYou can safely remove your CD now"
            BurnResult += "\n\nThanks for using the Burnstation"
            BurnResult += "\nenjoy ... and come back soon!"
	    h = 350
	    w = 130
	    buttPos = wx.Point(20, 90)
            
	    # Close the current playlist only if burn was successful
            db = MySQLdb.connect(host=config.DBhost, user=config.DBuser, passwd=config.DBpass, db=config.DB)
            cursor = db.cursor()
            cursor.execute("UPDATE netjuke_plists SET status=1 WHERE id=%s" % self.playlistID)
	    db.close()

            # Re-Init application after successful burn
            #self.parent.OnReinitAll()
        
        if CdrecordStatus == 65280: BurnResult = "No disc / Wrong disc"
        if CdrecordStatus == 65024: BurnResult = "Cannot get next writeable address.\nIs it a blank CD ?"
       
	logger.info("cdrecord exit status gave: %d" % CdrecordStatus)
	#self.NowBurningBox.Show(False)
        ProgDlg.Destroy()

        # finally build up the error message out of the previous BurnResult
	if CdrecordStatus != 0: BurnResult = 'Burning process failed with error:\n%s' % BurnResult

	if CdrecordStatus != 0: self.msg = Msg.Msg('BURN RESULT', BurnResult, 'BurnResultBox', 350, 180, wx.Point(10, 45))
        
	if CdrecordStatus == 0:
           logger.debug("about to delete targetPath")

           # remove spool dir after burning
           if shutil.rmtree(self.targetPath): logger.debug("targetPath was deleted")
           else: logger.debug("Removing didn't work.. is it ENABLED ??")

           # Re-Init application after successful burn
	   #self.parent.OnReinitAll()
	   #wx.Yield()
	   self.FullReset()

           BurnResult  = 'Burning process finished successfully!\nPlease, take your CD... enjoy!'
           msg = Msg.Msg('BURN RESULT (for %s CD)' % burnType, BurnResult, 'BurnResultBox', 350, 180, wx.Point(10, 45))

    #---------------------------------------------
    def produceHtmlInfo(self, tracksListResult):
        # prepare tempfiles
        if not os.path.isdir(config.tmpdir):
            # create the temp dir as it does not exist
            os.mkdir(config.tmpdir)

        os.system("cp " + config.srcdir + "/*png " + config.tmpdir)
        os.system("cp " + config.srcdir + "/*ico " + config.tmpdir)
        os.system("cp " + config.srcdir + "/autorun* " + config.tmpdir)
        os.system("cp " + config.bshome + "/ogghelp/* " + config.tmpdir)

        listtext = ''
        db = MySQLdb.connect(host=config.DBhost, user=config.DBuser, passwd=config.DBpass, db=config.DB)

        cursor = db.cursor()
        cursor.execute("SELECT tr_id FROM netjuke_plists_tracks WHERE pl_id='%s' ORDER BY id", self.playlistID)
        tracksListResult = cursor.fetchall()
	wavCount = 0
            
        for record in tracksListResult:
            Xcursor = db.cursor()
            sql = "SELECT tr.name, ar.name, al.name, la.name, tr.id FROM netjuke_tracks tr, netjuke_artists ar, netjuke_albums al, netjuke_labels la WHERE tr.ar_id=ar.id AND tr.al_id=al.id AND tr.la_id=la.id AND tr.id='%s'" % record
            Xcursor.execute(sql)
            Xresult = Xcursor.fetchall()
                
            for Xrecord in Xresult:
                listtext = listtext+"<tr style='background-color:#d3d2d2'>\n"
                listtext = listtext+"<td><a href='http://db.burnstation.org/infopanel.php?id=%s&type=song'>" % Xrecord[4] #track_id
		listtext = listtext+"%s</a></td>" % Xrecord[0] #track
                listtext = listtext+"<td>%s</td>" % Xrecord[2] #album
		listtext = listtext+"<td>%s</td>" % Xrecord[1] #artist
                listtext = listtext+"<td>%s</td>\n" % Xrecord[3] #label
                listtext = listtext+"</tr>\n" 

            ## creating cd-test inf files ##

                listinfo = "Albumperformer='%s'\n" % "burnstation"
                listinfo = listinfo+"Performer='%s'\n" % Xrecord[1]
                listinfo = listinfo+"Albumtitle='%s'\n" % Xrecord[2]
                listinfo = listinfo+"Tracktitle='%s'\n" % Xrecord[0]
                
                infFile = self.wavInfFileList[wavCount]
		#logmsg = 'At produceHtmlInfo() infFile = %s' % infFile
		#logmsg += 'and wavCount = %s' % wavCount
                writeinf = open(infFile, "w")
                writeinf.write(listinfo)
                writeinf.close()
		wavCount = wavCount + 1

        # close database connection, REMEMBER to OPEN again if you need to query ;-)
        db.close()
	
        # generate HTML page to dump on datatrack with compilation info
        indexpart0 = open(config.srcdir+"/index.part0", "r")
        htmltext = indexpart0.read()
        indexpart0.close

        htmltext = htmltext+listtext

        timenow = timestamp = datetime.datetime.now().strftime("%d/%m/%Y")
	htmltext = htmltext + '<tr><td style="background-color: white" colspan="4" align="center">\n'
        htmltext = htmltext + '<br>Created with <a href="http://www.burnstation.org">'
        htmltext = htmltext + "http://www.burnstation.org</a> on %s\n" % timenow
        htmltext = htmltext + '<br> User/Session ID: <a href="%s%s">%s</a>\n' % (config.usersession, self.playlistID, self.playlistID)
	htmltext = htmltext + '<br> <a href="http://www.platoniq.net"> http://www.platoniq.net</a>\n'
        htmltext = htmltext + "</td></tr>\n"
        htmltext = htmltext + "\n"
        htmltext = htmltext + "</td></tr></table>\n"
            
        indexpart1 = open(config.srcdir+"/index.part1", "r")
        htmltext = htmltext + indexpart1.read()
        indexpart1.close
            
        ## save html to a file ##
        writeme = open(config.tmphtml, "w")
        writeme.write(htmltext)
        writeme.close()
    
    #---------------------------------------------
    def CreateNewPlaylist(self):
        logger.debug("now we should create the newplaylist (DISABLED)")
    
    #---------------------------------------------
    def FullReset(self):
        os.system('burnstation')

