#!/usr/bin/python
# -*- coding: utf-8 -*-

from ErrorsHandler import *

class FocusManager:
    """Doc here"""
    def __init__(self):
	self.current = None
	self.objs = {}

    def Register(self, name, obj):
        if obj not in self.objs:
            self.objs[name] = obj
            logger.debug("Added '%s' to self.objs!" % name)
        else:
            logger.debug("Trying to add '%s' to self.objs: already there!" % name)

    def Unregister(self, name):
	if name not in self.objs:
            logger.warn("ERROR: '%s' not in self.objs!" % name)
            return

	self.objs.pop(name)
	if self.current == name:
	    self.current = None
	    self.SetFocus(self.objs.items()[0][0])
            logger.debug("Removed '%s' from self.objs!" % name)

    def SetFocus(self, name):
	import gv
	if name not in self.objs:
	    logger.warn("ERROR at FocusManager.SetFocus(): '%s' not in self.objs" % name)
	    return

	# Ok, the object is registered, so change the focus now
	if self.current is not None:
	    try: self.objs[self.current].SetBackgroundColour(gv.constants.NorPanelColor)
            except Exception, e: "FocusManager ERROR: %s" % str(e)
	self.current = name
	if self.current is not None:
	    try: self.objs[self.current].SetBackgroundColour(gv.constants.SelPanelColor)
            except Exception, e: "FocusManager ERROR: %s" % str(e)
            logger.debug("FocusManager.SetFocus(): focus now set to '%s'" % name)
	    if name == 'MusicTree':
                itemData = self.objs[self.current].GetPyData(self.objs[self.current].GetSelection())
                
        try: self.objs[self.current].SetFocus()
        except: logger.debug("FocusManager.SetFocus(): focus now set to '%s'" % name)

    def MovePrev(self):
	if self.current is not None:
	    self.objs[self.current].MovePrev()

    def MoveNext(self):
	if self.current is not None:
	    self.objs[self.current].MoveNext()

    def JoyRight(self):
	if self.current is not None:
	    self.objs[self.current].JoyRight()

    def JoyLeft(self):
	if self.current is not None:
	    self.objs[self.current].JoyLeft()

    def WhoIsFocused(self):
	return self.current

manager = FocusManager()

