#!/bin/env python
# -*- coding: utf-8 -*-

import wx                  # This module uses the new wx namespace
import sys
sys.path.append("..")
from MiscTools import *
import  LoadConfig
config = LoadConfig.LoadConfig()

import MiniFrame

#----------------------------------------------------------------------

class InfoPage(wx.Panel):
    def __init__(self, parent, text, image, pos):
        wx.Panel.__init__(self, parent, -1)

	self.img = None

        self.sizer = wx.BoxSizer(wx.VERTICAL)
        self.sizer.SetDimension(5,5,10,10)
        self.body = wx.TextCtrl(self, -1, '', size=(600,200), style=wx.TE_MULTILINE|wx.TE_RICH2)
        self.body.SetEditable(False)

        text = self.SetWelcome(text)

	self.pos = config.imgpos

	self.body.SetInsertionPoint(0)

        self.sizer.Add(self.body, 1, wx.EXPAND|wx.ALL)

        vsizer = wx.BoxSizer(wx.HORIZONTAL)
        vsizer.Add(self.sizer, 0, wx.EXPAND)
        vsizer.Add((0, 25))

        self.SetSizer(vsizer)
        self.SetAutoLayout(True)
        vsizer.Fit(self)

        if image is not None:
            self.ShowImage(image)

    def SetBackgroundColour(self, colour):
        self.body.SetBackgroundColour(colour)

    def SetWelcome(self, text):
        text = uniconvert2(text)
        start = 0
        end = len(text)
        self.AddText(text, 'title')

    def SetText(self, text=None, image=None, type='normal'):
        self.body.Clear()

        text = uniconvert2(text)
	self.body.SetInsertionPoint(0)
        self.body.WriteText(text)
	self.body.SetStyle(0, 247, wx.TextAttr("RED", "YELLOW"))

    def AddRow(self, label, value):
        self.AddText(label+" ", 'title')
        self.AddText(value+" ", 'normal')

    def AddText(self, text='', type='normal'):
        if (text is None) or (text is ''): return

        text = uniconvert2(text)

        start = self.body.GetInsertionPoint()
        try: length= len(text)
	except: length = 0
        end   = start + length

	if type is 'title':
            self.body.WriteText(text)
	    points = self.body.GetFont().GetPointSize()  # get the current size
            f = wx.Font(points+3, wx.NORMAL, wx.BOLD, wx.BOLD, True)
            self.body.SetStyle(start, end, wx.TextAttr(wx.NullColour, wx.NullColour, f))

	elif type is 'normal':
            self.body.WriteText(text)
	    points = self.body.GetFont().GetPointSize()  # get the current size
            f = wx.Font(points+3, wx.NORMAL, wx.NORMAL, wx.NORMAL, True)
            self.body.SetStyle(start, end, wx.TextAttr(wx.NullColour, wx.NullColour, f))

    def ShowImage(self, image):
	if isinstance(self.img,wx.Frame):
            self.img.SetImage(image)
        else:
            self.img = MiniFrame.MyMiniFrame(None, '', image, self.pos)

