#!/bin/env python
# -*- coding: utf-8 -*-

import wx                  # This module uses the new wx namespace
import sys
sys.path.append("..")
from MiscTools import *
import  LoadConfig
config = LoadConfig.LoadConfig()

import MiniFrame

#----------------------------------------------------------------------

class InfoPage2(wx.Panel):
    def __init__(self, parent, text):
        wx.Panel.__init__(self, parent, -1)

        self.body = wx.TextCtrl(self, -1, '', size=(300,300), style=wx.TE_MULTILINE|wx.TE_RICH2)
        self.body.SetEditable(False)

        text = self.SetWelcome(text)

	self.body.SetInsertionPoint(0)

    def SetBackgroundColour(self, colour):
        self.body.SetBackgroundColour(colour)

    def SetWelcome(self, text):
        text = uniconvert2(text)
        start = 0
        end = len(text)
        self.AddText(text, 'normal')

    def SetText(self, text=None, image=None, type='normal'):
        self.body.Clear()

        text = uniconvert2(text)
	self.body.SetInsertionPoint(0)
        self.body.WriteText(text)
	self.body.SetStyle(0, 247, wx.TextAttr("RED", "YELLOW"))

    def AddRow(self, label, value):
        self.AddText(label+" ", 'title')
        self.AddText(value+" ", 'normal')

    def AddText(self, text='', type='normal'):
        if (text is None) or (text is ''): return

        text = uniconvert2(text)

        start = self.body.GetInsertionPoint()
        try: length= len(text)
	except: length = 0
        end   = start + length

	if type is 'title':
            self.body.WriteText(text)
	    points = self.body.GetFont().GetPointSize()  # get the current size
            f = wx.Font(config.fontSize, wx.NORMAL, wx.BOLD, wx.BOLD, True)
            self.body.SetStyle(start, end, wx.TextAttr(wx.NullColour, wx.NullColour, f))

	elif type is 'normal':
            self.body.WriteText(text)
	    points = self.body.GetFont().GetPointSize()  # get the current size
            f = wx.Font(config.fontSize, wx.NORMAL, wx.NORMAL, wx.NORMAL, True)
            self.body.SetStyle(start, end, wx.TextAttr(wx.NullColour, wx.NullColour, f))

class Img(wx.Panel):
    def __init__(self, parent, image):
        wx.Panel.__init__(self, parent, -1)

	image = convert2bitmap(image)
        self.img = wx.StaticBitmap(self, -1, image)
        self.img.SetPosition(wx.Point(0,0))
	w = image.GetWidth()
	h = image.GetHeight()
        self.SetSize((w+10, h+20))

    def ShowImage(self, image):
        self.img.SetImage(image)

    def SetImage(self, image):
	image = convert2bitmap(image)
        self.img.SetBitmap(image)
        self.img.SetPosition(wx.Point(0,0))
	w = image.GetWidth()
	h = image.GetHeight()
        self.SetSize((w+10, h+20))
        self.Show(True)
        self.isVisible = True

