#!/usr/bin/python
# -*- coding: utf-8 -*-

from ErrorsHandler import *
logger.info("Initializing joystick module...")

import wx

import time
import MySQLdb

import pygame
import pygame.joystick
import pygame.display

import  LoadConfig


#---------------------------------------------------------------------------

class Joy(wx.Joystick):
    def __init__(self):
        wx.Joystick.__init__(self)

        self.config = LoadConfig.LoadConfig()

        self.SetMovementThreshold(1000)

        # Capture Joystick events (if they happen)
        self.SetMovementThreshold(100)

        self.events = wx.EVT_JOYSTICK_EVENTS

    def OnJoystick(self, evt):
        b = None
        action = None
        joyButton = self.GetButtonState()
        but = []
        
        for i in range(0, 10):
            if (joyButton & (1<<i)):
                log = '**** JOYSTICK button: %s' % i
                #logger.debug(log)
                #print log
                b = i
                but.append(i)
		print "BUTTON IS: " + str(i)
        
            if but.count(self.joymap['JoyLeft']) is 1:
                action = 'JoyLeft'
            if but.count(self.joymap['JoyDown']) is 1:
                action = 'JoyDown'
            if but.count(self.joymap['JoyRight']) is 1:
                action = 'JoyRight'
            if but.count(self.joymap['JoyUp']) is 1:
                action = 'JoyUp'

            if but.count(self.joymap['JoySeek']) is 1:
                action = 'JoySeek'
            if but.count(self.joymap['JoyAdd']) is 1:
                action = 'JoyAddDelete'
            if but.count(self.joymap['JoySwitch']) is 1:
                action = 'JoySwitch'
            if but.count(self.joymap['JoyScroll']) is 1:
                action = 'JoyScroll'
            if but.count(self.joymap['JoyBurn']) is 1:
                action = 'JoyBurn'
            if but.count(self.joymap['JoyReset']) is 1:
                action = 'JoyReset'
    
            if but.count(self.joymap['JoyRandom']) is 1:
                action = 'JoyRandom'

            # the code below is using shift + button
            '''
            if (but.count(8) is 1) and (but.count(0) is 1):
                action = 'JoySeek'
            if (but.count(8) is 1) and (but.count(1) is 1):
                action = 'JoyAddDelete'
            if (but.count(8) is 1) and (but.count(2) is 1):
                action = 'JoySwitch'
            if (but.count(8) is 1) and (but.count(3) is 1):
                action = 'JoyScroll'
            if (but.count(8) is 1) and (but.count(4) is 1):
                action = 'JoyBurn'
            if (but.count(1) is 1) and (but.count(2) is 1):
                action = 'JoyReset'
            '''

        return action


#------------------------------------------------------------------------------------

class Joy2:
    def __init__(self, parent):
        logger.info("Joy: using PyGame")

        self.config = LoadConfig.LoadConfig()

        pygame.display.init()
        pyjoy = pygame.joystick
        pyjoy.init() #initialize joystick module
        pyjoy.get_init() #verify initialization (boolean)

        # initialize
        self.count = pyjoy.get_count()
        if self.count > 0:
            self.stick = pyjoy.Joystick(0)
            self.stick.init() # now we will receive events for the joystick

            self.JoyName = self.stick.get_name()
            logger.info("Joy: found joystick '%s'" % self.JoyName)

            # set time filter (threshold) for catching joystick events (cursor at least)
            self.filterLimit = 120

            # init filter time counter
            self.filterTime = 0
            self.lock = False

	    # create filter timer
            self.tickID = wx.NewId()
            self.tick = wx.Timer(parent, self.tickID)
            wx.EVT_TIMER(parent, self.tickID, self.OnFilterTick)
        else:
            logger.warn("Joy: No joystick was detected !")
            self.stick = None
            return None

	#------------------------------------------------------
        # use cursors or not (can be set via config file (section joystick, key: cursors = 1 or 0)
        if self.config.joyCursors:
            logger.info("Joy: USING CURSORS !")
        else:
            logger.info("Joy: CURSORS OFF !")

	#------------------------------------------------------
	# Joystick actions
        self.joymap = {}

	if self.config.joyType == 'saitek': # for Saitek P2600 Rumble Force Pad
            self.joymap['JoyUp']     = 4
            self.joymap['JoyDown']   = 6
            self.joymap['JoyRight']  = 0
            self.joymap['JoyLeft']   = 8
            self.joymap['JoySeek']   = 2
            self.joymap['JoyAdd']    = 1
            self.joymap['JoySwitch'] = 7
            self.joymap['JoyScroll'] = 3
            self.joymap['JoyBurn']   = 3
            self.joymap['JoyShift']  = 5
            self.joymap['JoyReset']  = self.JoyShift + 4
            self.joymap['JoyRandom'] = 5

            doCancelStr = "press black button"
            doOkStr = 'press silver button'
            doCloseStr = doCancelStr
            doBurnStr = doOkStr
            doSwitchStr = 'button [5] changes option'
	if self.config.joyType == 'asia': # for GreenAsia joy
            self.joymap['JoyUp']     = 6
            self.joymap['JoyDown']   = 4
            self.joymap['JoyRight']  = 2
            self.joymap['JoyLeft']   = 3
            self.joymap['JoySeek']   = 1
            self.joymap['JoyAdd']    = 0
            self.joymap['JoySwitch'] = 7
            self.joymap['JoyScroll'] = 5
            self.joymap['JoyShift']  = 8
            self.joymap['JoyBurn']   = self.JoyShift + 9
            self.joymap['JoyReset']  = self.JoyShift + 1
            self.joymap['JoyRandom'] = -1

            doCancelStr = "press [square] button"
            doOkStr = 'press [X] button'
            doCloseStr = doCancelStr
            doBurnStr = doOkStr
            doSwitchStr = '[R1] changes option'
	elif self.config.joyType == 'rumblepad': # for Logitech Wingman Rumblepad
            self.joymap['JoyUp']     = -1
            self.joymap['JoyDown']   = -1
            self.joymap['JoyRight']  = -1
            self.joymap['JoyLeft']   = -1
            self.joymap['JoySeek']   = 0
            self.joymap['JoyAdd']    = 1
            self.joymap['JoySwitch'] = 2
            self.joymap['JoyScroll'] = 3
            self.joymap['JoyShift']  = -1
            self.joymap['JoyBurn']   = 4
            self.joymap['JoyReset']  = -1
            self.joymap['JoyRandom'] = -1

            doCancelStr = "press [A] button"
            doOkStr = 'press [C] button'
            doCloseStr = doCancelStr
            doBurnStr = doOkStr
            doSwitchStr = 'S + C changes option'
        elif self.config.joyType == 'graz': # for joypad at burnstation Graz (papa)
            self.joymap['JoyUp']     = 7
            self.joymap['JoyDown']   = 8
            self.joymap['JoyRight']  = 9
            self.joymap['JoyLeft']   = 5
            self.joymap['JoySeek']   = 0
            self.joymap['JoyAdd']    = 3
            self.joymap['JoySwitch'] = 1
            self.joymap['JoyScroll'] = 2
            self.joymap['JoyShift']  = -1
            self.joymap['JoyBurn']   = 6
            self.joymap['JoyReset']  = -1
            self.joymap['JoyRandom'] = -1

            doCancelStr = "move Joystick LEFT <-"
            doOkStr = 'move Joystick RIGHT ->'
            doCloseStr = doCancelStr
            doBurnStr = doOkStr
            doSwitchStr = '"Switch Panels" changes option'

        self.doCancel = "CANCEL: %s" % doCancelStr
        self.doClose = "Close\n%s" % doCloseStr
        self.doBurn = "BURN: %s" % doBurnStr
        self.doOk = "OK: %s" % doOkStr
        self.doSwitch = 'SWITCH: %s' % doSwitchStr

        self.GetJoyInfo()
        self.GetJoyMap()

    def filter(self):
        self.lock = True
        #print "filter STARTED !"
        self.filterTime = 0
        self.tick.Start(10)

    def OnFilterTick(self, evt):
        self.filterTime = self.filterTime + 10
        #print "self.filterTime: " + str(self.filterTime)

	if self.filterTime == self.filterLimit:
            #print "filter STOPPED!"
            self.tick.Stop()
            self.lock = False

    def GetEvent(self):
        event = pygame.event.poll()

        if 0:
            cursorX = round(self.stick.get_axis(self.joymap['cursorX']))
            cursorY = round(self.stick.get_axis(self.joymap['cursorY']))

            if cursorX: return self.ProcessCursor(self.joymap['cursorX'], cursorX)
            if cursorY: return self.ProcessCursor(self.joymap['cursorY'], cursorY)

        if event.type != 0 and event.type != 7:
            if event.type == pygame.JOYBUTTONDOWN:
                butt = event.button
		#print "GetEvent: " + str(butt)
                return butt

    def OnJoystick(self, evt):
        action = None
        butt = None

        event = pygame.event.poll()

        # Process cursors
        if self.config.joyCursors:
            action = self.ProcessCursor()

        if event.type != 0 and event.type != 7:

            if event.type == pygame.JOYBUTTONDOWN:
                butt = float(event.button)

                for action in self.joymap.keys():
                    if butt == self.joymap[action]:
                        return action

        return action

    def ProcessCursor(self):
        action = None
        if 1:
            cursors = ['cursorX', 'cursorY', 'vol']

            for cursor in cursors:
                if self.joymap[cursor] < 0: continue
                value = int(round(self.stick.get_axis(self.joymap[cursor])))

                if self.lock is False and value != 0:
                    self.filter()
                    #print "************    is NOT locked !"

                    top    =  1
                    bottom = -1

                    if cursor == 'cursorX':
                        if   value == top:    action = 'JoyRight'
                        elif value == bottom: action = 'JoyLeft'
                    elif cursor == 'cursorY':
                        if   value == top:    action = 'JoyDown'
                        elif value == bottom: action = 'JoyUp'
                    elif cursor == 'vol':
                        if   value == top:    action = 'volDown'
                        elif value == bottom: action = 'volUp'

        return action

    def ReloadConfig(self):
        self.config = LoadConfig.LoadConfig()
        self.GetJoyMap()

    def CreateJoy(self, name):
        print "creating %s joy" % name
        db = MySQLdb.connect(host=self.config.DBhost, user=self.config.DBuser, passwd=self.config.DBpass, db=self.config.DB)

        sql = "INSERT INTO joysticks SET name = '%s'" % name
        cursor = db.cursor()
        cursor.execute(sql)
        joystickID = db.insert_id()

        actions = [
                   'JoyUp',
                   'JoyDown',
                   'JoyLeft',
                   'JoyRight',
                   'JoySeek',
                   'JoyAdd',
                   'JoySwitch',
                   'JoyScroll',
                   'JoyBurn',
                   'JoyReset',
                   'JoyRandom',
                   'cursorX',
                   'cursorY'
                  ]

        for action in actions:
            sql = "INSERT IGNORE INTO joymap SET action = '%s', button = -1, joystick = '%s'" % (action, joystickID)
            cursor = db.cursor()
            cursor.execute(sql)

        self.GetJoyInfo()

    def GetJoyInfo(self):
        db = MySQLdb.connect(host=self.config.DBhost, user=self.config.DBuser, passwd=self.config.DBpass, db=self.config.DB)

        sql = "SELECT id, name FROM joysticks WHERE name = '%s'" % self.JoyName
        cursor = db.cursor()
        cursor.execute(sql)
        result = cursor.fetchall()

        if cursor.rowcount <= 0:
            self.CreateJoy(self.JoyName)
            return

        self.JoyInfo = {}
        for record in result:
            self.JoyInfo['id'] = record[0]
            self.JoyInfo['name'] = record[1]

        db.close()

    def GetJoyMap(self):
        db = MySQLdb.connect(host=self.config.DBhost, user=self.config.DBuser, passwd=self.config.DBpass, db=self.config.DB)

        sql = "SELECT action, button FROM joymap WHERE joystick = '%i' ORDER BY id" % self.JoyInfo['id']
        cursor = db.cursor()
        cursor.execute(sql)
        result = cursor.fetchall()
        for record in result:
            self.joymap[record[0]] = int(record[1])

        db.close()

