#!/usr/bin/python
# -*- coding: utf-8 -*-

import  MySQLdb
import  sys
sys.path.append('..')
import  wx
import  LoadConfig

#---------------------------------------------------------------------------
class JoyConfPanel(wx.Panel):
    def OnSetFocus(self, evt):
        print "OnSetFocus"
        evt.Skip()
    def OnKillFocus(self, evt):
        print "OnKillFocus"
        evt.Skip()
    def OnWindowDestroy(self, evt):
        print "OnWindowDestroy"
        evt.Skip()


    def __init__(self, parent):
        wx.Panel.__init__(self, parent, -1, size=wx.Size(400,200))

        self.config = LoadConfig.LoadConfig()

        self.parent = parent
        self.joymap  = self.parent.parent.stick.joymap
        self.actions = {}
        self.SetAction = ''
        self.joySet  = {}

        sizer = wx.BoxSizer(wx.VERTICAL)

        self.actions['l0'] = wx.StaticText(self, -1, "Joystick Model", pos=(0,10))
        self.actions['t0'] = wx.StaticText(self, -1, self.parent.parent.stick.JoyName, pos=(0,10))

	for action in self.joymap.keys():
            self.actions['l_'+action] = wx.StaticText(self, -1, action, pos=(0,10))
            self.actions['t_'+action] = wx.TextCtrl(self, -1, str(self.joymap[action]), size=wx.Size(300,20))
            self.joySet[action]  = False

        self.b = wx.Button(self, -1, "Done")
        #self.Bind(wx.EVT_BUTTON, self.OnLogin, self.b)

        space = 25

        sizer = wx.FlexGridSizer(cols=2, hgap=space, vgap=8)
        sizer.AddGrowableCol(1, 1)
        sizer.Add(self.actions['l0'], 1, wx.ALIGN_CENTER)
        sizer.Add(self.actions['t0'], 1, wx.GROW|wx.BOTTOM)
        
	for action in self.joymap.keys():
            sizer.Add(self.actions['l_'+action], 1, wx.ALIGN_CENTER)
            sizer.Add(self.actions['t_'+action], 1, wx.GROW|wx.BOTTOM)

        vsizer = wx.BoxSizer(wx.VERTICAL)
        vsizer.Add(sizer, 0, wx.EXPAND)
        vsizer.Add((0, 25))
        vsizer.Add(self.b, 0, wx.EXPAND, space)

        self.SetSizer(vsizer)
        self.SetAutoLayout(True)
        vsizer.Fit(self)

	self.WalkActions()

    def WalkActions(self):
        print self.SetAction
        for action in self.joySet.keys():
            if self.SetAction is '':
                self.Choose(action)
		break
            else:
                if self.joySet[action] == False:
                    self.Choose(action)
                    break

    def Choose(self, action):
        #print "please choose: %s" % action
	self.SetAction = action
        marker = '-> '

        self.actions['l_'+action].SetLabel(marker + action)

    def SetButton(self, button):
        if button is not None:
            button = str(button)
            #print "on JoyConfPanel button: " + str(button)
	    #print "..for action: " + self.SetAction
            action = self.SetAction
            self.actions['l_'+action].SetLabel(action)
            self.actions['t_'+action].SetValue(button)
            self.joySet[action]  = True

            self.WalkActions()

