#!/bin/env python
# -*- coding: utf-8 -*-

#----------------------------------------------------------------------------
# Name:         Main.py
# Purpose:      the main code for the Burnstation
#
# Author:       rama@xicnet.com
#
# Created:      April 2004
# Copyright:    
# Licence:      GPL
#--------------------------------------------------------------------------------

# Change the basedir to match the path where your burnstation-client is installed
#--------------------------------------------------------------------------------

import sys
import Common
import  LoadConfig
config = LoadConfig.LoadConfig()

basedir = config.bshome

sys.path.append(config.bshome)

Common.Init(config.bshome)

# exceptions catcher/logger
from ErrorsHandler import *
logger.info("******************************** Starting BurnStation ********************************")

#from MyLogger import *
#logger = MyLogger()

import os, shutil, time, string, MySQLdb
import MySQLdb
from DB import DB
DB = DB()
import ColorPanel
import ogg
import urllib
import re
from tools import cleanlist, which, filecopy, mkdirtree, touch, listmatch, rm, escapedfilename
import decoder
import wx
import wx.html
import datetime
import BurnNow
import Msg
import images

from MiscTools import *
from panels import *

sys.path.append(basedir + 'import')
import Publish2

import FocusManager

from Joy import *
from JoyConf import *

# welcome message
#import Welcome

# Start Audio system
from Audio import AudioPlayer
Player = AudioPlayer()

# Config variables ( gv = Global Variables )
import gv

#---------------------------------------------------------------------------
# HACKS
#---------------------------------------------------------------------------
os.putenv("LC_ALL","C")

logger.info('Deleting spool directory: %s' % config.spoolPath)
try: shutil.rmtree(config.spoolPath)
except Exception, e: logger.error('Deleting spool directory: %s, EXCEPTION: %s' % (config.spoolPath, str(e)))

logger.info('Creating spool directory: %s' % config.spoolPath)
try: os.mkdir(config.spoolPath)
except Exception, e: logger.error('Creating spool directory: %s, EXCEPTION: %s' % (config.spoolPath, str(e)))

logger.info('Creating temp in spool directory: %s' % config.spoolPath + 'temp')
try: os.mkdir(config.spoolPath + 'temp')
except Exception, e: logger.error('Creating temp in spool directory: %s, EXCEPTION: %s' % (config.spoolPath+'temp', str(e)))

#---------------------------------------------------------------------------
# unclassified functions

import login

#---------------------------------------------------------------------------
class MyLog(wx.PyLog):
    def __init__(self, textCtrl, logTime=0):
        wx.PyLog.__init__(self)
        self.tc = textCtrl
        self.logTime = logTime

    def DoLogString(self, message, timeStamp):
        if self.logTime:
            message = time.strftime("%X", time.localtime(timeStamp)) + \
                      ": " + message
        if self.tc:
            self.tc.AppendText(message + '\n')

#---------------------------------------------------------------------------
class MyTP(wx.PyTipProvider):
    def GetTip(self):
        return "This is my tip"

#---------------------------------------------------------------------------
def opj(path):
    """Convert paths to the platform-specific separator"""
    return apply(os.path.join, tuple(string.split(path, '/')))

#---------------------------------------------------------------------------
class MainFrame(wx.Frame):
    def __init__(self, parent, id, title):
        global GV, logger
	self.GV = gv.constants
        self.GV.logger = logger
	self.FocusManager = FocusManager.manager

        wx.Frame.__init__(self, parent, -1, title,
                         pos = wx.Point(config.guiPosX, config.guiPosY),
                         size = wx.Size(config.guiSizeX, config.guiSizeY),
                         style=wx.DEFAULT_FRAME_STYLE|wx.NO_FULL_REPAINT_ON_RESIZE)
        
	logger.debug('Burnstation app started')

        self.font               = wx.Font(config.fontSize, wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_NORMAL)
        self.fontSelected       = wx.Font(config.fontSize, wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_BOLD)
        self.playlistSeconds   = 0
	self.SelectThis        = None
	self.burnMenuIsOpen    = False
        self.playlistID        = None
        self.GV.NewPlaylistID  = None
	self.htmlPage          = 0
        self.htmlReachedBottom = False
        self.htmlReachedTop    = False
	self.XmmsPlayWelcome()
        self.xmmsSeekPos       = 0
        self.xmmsSeekSecs      = 10000
	self.currentPlayerTick = 0
        self.ContinuedRandom   = False

        self.InitPlaylist()

	self.tickID = wx.NewId()
	self.tick = wx.Timer(self, self.tickID)
	wx.EVT_TIMER(self, self.tickID, self.OnPlayerTick)

	# before building the MainFrame holding whole app, ask for login
	
        # FIXME what icon?
	#icon = "var/www/webspace/burnstation/img/burnstation.ico"
        #self.SetIcon(icon)

        #wx.CallAfter(self.ShowTip)

        self.otherWin = None
	self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

        #self.Centre(wx.BOTH)
        self.CreateStatusBar(1, wx.ST_SIZEGRIP)

        splitterBase = wx.SplitterWindow(self, -1, style=wx.NO_3D|wx.SP_3D)
        splitterMain = wx.SplitterWindow(splitterBase, -1, style=wx.NO_3D|wx.SP_3D)
        splitterNB = wx.SplitterWindow(splitterMain, -1, style=wx.NO_3D|wx.SP_3D)

        def EmptyHandler(evt): pass
	splitterBase.Bind(wx.EVT_ERASE_BACKGROUND, EmptyHandler)
	splitterMain.Bind(wx.EVT_ERASE_BACKGROUND, EmptyHandler)
	splitterNB.Bind(wx.EVT_ERASE_BACKGROUND, EmptyHandler)

        # Prevent TreeCtrl from displaying all items after destruction when True
        self.dying = False

        # Make a File menu
        self.mainmenu = wx.MenuBar()
	menu = wx.Menu()
        
	# publish contents
        importID = wx.NewId()
        menu.Append(importID, '&Publish Contents\tCtrl-P', 'Publish Contents')
	self.Bind(wx.EVT_MENU, self.OnImport, id=importID)

	# edit contents
        editID = wx.NewId()
        menu.Append(editID, '&Edit Contents\tCtrl-E', 'Edit Contents')
	self.Bind(wx.EVT_MENU, self.OnEdit, id=editID)

	# experimental GUI
        experimentalGUIID = wx.NewId()
        menu.Append(experimentalGUIID, 'E&xperimental GUI\tCtrl-X', 'Try the experimental GUI')
	self.Bind(wx.EVT_MENU, self.OnExperimentalGUI, id=experimentalGUIID)

	# joystick configuration
        joyconfID = wx.NewId()
        menu.Append(joyconfID, '&Joystick configuration\tCtrl-J', 'Configure your joystick')
	self.Bind(wx.EVT_MENU, self.OnJoyConf, id=joyconfID)

	# refresh
        RefreshID = wx.NewId()
        menu.Append(RefreshID, '&Refresh\tCtrl-R', 'Refresh the content')
	self.Bind(wx.EVT_MENU, self.OnResetTrees, id=RefreshID)

	# reset
        ResetID = wx.NewId()
        menu.Append(ResetID, '&Reset\tAlt-R', 'Reset trees and playlist')
	self.Bind(wx.EVT_MENU, self.OnReinitAll, id=ResetID)

	# languages option
        langsID = wx.NewId()
        menu.Append(langsID, '&Languages\tCtrl-L', 'Choose your favorite languages')
	self.Bind(wx.EVT_MENU, self.OnLangButton, id=langsID)
        
	# exit option
	exitID = wx.NewId()
        menu.Append(exitID, '&Quit\tCtrl-Q', 'Get the heck outta here!')
	self.Bind(wx.EVT_MENU, self.OnFileExit, id=exitID)
	
	# finally add the options to the menu
	self.mainmenu.Append(menu, '&Options')
            
        # Make a Help menu
        helpID = wx.NewId()
        menu = wx.Menu()
        menu.Append(helpID, '&About\tCtrl-H', 'About Burn Station')
	self.Bind(wx.EVT_MENU, self.OnHelpAbout, id=helpID)
        self.mainmenu.Append(menu, '&Help')
        self.SetMenuBar(self.mainmenu)
        
	#------------------------------------------------------------------------ 
	# Create a TreeCtrl holding the MusicTree
	#------------------------------------------------------------------------ 

        self.GV.HasFocus = None

	# create the notebook
        self.MusicPanel = MusicPanel(splitterMain)
        # Gazer : Hack temporal
        self.MusicPanel.RetPyData = RetPyData

        # populate MusicTree
        self.BuildMusicTree()

	# MusicTree events
        tID = self.MusicPanel.tab['MusicTreeID']
        self.Bind(wx.EVT_TREE_SEL_CHANGED, self.OnSelChangedMusicTree, id=tID)
        self.Bind(wx.EVT_TREE_ITEM_ACTIVATED, self.MusicPanel.OnFocusMusicTree, id=tID)
        self.Bind(wx.EVT_TREE_ITEM_COLLAPSING, self.MusicPanel.OnFocusMusicTree, id=tID)
        self.Bind(wx.EVT_TREE_ITEM_EXPANDING, self.MusicPanel.OnFocusMusicTree, id=tID)
        self.Bind(wx.EVT_TREE_ITEM_EXPANDED, self.MusicPanel.OnMusicTreeExpanding, id=tID)
        self.Bind(wx.EVT_LEFT_DOWN, self.OnTreeLeftDown)
        
        FocusManager.manager.SetFocus('MusicTree')

	#------------------------------------------------------------------------ 
	# create a right-hand panel holding PlaylistList and InfoPanel
	#------------------------------------------------------------------------ 
        # Set a splitter to add the InfoPanel and the bottom control panel
        self.Playlist = PlayListPanel(splitterNB)
        self.Playlist.login = login
        self.Playlist.Build()
        self.Playlist.PopulateData()

        self.Infopanel = InfoPanel(splitterNB)

	self.Bind(wx.EVT_BUTTON, self.OnAddToPlaylist, id=self.Infopanel.AddID)
	self.Bind(wx.EVT_BUTTON, self.RemoveFromPlaylist, id=self.Playlist.RemoveID)
	self.Bind(wx.EVT_BUTTON, self.EvtJoyRight, id=self.Playlist.PlayID)
	self.Bind(wx.EVT_BUTTON, self.XmmsStop, id=self.Playlist.StopID)
	self.Bind(wx.EVT_BUTTON, self.XmmsSeek, id=self.Playlist.SeekID)
	self.Bind(wx.EVT_BUTTON, self.OnPlayRandom, id=self.Playlist.RandomID)
	self.Bind(wx.EVT_BUTTON, self.burnMenu, id=self.MusicPanel.BurnID)
	self.Bind(wx.EVT_CHECKBOX, self.OnPlayCont, id=self.Playlist.PlayContID)

	splitterNB.SplitHorizontally(self.Infopanel, self.Playlist)
	splitterNB.SetSashPosition(380, True)
        splitterNB.SetMinimumPaneSize(380)

	# get welcome message to display on the Info Panel
	self.Infopanel.LoadPage(-1, 'welcome')
        
        self.Show(True)

        # add the windows to the splitter and split it.
	self.Message = MessagePanel(splitterBase)
	# link MessagePanel with the Playlist
	self.Playlist.Message = self.Message

	# Now split all panel into the UI
        splitterBase.SplitHorizontally(self.Message, splitterMain)
        splitterBase.SetSashPosition(35, True)
        splitterBase.SetMinimumPaneSize(15)
	
        splitterMain.SplitVertically(self.MusicPanel, splitterNB)
        splitterMain.SetSashPosition(400, True) # la sash vertical del medio
        splitterMain.SetMinimumPaneSize(20)
	
        splitterNB.SetMinimumPaneSize(20)

	splitterNB.Bind(wx.EVT_ERASE_BACKGROUND, EmptyHandler)

        #=================================================
	# use wx.Joystick
	'''
	self.stick = Joy()
        self.stick.SetCapture(self)
        self.Bind(self.stick.events, self.OnJoystick)
        # Calibrate our controls
        wx.CallAfter(self.OnJoystick)
	'''
        #-------------------------------------------------
        # use pygame joystick
        self.stick = Joy2(self)
        #=================================================
        
	self.Bind(wx.EVT_IDLE, self.OnIdle)

	#------------------------------------------------------------------------ 
	# some shortcuts
	#------------------------------------------------------------------------ 
	searchID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.DBSearch, id=searchID)
	
	clearPlaylistID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.OnClearPlaylist, id=clearPlaylistID)
	
	addToPlaylistID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.OnAddToPlaylist, id=addToPlaylistID)

	quemarPlaylistID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.burnMenu, id=quemarPlaylistID)

	FocusMusicTreeID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.MusicPanel.OnFocusMusicTree, id=FocusMusicTreeID)

	FocusPlaylistTreeID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.OnFocusPlaylist, id=FocusPlaylistTreeID)

	FocusInfoPanelID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.OnFocusInfoPanel, id=FocusInfoPanelID)
	
	XmmsSeekID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.XmmsSeek, id=XmmsSeekID)
	
	RandomID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.OnPlayRandom, id=RandomID)
	
	MovePrevID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.movePrev, id=MovePrevID)
	
	MoveNextID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.moveNext, id=MoveNextID)
	
	PlayID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.Play, id=PlayID)
	
	EvtJoyLeftID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.EvtJoyLeft, id=EvtJoyLeftID)
	
	EvtJoyRightID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.EvtJoyRight, id=EvtJoyRightID)
	
	AddOrRemoveToPlaylistID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.AddOrRemoveToPlaylist, id=AddOrRemoveToPlaylistID)
	
	TabLeftID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.EvtMoveLeft, id=TabLeftID)
	
	TabSwitchID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.EvtSwitch, id=TabSwitchID)
	
	ScrollID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.EvtScroll, id=ScrollID)
	
	BurnID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.burnMenu, id=BurnID)
	
	htmlPageUpID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.htmlPageUp, id=htmlPageUpID)
	
	htmlPageDownID = wx.NewId()
	self.Bind(wx.EVT_MENU, self.htmlPageDown, id=htmlPageDownID)
	
        # set the menu accellerator table...
        self.aTable = wx.AcceleratorTable([(wx.ACCEL_CTRL,  ord('W'), exitID),
                                     (wx.ACCEL_CTRL,  ord('a'), XmmsSeekID),
                                     (wx.ACCEL_CTRL,  ord('z'), AddOrRemoveToPlaylistID),
                                     (wx.ACCEL_CTRL,  ord('s'), TabSwitchID),
                                     (wx.ACCEL_CTRL,  ord('x'), ScrollID),
                                     (wx.ACCEL_CTRL,  ord('d'), BurnID),
                                     (wx.ACCEL_CTRL,  ord('i'), MovePrevID),
                                     (wx.ACCEL_CTRL,  ord('k'), MoveNextID),
                                     (wx.ACCEL_CTRL,  ord('j'), EvtJoyLeftID),
                                     (wx.ACCEL_CTRL,  ord('l'), EvtJoyRightID),
                                     (wx.ACCEL_CTRL,  ord('g'), htmlPageUpID),
                                     (wx.ACCEL_CTRL,  ord('b'), htmlPageDownID),
				     (wx.ACCEL_ALT, ord('h'), helpID)])
        self.SetAcceleratorTable(self.aTable)

    #---------------------------------------------------------------------------
    def getArtistInfo(self, elemento):
            valor = []
        
            db = DB.connect()
            cursor = db.cursor()
            cursor.execute("SELECT ar.name artist, al.name album, tr.name track, tr.time duration, tr.location location, ar.img_src imagen, tr.id trackID, ar.comments comments FROM netjuke_artists ar, netjuke_albums al, netjuke_tracks tr WHERE tr.ar_id=ar.id AND tr.al_id=al.id AND ar.id=%s", (elemento))
            result = cursor.fetchall()
            for record in result:
                 valor.append(record[0]) # artist
                 valor.append(record[1]) # album
                 valor.append(record[2]) # track
                 valor.append(record[3]) # duration
                 valor.append(record[4]) # location
                 valor.append(record[5]) # image
                 valor.append(record[6]) # id
                 valor.append(record[7]) # comments

            db.close()
            return valor

    #---------------------------------------------
    def OnJoystick(self, evt=None):
        self.action = None
        if self.FocusManager.WhoIsFocused() is 'JoyConf':
            self.JoyConf.Panel.SetButton(self.stick.GetEvent())
            return

        if self.stick.stick is not None:
            self.action = self.stick.OnJoystick(evt)
            if self.action is None: return

        #------------------------------------------------------
        # main navigation controls

	# GAZER : Acciones a revisar
        if self.action is 'JoyUp': # move to prev item
            self.movePrev(evt)
        if self.action == 'JoyDown': # move to next item
            self.moveNext(evt)
        if self.action is 'JoyLeft':
            #xmms stop or if stepped on folder act as B, meaning open/close
            self.EvtJoyLeft(evt)
        if self.action is 'JoyRight': # expand/play item
            self.EvtJoyRight(evt)
        if self.action is 'JoyAdd': # add to/delete from playlist
           self.AddOrRemoveToPlaylist(evt)
        if self.action is 'JoySwitch': # switch along panels
           self.EvtSwitch(evt)
	    
        #--------------------------------------------------------
        # additional(?) controls

        if self.action is 'JoyBurn': # burn CD
                self.burnMenu(evt)
        if self.action is 'JoyScroll': # scroll infopanel
            self.EvtScroll(evt)
        if self.action is 'JoySeek': # seek the track forward
           self.XmmsSeek(evt)
        if self.action is 'JoyRandom': # play a random track
	   self.OnPlayRandom(event=None)
        if self.action is 'JoyReset': # reset application
            self.GV.FullReset()

        if self.action is 'volUp': # set the volume up
            logger.info("Moving volume UP")
            Player.VolUp()
            self.Playlist.PlayVolume.SetValue(Player.getVolume())
        if self.action is 'volDown': # set the volume down
            logger.info("Moving volume DOWN")
            Player.VolDown()
            self.Playlist.PlayVolume.SetValue(Player.getVolume())
	    
    #---------------------------------------------
    def EvtScroll(self, event=None):
        logmsg_info = "self.EvtScroll() called, calling self.htmlPageDown() instead"
        logger.info(logmsg_info)
        self.Infopanel.ScrollDown()
    
    #---------------------------------------------
    def EvtSwitch(self, evt=None):
        logmsg = "EvtSwitch() called"
        logger.debug(logmsg)
        if self.FocusManager.WhoIsFocused() is 'DBSearch':
            self.DBSearchL()
        elif self.FocusManager.WhoIsFocused() is 'BurnMenu':
            self.BurnMenuSwitch()
        
	if self.FocusManager.WhoIsFocused() is 'MusicTree':
            self.FocusManager.SetFocus("TextPage")
	    self.Infopanel.LoadPage(self.MusicPanel.i, self.login.NewPlaylistID)
        elif self.FocusManager.WhoIsFocused() is 'TextPage':
	    self.Playlist.SetFocus()
	    self.Infopanel.LoadPage(self.MusicPanel.i, self.login.NewPlaylistID)
        elif self.FocusManager.WhoIsFocused() is 'PlayList':
	    self.MusicPanel.SetSelection(0)
	    self.Infopanel.LoadPage(self.MusicPanel.i, self.login.NewPlaylistID)
            self.FocusManager.SetFocus('MusicTree')
    
    #---------------------------------------------
    def EvtMoveLeft(self, evt=None):
        logmsg = "EvtMoveLeft() called"
        logger.debug(logmsg)
        if self.GV.HasFocus is 'DBSearch':
            self.DBSearchL()
        elif self.GV.HasFocus is 'BurnMenu':
            self.BurnMenuL()
        elif self.GV.HasFocus is 'MusicTree':
            logmsg_info = "not possible to move further left"
            logger.info(logmsg_info)
        elif self.GV.HasFocus is 'ReportsTree':
            self.nb0.SetSelection(0)
            self.MusicPanel.OnFocusMusicTree(event=None)
        elif self.GV.HasFocus is 'Playlist':
            self.MusicPanel.OnFocusReportsTree(event=None)
        elif self.GV.HasFocus is 'InfoPanel':
            self.nb.SetSelection(0)
            self.OnFocusPlaylist(event=None)
    
    #---------------------------------------------
    def EvtMoveRight(self, evt=None):
        logmsg = "EvtMoveRight() called"
        logger.debug(logmsg)
        if self.GV.HasFocus is 'DBSearch':
            self.DBSearchR()
        elif self.FocusManager.WhoIsFocused() is 'BurnMenu':
            self.BurnMenuSwitch()
        elif self.GV.HasFocus is 'MusicTree':
            self.nb0.SetSelection(1)
            self.MusicPanel.OnFocusReportsTree(event=None)
        elif self.GV.HasFocus is 'ReportsTree':
            self.nb.SetSelection(0)
            self.OnFocusPlaylist(event=None)
        elif self.GV.HasFocus is 'Playlist':
            self.nb.SetSelection(1)
            self.OnFocusInfoPanel(event=None)
        elif self.GV.HasFocus is 'InfoPanel':
            logmsg_info = "not possible to move further right"
            logger.info(logmsg_info)
    
    #---------------------------------------------
    def movePrev(self, evt=None):
	self.FocusManager.MovePrev()

    #---------------------------------------------
    def moveNext(self, evt=None):
	self.FocusManager.MoveNext()

    #---------------------------------------------
    def EvtJoyLeft(self, evt=None):
        logmsg = "in EvtJoyLeft() HasFocus: %s" % self.FocusManager.WhoIsFocused()
        logger.debug(logmsg)

        if self.FocusManager.WhoIsFocused() is 'BurnMenu':
            self.BurnMenu.Close()
            self.FocusManager.Unregister('BurnMenu')
            return

	# process self.action on panels (trees)

	try:
	    self.FocusManager.JoyLeft()
            logger.debug("in EvtJoyLeft() did self.FocusManager.JoyLeft()!")
	except Exception, (inst):
            logger.error("in EvtJoyLeft() got exception: " + str(inst))
	    if str(inst) == "Stop":
		self.XmmsStop(evt)

    #---------------------------------------------
    def EvtJoyRight(self, evt=None):
        logmsg = "EvtJoyRight() called..."
        logger.debug(logmsg)
        if self.FocusManager.WhoIsFocused() is 'BurnMenu':
            self.BurnMenu.Close()
            self.FocusManager.Unregister("BurnMenu")
            self.burnNow = BurnNow.BurnNow(self, self.BurnMenu.burnType, self.playlistID, self.FocusManager)
            return

	try:
	    self.FocusManager.JoyRight()
	except Exception, e:
            logger.error("in EvtJoyRight() got exception: " + str(e))
	    if str(e) == "Play":
		self.Play(evt=None)

    #---------------------------------------------
    def OnPlayPlaylist(self, event):
        db = DB.connect()
        cursor = db.cursor()
        sql = "SELECT DISTINCT tr.location \
                        FROM netjuke_plists_tracks pl, netjuke_tracks tr \
                        WHERE pl.pl_id='%s' AND pl.tr_id=tr.id \
			ORDER BY pl.id DESC" % self.SelectedPlaylistID
	cursor.execute(sql)
        result = cursor.fetchall()
        
        Player.ClearPlaylist()
	for record in result:
            TrackLocation = record[0]
	    PlayFile = self.GV.config.musicPath + urllib.url2pathname(TrackLocation)
	    logmsg = PlayFile
            logger.info(logmsg)
	    Player.AddToPlaylist(PlayFile)

        db.close()
	Player.Play()

    #---------------------------------------------
    def OnPlayRandom(self, event=None):
        db = DB.connect()
        cursor = db.cursor(MySQLdb.cursors.DictCursor)
        sql = "SELECT tr.id, tr.name, tr.location, concat('nu.nickname', tr.location) newLocation, tr.time, tr.size, \
               tr.comments, tr.img_src tr_img, al.img_src al_img, \
               la.name label, ar.name artist, al.name album, li.name license \
               FROM netjuke_tracks tr, netjuke_labels la, netjuke_artists ar, netjuke_albums al, licenses li  \
               WHERE tr.la_id=la.id AND tr.ar_id=ar.id AND tr.al_id=al.id AND tr.license=li.id \
               AND tr.exclude = 'f' AND la.exclude = 'f' AND ar.exclude = 'f' AND al.exclude = 'f'"
        if not self.ContinuedRandom: sql += " ORDER BY RAND() LIMIT 1"
	cursor.execute(sql)
        result = cursor.fetchall()

        self.itemData = {}
        self.itemData['type']            = 'song'
        for record in result:
            self.itemData['id']          = record['id']
            self.itemData['name']        = uniconvert2(record['name'])
            self.itemData['location']    = urllib.url2pathname(record['location'])
            self.itemData['newLocation'] = urllib.url2pathname(record['newLocation'])
            self.itemData['length']      = record['time']
            self.itemData['length2']      = record['time']
            self.itemData['size']        = record['size']
            self.itemData['info']        = uniconvert2(record['comments'])
            self.itemData['label']       = uniconvert2(record['label'])
            self.itemData['artist']      = uniconvert2(record['artist'])
            self.itemData['album']       = uniconvert2(record['album'])
            self.itemData['license']     = uniconvert2(record['license'])
            self.itemData['img']         = record['al_img']
	    logger.info("at OnPlayRandom self.trackLocation trying to play: %s" % self.itemData['location'])
            if self.Play(evt=None):
                logger.info("Playing (random): %s" % self.itemData['location'])
		
                # update infopanel
                self.Infopanel.LoadPage(self.itemData, 'song', self.login.NewPlaylistID)
                FocusManager.manager.SetFocus('InfoPanel')
            else:
		logger.error("FAILED to open %s for playback" % self.itemData['location'])
                wx.Sleep(2)
                self.OnPlayRandom(event=None)

            db.close()

    #---------------------------------------------
    def AddOrRemoveToPlaylist(self, evt):
        logger.debug("on AddOrRemoveToPlaylist() focus is: %s" % self.FocusManager.WhoIsFocused())
        if self.FocusManager.WhoIsFocused() is 'MusicTree':
            itemData = self.MusicPanel.tab['MusicTree'].GetItemData(self.treeItem)
        elif self.FocusManager.WhoIsFocused() is 'ReportsTree':
            itemData = self.MusicPanel.tab['ReportsTree'].GetPyData(self.MusicPanel.ReportsTree.Item)
        elif self.FocusManager.WhoIsFocused() is 'PlayList':
            itemData = self.Playlist.GetCurrentItemData()

        if self.FocusManager.WhoIsFocused() is not 'PlayList':
            # Item can only be added to playlist
            self.OnAddToPlaylist(evt)
        else:
            self.Playlist.DeleteSelected()

    #---------------------------------------------
    def OnFocusPlaylist(self, event):
	self.Playlist.SetFocus()

    #---------------------------------------------
    def OnFocusInfoPanel(self, event):
        if self.FocusManager.WhoIsFocused() is not 'InfoPanel':
            self.nb.IsEnabled()
            self.GV.HasFocus = 'InfoPanel'
            mensaje = 'focus info panel'
            wx.LogMessage(mensaje)
    
    #---------------------------------------------
    def OnAddToPlaylist(self, event):
        HadFocus = self.FocusManager.WhoIsFocused()

        if(self.Playlist.length + self.itemData['length2'] > self.Playlist.MaxLength):
            self.Playlist.LengthWarning()
        if(self.Playlist.size + self.itemData['size'] > self.Playlist.MaxSize):
            self.Playlist.SizeWarning()
            self.backToSourceTree(HadFocus)
            return

        print "at AddToPlaylist self.trackLocation: %s" % self.itemData['location']
	try:
	    self.Playlist.Add(self.itemData['location'], self.itemData['id'])
	except IOError, (inst):
	    self.Message.SetMessage("Can't add file to the playlist. Error : File not found.")

        self.backToSourceTree(HadFocus)

    def backToSourceTree(self, HadFocus):
	# Go back to source Tree which
        if HadFocus is 'MusicTree':
            self.MusicPanel.SetSelection(0)
            self.MusicPanel.OnFocusMusicTree(event=None)
        elif HadFocus is 'ReportsTree':
            self.MusicPanel.SetSelection(1)
            self.MusicPanel.OnFocusReportsTree(event=None)

    #---------------------------------------------
    def RemoveFromPlaylist(self, event=None):
	self.Playlist.DeleteSelected()

    #---------------------------------------------
    def CheckLangs(self):
        logmsg_info = "checking langs for this user"
        logger.info(logmsg_info)
        db = DB.connect()
        cursor = db.cursor()
        cursor.execute("SELECT count(lang) FROM lang WHERE userid=%s", (self.GV.LoggedUserID))
        result = cursor.fetchall()
        for record in result:
            langCount = record[0]
	db.close()
	logmsg_info = "user has %s langs chosen" % langCount
	logger.info(logmsg_info)
	if langCount == 0:
            logmsg = "no langs found for this user, offering choices now.."
            logger.warn(logmsg)
	    self.OnLangButton(evt=None)
	    return False
        else:
	    return True
	
    #---------------------------------------------
    def OnTreeType(self, event):
        logmsg = "OnTreeType called ... checking user has at least one lang selected"
        logger.debug(logmsg)
	logmsg = "self.MusicPanel.MusicTree.type is: %s" % self.GV.config.treeType
	logger.debug(logmsg)
	if self.GV.lang == '': # check if the user has at least one lang selected, else ask4it
            logmsg = "not switching tree as no langs are defined for this user"
	    logger.warn(logmsg)
	    langsExist = None
	    logmsg = "before langbox: %s" % langsExist
	    logger.debug(logmsg)
	    self.GV.setSwitchMusicTreeFlag(1)
	    self.OnLangButton(evt=None)
        else:
	    "INFO: OK! user has at least one lang, proceeding to SwitchMusicTree"
	    self.SwitchMusicTree()
    #---------------------------------------------
    def SwitchMusicTree(self):
	if self.GV.config.treeType is 'music':
	    mode = 'reports'
	    TreeTypeButtonLabel = "Browse Music"
	    searchType = 'ReportLabel'
	
	if self.GV.config.treeType is 'reports':
	    mode = 'music'
	    TreeTypeButtonLabel = "Browse Audio Reports"
	    searchType = 'label'

	self.GV.SetTreeType(mode)
        self.TreeTypeButton.SetLabel(TreeTypeButtonLabel)
        self.BrowseDisplay.SetLabel('Browsing: ' + mode)
	
	logmsg = "Switching to " + mode + " browse mode..."
        logger.debug(logmsg)
        self.ClearMusicTree()
        self.BuildMusicTree('', searchType)
        wx.LogMessage("Ok, now browsing " + mode)
        
    #---------------------------------------------
    def makeColorPanel(self, parent, color):
        p = wx.Panel(parent, -1)
        win = ColorPanel.ColoredPanel(p, color)
        p.win = win
    
        def OnCPSize(evt, win=win):
            win.SetSize(evt.GetSize())
	p.Bind(wx.EVT_SIZE, OnCPSize)
	# p o self arriba?
        return p

    #---------------------------------------------
    def BuildMusicTree(self):
        self.BuildMusicTreeDB()
        #self.BuildMusicTreeFile()

    #---------------------------------------------
    def BuildMusicTreeFile(self):
        self.musicPathPrefix = ''
        isz = (16,16)
        il = wx.ImageList(isz[0], isz[1])
        self.fldridx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FOLDER,      wx.ART_OTHER, isz))
        self.fldropenidx = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FILE_OPEN,   wx.ART_OTHER, isz))
        self.fileidx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_NORMAL_FILE, wx.ART_OTHER, isz))
        self.smileidx    = il.Add(images.getSmilesBitmap())
        self.sm_up       = il.Add(images.getSmallUpArrowBitmap())
        self.sm_dn       = il.Add(images.getSmallDnArrowBitmap())

        self.MusicPanel.tab['MusicTree'].SetImageList(il)
        self.il = il
        # NOTE:  For some reason tree items have to have a data object in
        #        order to be sorted.  Since our compare just uses the labels
        #        we don't need any real data, so we'll just use None below for
        #        the item data.
        self.dir = "/home/rama/music"
        logger.debug4( "About to PopulateTree() using dir: %s" % self.dir )
        self.MusicPanel.tab['MusicTree'].DeleteAllItems()
        name = "Removable Device"
	self.root = self.MusicPanel.tab['MusicTree'].AddRoot(name, data = wx.TreeItemData(self.dir))
        self.MusicPanel.tab['MusicTree'].SetItemFont(self.root, self.font)

	if self.dir == '': return

        def _add_dir(root_item, current_dir):
            for d in os.listdir(current_dir):
                # FIXME files with special chars dont work

                #real_dir = os.path.join(current_dir, get_ascii_filename(d))
                real_dir = os.path.join(current_dir, uniconvert2(d))

                if d == '.' or d == '..': continue
                if d[0] == '.': continue

                if not os.path.isdir(real_dir): type = "song"
                else: type = "dir"

                try:
                    itemData = { 'type': type, 'id': 1, 'name':d, 'info':'info', 'img':'img', 'location':real_dir, 'newLocation':real_dir, 'length2':1 }
                    #item  = self.MusicPanel.tab['MusicTree'].AppendItem(root, label, data = wx.TreeItemData(itemData))
                    child = self.MusicPanel.tab['MusicTree'].AppendItem(root_item, d, data = wx.TreeItemData(itemData))
                    self.MusicPanel.tab['MusicTree'].SetItemImage(child, self.fldridx, wx.TreeItemIcon_Normal)
                    self.MusicPanel.tab['MusicTree'].SetItemImage(child, self.fldropenidx, wx.TreeItemIcon_Expanded)
                    self.MusicPanel.tab['MusicTree'].SetItemFont(child, self.font)
                    _add_dir(child, real_dir)
                except Exception, e:
                    logger.error("while trying to read: " + d + " . Got exception: " + str(e) + " " + str(Exception) )
                    logger.debug("ASCII-converted string follows: %s" % get_ascii_filename(d) )

        _add_dir(self.root, self.dir)
            
        self.MusicPanel.tab['MusicTree'].Expand(self.root)

    #---------------------------------------------
    def BuildMusicTreeDB(self, searchString='', searchType='label'):
        self.musicPathPrefix = self.GV.config.musicPath
        if searchType is 'music':
	    searchType = 'artist'
	
        logger.debug("Building Music Tree ...  (using search string: '%s' and search type: '%s')" % (searchString, searchType))
        
        self.MusicPanel.tab['MusicTree'].DeleteAllItems()

        isz = (16,16)
        il = wx.ImageList(isz[0], isz[1])
        fldridx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FOLDER,      wx.ART_OTHER, isz))
        fldropenidx = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FILE_OPEN,   wx.ART_OTHER, isz))
        fileidx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_NORMAL_FILE, wx.ART_OTHER, isz))
        smileidx    = il.Add(images.getSmilesBitmap())

        self.MusicPanel.tab['MusicTree'].SetImageList(il)
	self.MusicPanel.tab['MusicTree'].il = il

        # NOTE:  For some reason tree items have to have a data object in
        #        order to be sorted.  Since our compare just uses the labels
        #        we don't need any real data, so we'll just use None below for
        #        the item data.

        root = self.MusicPanel.tab['MusicTree'].AddRoot("MusicTreeRoot")
        self.MusicPanel.tab['MusicTree'].SetPyData(root, None)
        self.MusicPanel.tab['MusicTree'].SetItemImage(root, fldridx, wx.TreeItemIcon_Normal)
        self.MusicPanel.tab['MusicTree'].SetItemImage(root, fldropenidx, wx.TreeItemIcon_Expanded)

        db = DB.connect()
        cursor = db.cursor()
	#------------------------------------------------------------------------------------#
	#                                     Music                                          #
	#------------------------------------------------------------------------------------#

        # -------------------------------------------------
        # Get LABELS list
        # -------------------------------------------------
        if searchType == 'label':
           sql = "/* Get Music LABELS */ SELECT DISTINCT la.id, la.name, la.comments, la.img_src \
		  FROM netjuke_labels la, netjuke_tracks tr"
           sql += " WHERE la.id=tr.la_id AND tr.report=0"
	   sql += " AND la.exclude = 'f' AND tr.exclude = 'f'"
	   #sql += " AND tr.enabled = '1'" # enabled = 1 means officially published
	   sql += " AND la.name LIKE '%"
           sql += "%s" % searchString
           sql += "%'" + " ORDER BY la.name LIMIT %d" % self.GV.config.treeLimit
	
           cursor.execute(sql)
           result = cursor.fetchall()
           for record in result:
               labelID  = record[0]
               label    = uniconvert2(record[1])
               info     = uniconvert2(record[2])
               img      = record[3]
               itemData = { 'type': 'label', 'id': labelID, 'name':label, 'info':info, 'img':img }
               item     = self.MusicPanel.tab['MusicTree'].AppendItem(root, label, data = wx.TreeItemData(itemData))

	       self.MusicPanel.tab['MusicTree'].SetItemFont(item, self.font)
               self.MusicPanel.tab['MusicTree'].SetItemImage(item, fldridx, wx.TreeItemIcon_Normal)
               self.MusicPanel.tab['MusicTree'].SetItemImage(item, fldropenidx, wx.TreeItemIcon_Expanded)
               
               cursor2 = db.cursor()
               # Get ARTISTS for this LABEL
               sql2 = "/* Get ARTISTS for this LABEL */ \
		       SELECT DISTINCT ar.id artist_id, ar.name artist, ar.comments, ar.img_src \
                       FROM netjuke_artists ar, netjuke_tracks tr, netjuke_labels la, \
                       netjuke_albums al \
                       WHERE tr.la_id=la.id \
                       AND ar.id=tr.ar_id \
                       AND al.id=tr.al_id"
               sql2 += " AND la.id=%s" % labelID
               sql2 += " AND tr.report=0"
               sql2 += " AND ar.exclude = 'f' AND la.exclude = 'f' AND tr.exclude = 'f'"
               #sql2 += " AND tr.enabled = '1'" # enabled = 1 means officially published
	       sql2 += " ORDER BY artist LIMIT %d" % self.GV.config.treeLimit

               cursor2.execute(sql2)
               result2 = cursor2.fetchall()
               for record2 in result2:
                   artistID = record2[0]
                   artist   = uniconvert2(record2[1])
                   info     = uniconvert2(record2[2])
                   img      = record2[3]
                   itemData = { 'type': 'artist', 'id': artistID, 'name':artist, 'info':info, 'img':img }
                   item2    = self.MusicPanel.tab['MusicTree'].AppendItem(item, artist, data = wx.TreeItemData(itemData))

                   self.MusicPanel.tab['MusicTree'].SetItemFont(item2, self.font)
			  
                   cursor3 = db.cursor()
		   # Get albums for this ARTIST
                   sql3 = "/* Get ALBUMS for this ARTIST */ SELECT DISTINCT al.id id, al.name album, \
                               al.comments, al.img_src \
                           FROM netjuke_artists ar, netjuke_albums al, netjuke_tracks tr, \
                           netjuke_labels la \
                           WHERE tr.ar_id=ar.id AND tr.al_id=al.id AND"
                   sql3 += " ar.id=%s" % artistID
                   sql3 += " AND tr.la_id=la.id"
                   sql3 += " AND tr.la_id=%d" % labelID
                   sql3 += " AND tr.report=0"
                   sql3 += " AND ar.exclude = 'f' AND al.exclude = 'f' AND la.exclude = 'f' AND tr.exclude = 'f'"
                   #sql3 += " AND tr.enabled = '1'" # enabled = 1 means officially published
                   sql3 += " ORDER BY album LIMIT %d" % self.GV.config.treeLimit
		     
                   cursor3.execute(sql3)
                   result3 = cursor3.fetchall()
                   for record3 in result3:
                       albumID   = record3[0]
                       album     = uniconvert2(record3[1])
                       info      = uniconvert2(record3[2])
                       img       = record3[3]
                       itemData = { 'type': 'album', 'id': albumID, 'name':album, 'info':info, 'img':img }
                       item3     = self.MusicPanel.tab['MusicTree'].AppendItem(item2, album, data = wx.TreeItemData(itemData))
			      
                       self.MusicPanel.tab['MusicTree'].SetItemFont(item3, self.font)
                       cursor4 = db.cursor()

		       # Get TRACKS for this album
                       sql4 = "/* Get TRACKS for this ALBUM */ \
                               SELECT tr.id trackID, tr.name songname, tr.location location, \
			       concat(nu.nickname, tr.location) newLocation, SEC_TO_TIME(tr.time), \
                               (tr.size / 1024 / 1024) filesize, \
			       tr.comments, tr.img_src, ar.img_src, tr.time \
                               FROM netjuke_artists ar, netjuke_albums al, netjuke_tracks tr, netjuke_users nu, \
			       file_uploader fu \
                               WHERE tr.ar_id=ar.id AND tr.al_id=al.id"
                       sql4 += " AND al.id=%s AND tr.la_id=%s AND ar.id=%s AND tr.report=0" % (albumID, labelID, artistID)
                       sql4 += " AND fu.file=tr.id AND fu.uploader=nu.id"
                       sql4 += " AND ar.exclude = 'f' AND al.exclude = 'f' AND tr.exclude = 'f'"
                       sql4 += " AND tr.license > 0"
                       #sql4 += " AND tr.enabled = '1'" # enabled = 1 means officially published
                       sql4 += " ORDER BY tr.track_number, songname LIMIT %d" % (self.GV.config.treeLimit)

                       cursor4.execute(sql4)
                       result4 = cursor4.fetchall()
                       for record4 in result4:
                           songID      = record4[0]
                           song        = uniconvert2(record4[1])
                           location    = record4[2]
                           newLocation = record4[3]
                           length      = record4[4]
                           size        = '%4.2f' % float(record4[5])
                           info        = record4[6]
                           imgTr       = ValidateImage(record4[7], 'tr')
                           imgAl       = ValidateImage(record4[8], 'al')
                           length2     = record4[9]
                           if imgTr == '': img = imgAl
                           else: img = imgTr

                           img         = record4[7]

                           itemData    = {'type':'song', 'id':songID, 'name':song, 'location':location, 'newLocation':newLocation, 'length':length, 'length2':length2, 'size':float(size), 'info':info, 'img':img, 'label':label, 'artist':artist, 'album':album }
                           item4       = self.MusicPanel.tab['MusicTree'].AppendItem(item3, song, data = wx.TreeItemData(itemData))

                           self.MusicPanel.tab['MusicTree'].SetItemFont(item4, self.font)
	   
	   if self.MusicPanel.tab['MusicTree'].GetCount() is 0:
              itemData = { 'type': None }
              item = self.MusicPanel.tab['MusicTree'].AppendItem(root, 'No results found, try again later', data = wx.TreeItemData(itemData))
	   self.GV.SetTreeType('music')

        db.close()

        #--------------------------------------------------------------------------------------

        self.MusicPanel.tab['MusicTree'].SetItemFont(item3, self.font)
	
	# Default item
	rootItem = self.MusicPanel.tab['MusicTree'].GetRootItem()
	(firstChild, cookie) = self.MusicPanel.tab['MusicTree'].GetFirstChild(root)
	self.treeItem = firstChild
	rootItem = self.MusicPanel.tab['MusicTree'].GetRootItem()
        self.MusicPanel.tab['MusicTree'].SelectItem(rootItem)
	cookie = 0
	(defaultItem, cookie) = self.MusicPanel.tab['MusicTree'].GetFirstChild(rootItem)
	self.treeItemParent = None
	self.treeItemGParent = None
	self.treeItemGGParent = None
	self.treeItemParentLast = None
	self.treeItemGParentLast = None
	self.treeItemGGParentLast = None
        logger.info("OK! Finished building MusicTree!")
        self.MusicPanel.tab['MusicTree'].Bind(wx.EVT_LEFT_DCLICK, self.OnLeftDClick)

    #---------------------------------------------
    def OnLeftDClick(self, evt):
        self.EvtJoyRight(self)

    #--------------------------------------------------------------------------------------
    # build reports tree
    #--------------------------------------------------------------------------------------
    
    def BuildReportsTree(self, searchString='', searchType='ReportLabel'):
        logger.debug("Building ReportsTree ...  (using search string: '%s' and search type: '%s')" % (searchString, searchType))
        
        self.MusicPanel.tab['ReportsTree'].DeleteAllItems()
	
        root = self.MusicPanel.tab['ReportsTree'].AddRoot("ReportsTreeRoot")
        
        db = DB.connect()
        cursor = db.cursor()

	#------------------------------------------------------------------------------------#
	#                                  Audio Reports                                     #
	#------------------------------------------------------------------------------------#

        #-------------------------------------------------
        # Get Report Labels list
        #-------------------------------------------------
	#if searchType == 'ReportLabel':
	if searchType == 'ReportLabelOFF':
           sql = "SELECT DISTINCT ar.id, ar.name FROM netjuke_artists ar, netjuke_tracks tr"
           sql += " WHERE ar.name LIKE '%"
           sql += "%s" % searchString
           sql += "%'"
           sql += " AND ar.id=tr.ar_id AND tr.report=1 AND tr.lg_id in (%s)" % (self.GV.lang)
	   sql += " ORDER BY ar.name LIMIT %s" % self.GV.config.treeLimit
	
           cursor.execute(sql)
           result = cursor.fetchall()
           for record in result:
               artistID = record[0]
               artis = record[1]
               artist = uniconvert2(artis)
               artistData = [searchType, artistID]
               item = self.MusicPanel.tab['ReportsTree'].AppendItem(root, artist, data = wx.TreeItemData(artistData))

               self.MusicPanel.tab['ReportsTree'].SetItemFont(item, self.font)

               cursor2 = db.cursor()
               # Get albums for this ARTIST
               sql2 = "SELECT DISTINCT al.id id, al.name album \
                       FROM netjuke_artists ar, netjuke_albums al, netjuke_tracks tr, \
                       netjuke_genres ge \
                       WHERE tr.ar_id=ar.id AND tr.al_id=al.id AND"
               sql2 += " ar.id=%s" % artistID
               sql2 += " AND tr.ge_id=ge.id"
               sql2 += " ORDER BY album LIMIT %d" % self.GV.config.treeLimit
               
               logger.debug(logmsg)
               cursor2.execute(sql2)
               result2 = cursor2.fetchall()
               for record2 in result2:
                   albumID = record2[0]
                   albu = record2[1]
                   album = uniconvert2(albu)
                   albumData = ['ReportTopic', albumID]
                   item2 = self.MusicPanel.tab['ReportsTree'].AppendItem(item, album, data = wx.TreeItemData(albumData))
			  

                   self.MusicPanel.tab['ReportsTree'].SetItemFont(item2, self.font)

                   cursor3 = db.cursor()
                   # Get TRACKS for this album
                   sql3 = "SELECT tr.id songId, tr.name songname, tr.location location \
                          FROM netjuke_artists ar, netjuke_albums al, netjuke_tracks tr, langlist \
                          WHERE tr.ar_id=ar.id AND tr.al_id=al.id AND al.id='%s' AND ar.id='%s' \
			  AND tr.lg_id=langlist.id" % (albumID, artistID)
                   sql3 += " AND ar.id=tr.ar_id AND tr.report=1 AND tr.lg_id in (%s)" % (self.GV.lang)
		   sql3 += " ORDER BY songname LIMIT %d" % self.GV.config.treeLimit
			  
                   cursor3.execute(sql3)
                   result3 = cursor3.fetchall()
                   for record3 in result3:
                        songID = record3[0]
                        son = record3[1]
                        song = uniconvert2(son)
                        songLocation = record3[2]
                        songData = ['report', songID, songLocation]
                        item3 = self.MusicPanel.tab['ReportsTree'].AppendItem(item2, song, data = wx.TreeItemData(songData))
	
                        self.MusicPanel.tab['ReportsTree'].SetItemFont(item3, self.font)
	
        #-------------------------------------------------
        # Get Report Topic list
        #-------------------------------------------------
	if searchType == 'ReportTopic':
           sql = "/* search ReportTopic */ SELECT DISTINCT al.id, al.name FROM netjuke_albums al, netjuke_tracks tr"
           sql += " WHERE al.name LIKE '%"
           sql += "%s" % searchString
           sql += "%'"
           sql += " AND al.id=tr.al_id AND tr.report=1 AND tr.lg_id in (%s)" % (self.GV.lang)
	   sql += " ORDER BY al.name LIMIT %s" % self.GV.config.treeLimit
	
           #logmsg = "SQL = " + sql
           logger.debug(logmsg)
           cursor.execute(sql)
           result = cursor.fetchall()
           for record in result:
               topicID = record[0]
               topi = record[1]
               topic = uniconvert2(topi)
               topicData = [searchType, topicID]
               item = self.MusicPanel.tab['ReportsTree'].AppendItem(root, topic, data = wx.TreeItemData(topicData))

               self.MusicPanel.tab['ReportsTree'].SetItemFont(item, self.font)

               cursor2 = db.cursor()
               # Get TRACKS for this TOPIC
               sql2 = "SELECT tr.id songId, tr.name songname, tr.location location \
                      FROM netjuke_artists ar, netjuke_albums al, netjuke_tracks tr, langlist \
                      WHERE tr.ar_id=ar.id AND tr.al_id=al.id AND al.id='%s' \
                      AND tr.lg_id=langlist.id" % (topicID)
               sql2 += " AND ar.id=tr.ar_id AND tr.report=1 AND tr.lg_id in (%s)" % (self.GV.lang)
               sql2 += " ORDER BY songname LIMIT %d" % self.GV.config.treeLimit
			  
               cursor2.execute(sql2)
               result2 = cursor2.fetchall()
               for record2 in result2:
                    songID = record2[0]
                    son = record2[1]
                    song = uniconvert2(son)
                    songLocation = record2[2]
                    songData = ['report', songID, songLocation]
                    item2 = self.MusicPanel.tab['ReportsTree'].AppendItem(item, song, data = wx.TreeItemData(songData))

	if self.MusicPanel.tab['ReportsTree'].GetCount() == 0:
            songData = [searchType, 1, 1]
            item2 = self.MusicPanel.tab['ReportsTree'].AppendItem(root, 'No results found, try again later', data = wx.TreeItemData(songData))
        else:
            logmsg = "reports count was not cero but: %d" % self.MusicPanel.tab['ReportsTree'].GetCount()
            logger.debug(logmsg)
	       
	self.GV.SetTreeType('reports')
	# End if
	
        db.close()

        self.MusicPanel.tab['ReportsTree'].SetItemFont(item2, self.font)
	
	# Default item
	rootItem = self.MusicPanel.tab['ReportsTree'].GetRootItem()
	(firstChild, cookie) = self.MusicPanel.tab['ReportsTree'].GetFirstChild(rootItem)
	self.MusicPanel.tab['ReportsTree'].Item = firstChild
	cookie = 0
	(defaultItem, cookie) = self.MusicPanel.tab['ReportsTree'].GetFirstChild(rootItem)
	self.MusicPanel.tab['ReportsTree'].ItemParent = None
	self.MusicPanel.tab['ReportsTree'].ItemGParent = None
	self.MusicPanel.tab['ReportsTree'].ItemGGParent = None
	self.MusicPanel.tab['ReportsTree'].ItemParentLast = None
	self.MusicPanel.tab['ReportsTree'].ItemGParentLast = None
	self.MusicPanel.tab['ReportsTree'].ItemGGParentLast = None
        logger.info("OK! Finished building ReportsTree!")

    #---------------------------------------------
    def ClearMusicTree(self):
        self.MusicPanel.tab['MusicTree'].DeleteAllItems()

    #---------------------------------------------
    def ClearReportsTree(self):
        self.MusicPanel.tab['ReportsTree'].DeleteAllItems()
    
    #---------------------------------------------
    def OnTestFunc(self, evt):
        for lang in self.GV.lang:
            logmsg = "on OnTestFunc() lang: %s" %lang
            logger.debug(logmsg)

    #---------------------------------------------
    def NowBurningDialog(self, title, message):
	self.NowBurningBox = wx.Frame(None, -1, title, pos=(500,300), size=(300,100),
				style=wx.DEFAULT_FRAME_STYLE
				| wx.STAY_ON_TOP
				)
	self.burnInfo = wx.StaticText(self.NowBurningBox, -1, message, wx.Point(580, 2))
        self.NowBurningBox.Show(True)
	self.BurnNow()
	
    #---------------------------------------------
    def BurnMenuL(self):
        logmsg = "BurnMenuL() called"
        logger.debug(logmsg)
        posicion = self.burn_rb.GetSelection()
	if posicion == 0:
	    logmsg = "WARN: not possible to move further left"
            logger.warn(logmsg)
	else:
	    newPos = posicion - 1
	    if newPos == 0:
                self.burnType = 'audio'
            if newPos == 1:
                self.burnType = 'data'
        self.burn_rb.SetSelection(newPos)
	logmsg = "self.burnType set to: %s" % self.burnType
	logger.debug(logmsg)
    
    #---------------------------------------------
    def BurnMenuSwitch(self):
        logmsg = "BurnMenuSwitch() called"
        logger.debug(logmsg)
        posicion = self.BurnMenu.burn_rb.GetSelection()
	if posicion == 1:
	    newPos = 0
	elif posicion == 0:
	    newPos = 1
	    
	if newPos == 0:
            self.BurnMenu.burnType = 'audio'
        if newPos == 1:
            self.BurnMenu.burnType = 'data'

        self.BurnMenu.burn_rb.SetSelection(newPos)
	logmsg = "self.BurnMenu.burnType set to: %s" % self.BurnMenu.burnType
	logger.debug(logmsg)
	
    #---------------------------------------------
    def burnMenu(self, evt):
        if self.FocusManager.WhoIsFocused() is 'BurnResultBox':
            logmsg = 'BurnResultBox has focus, not popping up burnMenu..'
            logger.info(logmsg)
	    return

        def close():
            #print "closing burnmenu"
            pass

        logmsg_info = "self.playlistCount = %s" % self.Playlist.count
        logger.info(logmsg_info)
        if self.Playlist.count > 0:
            if self.FocusManager.WhoIsFocused() is not 'BurnMenu':
                logmsg_info = "---- in burnMenu() self.Playlist.AudioOversized = %s" % self.Playlist.AudioOversized
                logger.info(logmsg_info)
		if self.Playlist.AudioOversized is not True:
                    logmsg_info = "---- in burnMenu() entering PopBurn ALL !!!!!!!"
                    logger.info(logmsg_info)
		    self.BurnMenu = PopBurn(self, 'all', self.playlistID, self.FocusManager)
		    self.BurnMenu.Show()
		    self.BurnMenu.w.SetFocus()
                    self.GV.HadFocus = self.FocusManager.WhoIsFocused()
                    self.FocusManager.Register("BurnMenu", self.BurnMenu)
                    self.FocusManager.SetFocus("BurnMenu")
		elif not self.Playlist.DataOversized:
		    self.BurnMenu = PopBurn(self, 'data', self.playlistID, self.FocusManager)
		    self.BurnMenu.Show()
		    self.BurnMenu.w.SetFocus()
                    self.GV.HadFocus = self.FocusManager.WhoIsFocused()
		else:
		    if self.FocusManager.WhoIsFocused() is not 'BurnResultBox':
                        logmsg = "self.WarnOversized(evt=None) should popup"
                        logger.debug(logmsg)
                        oversized_txt = "Your playlist is totally oversized,"
                        oversized_txt += "\nso you must remove some contents"
                        oversized_txt += "\nbefore you can burn"
                        oversized_txt += "\n"
                        oversized_txt += "\n%s" % config.doClose
                        Msg.Msg('ERROR', oversized_txt, 'BurnResultBox', 300, 100, 0)
            else:
                logmsg_info = "burnMenu() is already open, ignoring.."
                logger.info(logmsg_info)
        else:
	    if self.FocusManager.WhoIsFocused() is not 'BurnResultBox':
                log = "ERROR at burnMenu(): no items in playlist, warning user.."
                logger.info(log)
                txt = 'You must add something to your playlist'
                txt += '\nbefore burning!'
                txt += '\n'
                log = "burnMenu() has focus: %s" % self.FocusManager.WhoIsFocused()
                logger.debug(log)
                self.GV.Msg = Msg.Msg('ERROR', txt, 'BurnResultBox', 400, 200, 0)
            else:
                log = "PopUp already open not popping up again (HasFocus: %s)" % self.FocusManager.WhoIsFocused()
                logger.info(log)
    
    #---------------------------------------------
    def burnMenuAll(self, evt):
            logmsg_info = "burnMenuAll() called"
            logger.info(logmsg_info)
            self.GV.HadFocus = self.GV.HasFocus
            self.GV.HasFocus = 'BurnMenu'
            self.burnMenuIsOpen = True

            self.burnType = 'audio'

	    self.popFrame = wx.Frame(None, -1, "Select CD burn type", size=(300,150),
				style=wx.DEFAULT_FRAME_STYLE)
	    self.BurnMenuAllWin = wx.Window(self.popFrame, -1, size=(300, 150), style=wx.WANTS_CHARS)
	
            RBUT1 = wx.NewId()
            RBUT2 = wx.NewId()
            RBOX2 = wx.NewId()

            sizer = wx.BoxSizer(wx.VERTICAL)
	
            burnTypes = ['audio', 'data']
            
	    burnTypeHelpTxt = 'Choose the type of CD you prefer'
            burnTypeHelpTxt += '\nGreen SWITCH button changes option'
	    burnTypeHelp = wx.StaticText(self.burnpanel, -1, burnTypeHelpTxt, wx.Point(20, 10))
            
	    self.burn_rb = wx.RadioBox(self.burnpanel, RBOX2, "", wx.Point(80, 40), wx.DefaultSize,
                            burnTypes, 2, wx.RA_SPECIFY_COLS | wx.NO_BORDER)
            
	    burnTypeHelpTxt2 = '\n%s' % config.doBurn
            burnTypeHelpTxt2 += '  %s' % config.doCancel
	    burnTypeHelp2 = wx.StaticText(self.burnpanel, -1, burnTypeHelpTxt2, wx.Point(20, 80))
        

            def EvtRadioBox(event):
                BoxID = event.GetInt()
                if BoxID == 0:
                    self.burnType = 'audio'
                if BoxID == 1:
                    self.burnType = 'data'
                logmsg = "at burnMenu() -> %s mode <- was chosen" % self.burnType
                logger.debug(logmsg)
	    
            sizer.Add(self.burn_rb, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM, 30)
            self.burnpanel.Bind(wx.EVT_RADIOBOX, EvtRadioBox, self.burn_rb)
        
            self.BurnMenuAllWin.Show(True)
            self.BurnMenuAllWin.Enable(True)
        
            if self.burnType == '':
               self.burnType = 'audio'
            else:
               self.burnType = 'data'
	
	    self.popFrame.Show(True)
            self.popFrame.Centre(wx.BOTH)
            logmsg = 'burnMenu() burnType = %s' % self.burnType
            logger.debug(logmsg)
            self.BurnMenuAllWin.SetFocus()
            #self.burnpanel.InitDialog()
            wx.FutureCall(50, self.ShowFocus)

    #---------------------------------------------
    def burnMenuData(self, evt):
            self.GV.HadFocus = self.GV.HasFocus
            self.GV.HasFocus = 'BurnMenu'
            self.burnMenuIsOpen = True

            self.playlistAQuemar = ''
            self.burnType = 'data'

            self.BurnTypeWin = wx.Dialog(None, -1, "Burn Type",
                                         size=(300, 150), style=wx.DEFAULT_DIALOG_STYLE)
	
            sizer = wx.BoxSizer(wx.VERTICAL)
	
	    burnTypeHelpTxt = 'Your playlist is too big to burn as AUDIO'
            burnTypeHelpTxt += '\nYou have no other choice to burn as DATA'
            burnTypeHelpTxt += '\nor CANCEL to make your playlist smaller'
	    burnTypeHelp = wx.StaticText(self.BurnTypeWin, -1, burnTypeHelpTxt, wx.Point(20, 10))
            
	    burnTypeHelpTxt2 = '\n%s' % config.doBurn
            burnTypeHelpTxt2 += '  %s' % config.doCancel
	    burnTypeHelp2 = wx.StaticText(self.BurnTypeWin, -1, burnTypeHelpTxt2, wx.Point(20, 80))
        

            def OnCloseMe(event):
                self.BurnTypeWin.Destroy()

            self.playlistAQuemar = timestamp = datetime.datetime.now().strftime("%Y%m%d%H%M%S")
            self.BurnTypeWin.Centre(wx.BOTH)
            self.BurnTypeWin.ShowModal()
            self.burnMenuIsOpen = False
        
            logmsg = 'burnMenuData() burnType = %s' % self.burnType
            logger.debug(logmsg)
            logmsg = 'self.playlistAQuemar = %s' % self.playlistAQuemar
            logger.debug(logmsg)

    #---------------------------------------------
    def DBSearchL(self):
        posicion = search_rb.GetSelection()
	if posicion == 0:
	    logmsg = "not possible to move further left"
            logger.warn(logmsg)
	else:
	    newPos = posicion - 1
	
	if newPos == 0:
	    self.categoria = 'label'
        if newPos == 1:
	    self.categoria = 'artist'

        search_rb.SetSelection(newPos)
    
    #---------------------------------------------
    def DBSearchR(self):
        posicion = search_rb.GetSelection()
	if posicion == 2:
	    logmsg = "WARN: not possible to move further right"
            logger.warn(logmsg)
	else:
	    newPos = posicion + 1
        
	if newPos == 1:
	    self.categoria = 'artist'
        if newPos == 2:
	    self.categoria = 'genre'

        search_rb.SetSelection(newPos)
	
    #---------------------------------------------
    def DBSearch(self, evt):
        global search_rb
        HadFocus = self.GV.HasFocus
        self.GV.HasFocus = 'DBSearch'
	searchString = ''
	self.categoria = ''
        dlg = wx.TextEntryDialog(self, '', 'Search', '')
        RBUT1 = wx.NewId()
        RBUT2 = wx.NewId()
        RBUT3 = wx.NewId()

        RBOX2 = wx.NewId()

        sizer = wx.BoxSizer(wx.VERTICAL)

        if HadFocus is 'MusicTree':
            sampleList = ['Label', 'Artist', 'Genre']
            option0 = 'label'
            option1 = 'artist'
            option2 = 'genre'
        elif HadFocus is 'ReportsTree':
            sampleList = ['Label', 'Topic', 'Disabled']
            option0 = 'ReportLabel'
            option1 = 'ReportTopic'
            option2 = 'disabled'
	
        search_rb = wx.RadioBox(dlg, RBOX2, "", wx.Point(0, -10), wx.DefaultSize,
                        sampleList, 3, wx.RA_SPECIFY_COLS | wx.NO_BORDER)

	def EvtRadioBox(event):
	    BoxID = event.GetInt()
            if BoxID == 0:
		self.categoria = option0
            if BoxID == 1:
		self.categoria = option1
            if BoxID == 2:
		self.categoria = option2
	    
	dlg.Bind(wx.EVT_RADIOBOX, EvtRadioBox, search_rb)
        sizer.Add(search_rb, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM, 10)
        
	if dlg.ShowModal() == wx.ID_OK:
            searchString = dlg.GetValue()
        dlg.Destroy()

	if self.categoria == '':
	    self.categoria = option0
	    
	if searchString != '' and HadFocus is 'MusicTree':
            self.BuildMusicTree(searchString, self.categoria)
	elif searchString != '' and HadFocus is 'ReportsTree':
            self.BuildReportsTree(searchString, self.categoria)
	else:
	    wx.LogMessage("Cancelado ! No buscamos...")
        
	# return focus to window/panel/tree who dispatched it to this function
	self.GV.HasFocus = HadFocus
	
    #---------------------------------------------
    def htmlPageUp(self, event):
        self.htmlReachedBottom = False
        if not self.htmlReachedTop:
            self.htmlPage = self.htmlPage - 1
            anchorname = "page%s" % self.htmlPage
            logmsg = "scrolling to anchor: %s" % anchorname
            logger.debug(logmsg)
            self.Infopanel.html.ScrollToAnchor(anchorname)
            if not self.Infopanel.html.ScrollToAnchor(anchorname):
                logmsg = "html page up NOT OK, adding 1 to htmlPage"
                logger.debug(logmsg)
                self.htmlReachedTop = True
                self.htmlPage = self.htmlPage + 1
    
    #---------------------------------------------
    def htmlPageDown(self, event):
        self.htmlReachedTop = False
        if not self.htmlReachedBottom:
            self.htmlPage = self.htmlPage + 1
            anchorname = "page%s" % self.htmlPage
            logmsg = "scrolling to anchor: %s" % anchorname
            logger.debug(logmsg)
            if not self.Infopanel.html.ScrollToAnchor(anchorname):
                logmsg = "html page down NOT OK, substracting 1 to htmlPage"
                logger.debug(logmsg)
                self.htmlReachedBottom = True
                self.htmlPage = self.htmlPage - 1
    
    #---------------------------------------------
    def OnResetTrees(self, event=None):
        logger.info("resetting trees... Wait!")

        self.BuildMusicTree()

	self.MusicPanel.tab['MusicTree'].SetFocus()

    #---------------------------------------------
    def OnTreeLeftDown(self, event):
        logmsg = "OnTreeLeftDown() event ocurred"
        logger.debug(logmsg)
	
	if self.FocusManager.WhoIsFocused() is 'MusicTree':
            pt = event.GetPosition();
            item, flags = self.MusicPanel.tab['MusicTree'].HitTest(pt)
            if item == self.MusicPanel.tab['MusicTree'].GetSelection():
                #itemInfo = self.getArtistInfo(self.MusicPanel.MusicTree.GetItemText(item));
		logmsg = "getArtistInfo DISABLED"
                logger.debug(logmsg)
            event.Skip()
        elif self.FocusManager.WhoIsFocused() is 'ReportsTree':
            pt = event.GetPosition();
            item, flags = self.MusicPanel.tab['ReportsTree'].HitTest(pt)
            if item == self.MusicPanel.tab['ReportsTree'].GetSelection():
                #itemInfo = self.getArtistInfo(self.MusicPanel.tab['ReportsTree'].GetItemText(item));
		logmsg = "getArtistInfo DISABLED"
                logger.debug(logmsg)
            event.Skip()

    #---------------------------------------------
    def OnSelChangedMusicTree(self, event):
        if self.dying:
            return
        
        logger.debug("OnSelChangedMusicTree() ocurred")
        #FocusManager.manager.SetFocus('MusicTree')

        self.MusicPanel.OnFocusMusicTree(event=None) # keep focus on MusicTree
	item = event.GetItem()
	#self.MusicPanel.tab['MusicTree'].SetItemBold(item)
        #self.MusicPanel.tab['MusicTree'].SetItemFont(item, self.fontSelected)
        #self.MusicPanel.tab['MusicTree'].SetItemBackgroundColour(item, wx.Colour(15, 100, 100))
        #self.MusicPanel.tab['MusicTree'].SetItemTextColour(item, config.fontSelectedFG)
        #self.MusicPanel.tab['MusicTree'].SetItemBackgroundColour(item, config.fontSelectedBG)
        itemText = self.MusicPanel.tab['MusicTree'].GetItemText(item)
        #itemData = self.MusicPanel.tab['MusicTree'].RetPyData(item)
        itemData = self.MusicPanel.GetItemData('MusicTree', item)
	itemType = itemData['type']

	itemParent = self.MusicPanel.tab['MusicTree'].GetItemParent(item)
	itemParentTxt = self.MusicPanel.tab['MusicTree'].GetItemText(itemParent)
	cookie = 0
	(self.itemFirstBro, cookie) = self.MusicPanel.tab['MusicTree'].GetFirstChild(itemParent)

	logmsg = "itemType en OnSelChangedMusicTree() is: %s" % itemType
	logger.debug(logmsg)

	self.Infopanel.LoadPage(itemData, self.login.NewPlaylistID)

	#wx.LogMessage("Seleccion: %s"  % itemText + " cargando desde la base de datos ...")
	#itemInfo = self.getArtistInfo(itemText)
	
        self.itemData = itemData

        self.treeItemGParent = None
        self.treeItemGParentLast = None
        self.treeItemGGParent = None
        self.treeItemGGParentLast = None
	
	self.treeItem = item
	self.treeItemParent = self.MusicPanel.tab['MusicTree'].GetItemParent(item)
	logmsg = "in OnSelChangedMusicTree() itemParent is: %s" % self.MusicPanel.tab['MusicTree'].GetItemText(self.treeItemParent)
	logger.debug(logmsg)
	self.treeItemParentLast = self.MusicPanel.tab['MusicTree'].GetLastChild(self.treeItemParent)
        self.rootItem = self.MusicPanel.tab['MusicTree'].GetRootItem()
	if self.treeItemParent != self.rootItem:
            self.treeItemGParent = self.MusicPanel.tab['MusicTree'].GetItemParent(self.treeItemParent)
            self.treeItemGParentLast = self.MusicPanel.tab['MusicTree'].GetLastChild(self.treeItemGParent)
	    if self.treeItemGParent != self.rootItem:
                self.treeItemGGParent = self.MusicPanel.tab['MusicTree'].GetItemParent(self.treeItemGParent)
		if (self.treeItemGGParent != self.rootItem):
                    self.treeItemGGParentLast = self.MusicPanel.tab['MusicTree'].GetLastChild(self.treeItemGGParent)
        self.MusicPanel.OnFocusMusicTree(event)
    
    #---------------------------------------------
    def OnSelChangedReportsTree(self, event):
        if self.dying:
            return

        #FocusManager.manager.SetFocus('ReportsTree')
        
	self.htmlPage = 0
        self.htmlReachedBottom = False
        self.htmlReachedTop = False
	logmsg = "OnSelChangedReportsTree() ocurred"
        logger.debug(logmsg)
        self.MusicPanel.OnFocusReportsTree(event=None) # keep focus on ReportsTree
	item = event.GetItem()
        #self.MusicPanel.tab['ReportsTree'].SetItemFont(item, self.fontSelected)
        itemText = self.MusicPanel.tab['ReportsTree'].GetItemText(item)
	logmsg = "Report ItemText: %s" % itemText
        logger.debug(logmsg)
	itemData = RetPyData(item, self.FocusManager.WhoIsFocused())
	itemType = itemData[0]

	itemParent = self.MusicPanel.tab['ReportsTree'].GetItemParent(item)
	itemParentTxt = self.MusicPanel.tab['ReportsTree'].GetItemText(itemParent)
	cookie = 0
	(self.MusicPanel.tab['ReportsTree'].ItemFirstBro, cookie) = self.MusicPanel.tab['ReportsTree'].GetFirstChild(itemParent)

	logmsg = "itemType en OnSelChangedReportsTree() is: %s" % itemType
	logger.debug(logmsg)

	if itemType is 'song':
	     #artistInfo = self.getArtistInfo(itemData[1])
	     queryString = '?id=%s&type=song&playlist=%s&reportsTreeSONG' % \
			    (itemData[1], self.login.NewPlaylistID)
             infoPage = self.GV.config.webUrl + '/infopanel.php' + queryString
             
	     # set track info into self making it available for the rest of events
	     self.track = itemText
	     self.trackID = itemData[1]
	     self.trackLocation = itemData[2]
        elif itemType is 'report':
	     #artistInfo = self.getArtistInfo(itemData[1])
	     queryString = '?id=%s&type=report&playlist=%s&reportsTreeREPORT' % \
			    (itemData[1], self.login.NewPlaylistID)
             infoPage = self.GV.config.webUrl + '/infopanel.php' + queryString
             
	     # set track info into self making it available for the rest of events
	     self.track = itemText
	     self.trackID = itemData[1]
	     self.trackLocation = itemData[2]
        else:
            infoPage = self.GV.config.webUrl + '/infopanel.php?id=%d&type=%s&reportsTreeELSE' % (itemData[1], itemType)
             
	self.Infopanel.LoadPage(infoPage, self.login.NewPlaylistID)
	self.MusicPanel.SetSelection(MusicPanel.Reports)
        self.MusicPanel.OnFocusReportsTree(event)

	wx.LogMessage("Seleccion: %s"  % itemText + " cargando desde la base de datos ...")
	#itemInfo = self.getArtistInfo(itemText)
	
        self.MusicPanel.tab['ReportsTree'].ItemGParent = None
        self.MusicPanel.tab['ReportsTree'].ItemGParentLast = None
        self.MusicPanel.tab['ReportsTree'].ItemGGParent = None
        self.MusicPanel.tab['ReportsTree'].ItemGGParentLast = None
	
	self.MusicPanel.tab['ReportsTree'].Item = item
	logmsg = "in OnSelChangedReportsTree() item is: %s" % self.MusicPanel.tab['ReportsTree'].GetItemText(self.MusicPanel.tab['ReportsTree'].Item)
	logger.debug(logmsg)

	self.MusicPanel.tab['ReportsTree'].ItemParent = self.MusicPanel.tab['ReportsTree'].GetItemParent(item)
	logmsg = "in OnSelChangedReportsTree() itemParent is: %s" % self.MusicPanel.tab['ReportsTree'].GetItemText(self.MusicPanel.tab['ReportsTree'].ItemParent)
	logger.debug(logmsg)
	self.MusicPanel.tab['ReportsTree'].ItemParentLast = self.MusicPanel.tab['ReportsTree'].GetLastChild(self.MusicPanel.tab['ReportsTree'].ItemParent)
        self.MusicPanel.tab['ReportsTree'].rootItem = self.MusicPanel.tab['ReportsTree'].GetRootItem()
	if self.MusicPanel.tab['ReportsTree'].ItemParent != self.MusicPanel.tab['ReportsTree'].rootItem:
            self.MusicPanel.tab['ReportsTree'].ItemGParent = self.MusicPanel.tab['ReportsTree'].GetItemParent(self.MusicPanel.tab['ReportsTree'].ItemParent)
            self.MusicPanel.tab['ReportsTree'].ItemGParentLast = self.MusicPanel.tab['ReportsTree'].GetLastChild(self.MusicPanel.tab['ReportsTree'].ItemGParent)
	    if self.MusicPanel.tab['ReportsTree'].ItemGParent != self.MusicPanel.tab['ReportsTree'].rootItem:
                self.MusicPanel.tab['ReportsTree'].ItemGGParent = self.MusicPanel.tab['ReportsTree'].GetItemParent(self.MusicPanel.tab['ReportsTree'].ItemGParent)
		if (self.MusicPanel.tab['ReportsTree'].ItemGGParent != self.MusicPanel.tab['ReportsTree'].rootItem):
                    self.MusicPanel.tab['ReportsTree'].ItemGGParentLast = self.MusicPanel.tab['ReportsTree'].GetLastChild(self.MusicPanel.tab['ReportsTree'].ItemGGParent)

    #---------------------------------------------
    def mainTreeNextItem(self, event):
        logmsg = "mainTreeNextItem() called"
        logger.debug(logmsg)
        itemData = RetPyData(self.treeItem, self.FocusManager.WhoIsFocused())
        itemType = itemData[0]
        CollapseList = []

	item = None # the new one

	logmsg = "---------------------------------------------------------------"
        logger.debug(logmsg)
        treeItemText = self.MusicPanel.MusicTree.GetItemText(self.treeItem)
        logmsg = "treeItem: %s" % treeItemText
        logger.debug(logmsg)
	
	if self.treeItemParent is not None:
	    itemParentText = self.MusicPanel.MusicTree.GetItemText(self.treeItemParent)
            logmsg = "itemParent: %s" % itemParentText
            logger.debug(logmsg)

	if self.treeItemGParent is not None:
		treeItemParentLastText = self.MusicPanel.MusicTree.GetItemText(self.treeItemParentLast)
		logmsg = "treeItemParentLast: %s" % treeItemParentLastText
                logger.debug(logmsg)
	
	if self.treeItemGParentLast is not None:
		treeItemGParentLastText = self.MusicPanel.MusicTree.GetItemText(self.treeItemGParentLast)
		logmsg = "treeItemGParentLast: %s" % treeItemGParentLastText
                logger.debug(logmsg)

	logmsg = "---------------------------------------------------------------"
        logger.debug(logmsg)
	logmsg = "itemType: %s" % itemType
        logger.debug(logmsg)
	logmsg = "---------------------------------------------------------------"
        logger.debug(logmsg)
	
	if self.MusicPanel.MusicTree.IsExpanded(self.treeItem) \
	and (itemType != 'song' and itemType != 'report'):
            logmsg = "item is not song nor report, and is expanded, descending to first child"
            logger.debug(logmsg)
            cookie = 0
            (item, cookie) = self.MusicPanel.MusicTree.GetFirstChild(self.treeItem)
	elif (not self.MusicPanel.MusicTree.IsExpanded(self.treeItem)) \
	and (itemType != 'song' and itemType != 'report'):
            logmsg = "not expanded, seeking next brother or uncle"
            logger.debug(logmsg)
	    if self.treeItem == self.treeItemParentLast:
                logmsg = "last son and brother, jumping to GParent bro"
                logger.debug(logmsg)
		item = self.MusicPanel.MusicTree.GetNextSibling(self.treeItemParent)
                if not item:
		    logmsg = "itemParent has no bro"
		    logger.debug(logmsg)
		    logmsg = "seeking itemGParent bro"
		    logger.debug(logmsg)
                    item = self.MusicPanel.MusicTree.GetNextSibling(self.treeItemGParent)
		    if item is not None:
                         logmsg = "not collapsing yet"
                         logger.debug(logmsg)
                         CollapseList = ['treeItemParent', 'treeItemGParent']
		else:
                     logmsg = "not collapsing yet"
                     logger.debug(logmsg)
		     CollapseList = ['treeItemParent']
            else:
                logmsg = "not last, jumping to next bro"
                logger.debug(logmsg)
                item = self.MusicPanel.MusicTree.GetNextSibling(self.treeItem)
        else:
	    logmsg = "is track, seeking brothers"
	    logger.debug(logmsg)
	    if self.treeItem == self.treeItemParentLast:
		logmsg = "is last track, so next whould be:"
		logger.debug(logmsg)
		if self.treeItemParent == self.treeItemGParentLast:
		    logmsg = "itemParent is the last one, looking for GParent bro"
		    logger.debug(logmsg)
		    item = self.MusicPanel.MusicTree.GetNextSibling(self.treeItemGParent)
                    CollapseList = ['treeItemParent', 'treeItemGParent']
		    if not item.IsOk():
			logmsg = "GParent has no bro, is the last one?"
			logger.debug(logmsg)
			logmsg = "so, jumping to next GGParent's bro.. trying"
			logger.debug(logmsg)
			item = self.MusicPanel.MusicTree.GetNextSibling(self.treeItemGGParent)
                        CollapseList = ['treeItemParent', 'treeItemGParent', 'treeItemGGParent']
		else:
		    logmsg = "itemparent is not last is not GParent's last"
		    logger.debug(logmsg)
		    logmsg = "so, getting item's Parent bro"
		    logger.debug(logmsg)
                    item = self.MusicPanel.MusicTree.GetNextSibling(self.treeItemParent)
                    CollapseList = ['treeItemParent']
            else:
                item = self.MusicPanel.MusicTree.GetNextSibling(self.treeItem)
	
	# after all, select the next item and collapse parents as of CollapseList
	if item.IsOk():
	    for CollapseMe in CollapseList:
                if CollapseMe is 'treeItemParent':
                    self.MusicPanel.MusicTree.Collapse(self.treeItemParent)
                if CollapseMe is 'treeItemGParent':
                    self.MusicPanel.MusicTree.Collapse(self.treeItemGParent)
                if CollapseMe is 'treeItemGGParent':
                    self.MusicPanel.MusicTree.Collapse(self.treeItemGGParent)
	    self.MusicPanel.MusicTree.SelectItem(item)
	    logmsg = "selected: %s" % self.MusicPanel.MusicTree.GetItemText(self.MusicPanel.MusicTree.GetSelection())
	    logger.debug(logmsg)
            logmsg = "last: %s" % self.MusicPanel.MusicTree.GetItemText(self.treeItemParentLast)
            logger.debug(logmsg)
	else:
	    logmsg = "could not get next item, not selecting"
            logger.warn(logmsg)
	
    #---------------------------------------------
    def reportsTreeNextItem(self, event): # FIXME to work with reports tree
        logmsg = "reportsTreeNextItem() called"
        logger.debug(logmsg)
	itemData = RetPyData(self.MusicPanel.tab['ReportsTree'].Item, self.FocusManager.WhoIsFocused())
        itemType = itemData[0]
        CollapseList = []

	item = None # the new one

	if self.MusicPanel.tab['ReportsTree'].IsExpanded(self.MusicPanel.tab['ReportsTree'].Item) \
	and (itemType != 'song' and itemType != 'report'):
            logmsg = "item is not song nor report, and is expanded, descending to first child"
            logger.debug(logmsg)
            cookie = 0
            (item, cookie) = self.MusicPanel.tab['ReportsTree'].GetFirstChild(self.MusicPanel.tab['ReportsTree'].Item)
	elif (not self.MusicPanel.tab['ReportsTree'].IsExpanded(self.MusicPanel.tab['ReportsTree'].Item)) \
	and (itemType != 'song' and itemType != 'report'):
            logmsg = "not expanded, seeking next brother or uncle"
            logger.debug(logmsg)
	    if self.MusicPanel.tab['ReportsTree'].Item == self.MusicPanel.tab['ReportsTree'].ItemParentLast:
                logmsg = "last son and brother, jumping to GParent bro"
                logger.debug(logmsg)
		item = self.MusicPanel.tab['ReportsTree'].GetNextSibling(self.MusicPanel.tab['ReportsTree'].ItemParent)
                if not item.IsOk() and self.MusicPanel.tab['ReportsTree'].ItemGParent:
		    logmsg = "itemParent has no bro"
		    logger.debug(logmsg)
		    logmsg = "seeking itemGParent bro"
		    logger.debug(logmsg)
                    item = self.MusicPanel.tab['ReportsTree'].GetNextSibling(self.MusicPanel.tab['ReportsTree'].ItemGParent)
		    if item.IsOk():
                        CollapseList = ['ItemParent', 'ItemGParent']
		else:
                    CollapseList = ['ItemParent']
            else:
                logmsg = "not last, jumping to next bro"
                logger.debug(logmsg)
                item = self.MusicPanel.tab['ReportsTree'].GetNextSibling(self.MusicPanel.tab['ReportsTree'].Item)
        else:
	    logmsg = "is track, seeking brothers"
	    logger.debug(logmsg)
	    if self.MusicPanel.tab['ReportsTree'].Item == self.MusicPanel.tab['ReportsTree'].ItemParentLast:
		logmsg = "is last track, so next whould be:"
		logger.debug(logmsg)
		if self.MusicPanel.tab['ReportsTree'].ItemParent == self.MusicPanel.tab['ReportsTree'].ItemGParentLast:
		    logmsg = "itemParent is the last one, looking for GParent bro"
		    logger.debug(logmsg)
		    item = self.MusicPanel.tab['ReportsTree'].GetNextSibling(self.MusicPanel.tab['ReportsTree'].ItemGParent)
                    CollapseList = ['ItemParent', 'ItemGParent']
		    if not item.IsOk():
			logmsg = "GParent has no bro, is the last one?"
			logger.debug(logmsg)
			logmsg = "so, jumping to next GGParent's bro.. trying"
			logger.debug(logmsg)
			item = self.MusicPanel.tab['ReportsTree'].GetNextSibling(self.MusicPanel.tab['ReportsTree'].ItemGGParent)
                        CollapseList = ['ItemParent', 'ItemGParent', 'ItemGGParent']
		else:
		    logmsg = "itemparent is not last is not GParent's last"
		    logger.debug(logmsg)
		    logmsg = "so, getting item's Parent bro"
		    logger.debug(logmsg)
                    item = self.MusicPanel.tab['ReportsTree'].GetNextSibling(self.MusicPanel.tab['ReportsTree'].ItemParent)
                    CollapseList = ['ItemParent']
            else:
		   item = self.MusicPanel.tab['ReportsTree'].GetNextSibling(self.MusicPanel.tab['ReportsTree'].Item)
	
	# after all, select the next item
	if item.IsOk():
	    for CollapseMe in CollapseList:
                if CollapseMe is 'ItemParent':
                    self.MusicPanel.tab['ReportsTree'].Collapse(self.MusicPanel.tab['ReportsTree'].ItemParent)
                if CollapseMe is 'ItemGParent':
                    self.MusicPanel.tab['ReportsTree'].Collapse(self.MusicPanel.tab['ReportsTree'].ItemGParent)
                if CollapseMe is 'ItemGGParent':
                    self.MusicPanel.tab['ReportsTree'].Collapse(self.MusicPanel.tab['ReportsTree'].ItemGGParent)
	    self.MusicPanel.tab['ReportsTree'].SelectItem(item)
            logmsg = "last: %s" % self.MusicPanel.tab['ReportsTree'].GetItemText(self.MusicPanel.tab['ReportsTree'].ItemParentLast)
            logger.debug(logmsg)
	    logmsg = "selected: %s" % self.MusicPanel.tab['ReportsTree'].GetItemText(self.MusicPanel.tab['ReportsTree'].GetSelection())
	    logger.debug(logmsg)
	
    #---------------------------------------------
    def plTreePrevItem(self, event):
	if self.Playlist.plItem == self.Playlist.itemFirstBro:
	    logmsg = "we exit UP!"
            logger.debug(logmsg)
	    item = self.Playlist.GetItemParent(self.Playlist.plItem)
	else:
            item = self.Playlist.GetPrevSibling(self.Playlist.plItem)
	self.Playlist.SelectItem(item)
        logmsg = "move to playlist previous item"
        logger.debug(logmsg)

    #---------------------------------------------
    def plTreeNextItem(self, event):
        plItemTxt = self.Playlist.GetItemText(self.Playlist.plItem)
	if self.Playlist.IsExpanded(self.Playlist.plItem):
            (item, cookie) = self.Playlist.GetFirstChild(self.Playlist.plItem)
	else:
            if self.Playlist.plItem == self.Playlist.itemLastBro:
		item = self.Playlist.GetNextSibling(self.Playlist.itemParent)
		self.Playlist.Collapse(self.Playlist.itemParent)
	    else:
                item = self.Playlist.GetNextSibling(self.Playlist.plItem)
	self.Playlist.SelectItem(item)
	
	itemData = self.MusicPanel.MusicTree.GetPyData(item)

    #---------------------------------------------
    def XmmsPlayWelcome(self):
        logmsg = "Welcome track playback disabled..."
        logger.debug(logmsg)
        return
        #PlayFile = '/usr/local/media/reports/burnstart.wav'
        PlayFile = '/usr/local/burnstation/burnstart.wav'
        Player.ClearPlaylist()
        Player.AddToPlaylist(PlayFile)
        Player.Play()
        Player.ClearPlaylist()
    
    #---------------------------------------------
    def GetTrackDataByID(self):
        db = DB.connect()
        cursor = db.cursor()
        sql = "SELECT name, location FROM netjuke_tracks WHERE id = '%i'" % self.Playlist.GetCurrentItemData()
	cursor.execute(sql)
        result = cursor.fetchall()
	for record in result:
            name     = record[0]
            location = record[1]

        return (name, location)

    #---------------------------------------------
    def InitPlayerTick(self, evt):
	self.currentPlayerTick = 0;
	self.tick.Start(1000)

        self.Playlist.playbar.Bind(wx.EVT_SCROLL_THUMBTRACK, self.OnSliderScroll)

    def DeInitPlayerTick(self):
        self.tick.Stop()
	self.currentPlayerTick = 0;
        self.Playlist.playbar.SetValue(self.currentPlayerTick)

    def OnPlayerTick(self, evt):
        self.currentPlayerTick += 1
        self.Playlist.playbar.SetValue(self.currentPlayerTick)
        remaining = self.itemData['length2'] - self.currentPlayerTick
        #print remaining
        if remaining == 0:
            self.DeInitPlayerTick()
            print "Play finished!"
            if self.ContinuedRandom: self.OnPlayRandom()

    #---------------------------------------------
    def OnPlayCont(self, evt):
        self.ContinuedRandom = self.Playlist.PlayCont.IsChecked()

    #---------------------------------------------
    def Play(self, evt):
        self.xmmsSeekPos = 0

        self.InitPlayerTick(evt)
        if self.FocusManager.WhoIsFocused() is 'MusicTree' or FocusManager.manager.WhoIsFocused() is 'ReportsTree' or FocusManager.manager.WhoIsFocused() is 'InfoPanel':
            location = self.itemData['location']
            trackName = self.itemData['name']
	    self.Playlist.playbar.SetRange(0, self.itemData['length2'])
        elif self.FocusManager.WhoIsFocused() is 'PlayList':
	    (trackName, location) = self.GetTrackDataByID()

        PlayFile = self.musicPathPrefix + location
        PlayFile = urllib.url2pathname(PlayFile)
        
       # FIXME flag this record on the DB as not found
	if not os.path.isfile(PlayFile):
            logger.warn("File not found: %s" % PlayFile)

	if not os.path.isfile(PlayFile):
            logger.info("File %s not found" % PlayFile)
            self.Message.SetMessage('Now Listening: track not found.. trying it online')
	    mediaURL = "http://db.burnstation.org/burnstation"
	    PlayFile =  mediaURL + "/" + location

            logger.info("Trying to open file online: %s" % PlayFile)

	    try:
                logger.info("opening %s" % PlayFile)
		urlopener = urllib.URLopener()
		con = urlopener.open(PlayFile)
                Player.ClearPlaylist()
                con.close()
	    except:
                logger.warn("404 remote file %s does not exist" % PlayFile)
                return False
	else:
            Player.ClearPlaylist()
	
        logger.info("Trying to play %s" % PlayFile)
	try:
            Player.ClearPlaylist()
            Player.AddToPlaylist(PlayFile)
            Player.Play()
            PlayFileUnicoded = uniconvert2(PlayFile)
            self.Message.SetMessage('Now Listening: ' + trackName)
            return True
	except Exception, e:
	    logger.warn("NOT playing! Exception was: " + str(e))

    #---------------------------------------------
    def OnSliderScroll(self, evt):
        newPos = (self.Playlist.playbar.GetValue() * 1000) + self.xmmsSeekSecs
        Player.Seek(newPos)
	#self.currentPlayerTick = newPos

    #---------------------------------------------
    def XmmsSeek(self, evt):
        # get current position from Player tick

        #newPos = (self.Playlist.playbar.GetValue() * 1000) + self.xmmsSeekSecs
        newPos = self.currentPlayerTick + self.xmmsSeekSecs
        #self.xmmsSeekPos = (self.currentPlayerTick * 1000) + self.xmmsSeekSecs
        logmsg = "Current play position: %i . Seeking to: %s" % (self.currentPlayerTick, newPos)
        logger.debug(logmsg)
        self.currentPlayerTick = newPos / 1000
        self.Playlist.playbar.SetValue(self.currentPlayerTick)
        Player.Seek(newPos)
 
    #---------------------------------------------
    def XmmsVolume(self, evt):
        newVol =  self.Playlist.playvolume.GetValue()
        logger.debug("New volume ::" + str(newVol))
        
    #---------------------------------------------
    def OnJoyConf(self, evt):
        self.JoyConf = JoyConf(self)

    #---------------------------------------------
    def ReloadConfig(self):
        self.stick.ReloadConfig()

    #---------------------------------------------
    def OnExperimentalGUI(self, evt):
        #command = ['xmms']
        #xmmsPID = os.spawnvpe(os.P_NOWAIT, 'xmms', command, os.environ)
        cmd = 'cd pygamegui/ ; python ./lista.py'
	os.system(cmd)

    #---------------------------------------------
    def OnLangButton(self, evt):
	logmsg = "OK, popping up langBox"
        logger.debug(logmsg)
	langBox = __import__("lang", globals())
	win = wx.Frame(None, -1, "Select Lang", pos=(50,50), size=(220,220),
				style=wx.DEFAULT_FRAME_STYLE)
        win.pariente = self

        logmsg = "self.GV.LoggedUser antes de llamar langBox: %s" % self.GV.LoggedUser
        logger.debug(logmsg)
	langBox.run(self, win, self.GV, frame)
	win.Show(True)
	def LangBoxOnClose(evt):
            if self.GV.lang == '':
                # Reload LangBox
                logmsg = "WARNING: when LangBox was closed, no lang was selected, asking again!"
                logger.debug(logmsg)
                #self.OnLangButton(evt=None)
		logmsg_info = "not closing"
		logger.info(logmsg_info)
		return False
            else:
                win.Show(False)
		logmsg = "ok, closed"
                logger.debug(logmsg)
		return True

    #---------------------------------------------
    def OnLogout(self, evt):
	self.GV.FullReset()
    
    #---------------------------------------------
    def XmmsStop(self, evt):
        Player.Stop()
        self.DeInitPlayerTick()
    
    #---------------------------------------------
    def OnClearPlaylist(self, event):
	# limpiamos totalmente la playlist (borra *toda* la seleccion)
	wx.LogMessage("borrando la playlist..espere")
        db = DB.connect()
        cursor = db.cursor()
        cursor.execute("DELETE FROM playlists")
	db.close()
	self.Playlist.Clear()
	self.Playlist.PopulateData()
	wx.LogMessage("playlist borrada!")
    
    #---------------------------------------------
    # Menu methods
    #---------------------------------------------
    def OnFileExit(self, *event):
        logmsg = "ok, hope you enjoyed, bye ..."
        logger.debug(logmsg)
        self.Close()
    
    #---------------------------------------------
    def OnHelpAbout(self, event):
        txtAbout = 'Credits'
        txtAbout += '\nProject by: Platoniq.net <info@platoniq.net>'
        txtAbout += '\nAuthor: Ramiro Cosentino <rama@xicnet.com>'
        txtAbout += '\nContributors: Philip Leitner <pi@modular-t.org>'
        txtAbout += '\n'
        txtAbout += '\nhttp://burnstation.org'
        
	titleAbout = 'About Burn Station Software'

        dlg = wx.MessageDialog(self, txtAbout, titleAbout, wx.OK | wx.ICON_INFORMATION)
                               #wx.YES_NO | wx.NO_DEFAULT | wx.CANCEL | wx.ICON_INFORMATION)
        dlg.ShowModal()
        dlg.Destroy()

    #---------------------------------------------
    def ShowFocus(self):
        log = "** ShowFocus() called, result = %s" % wx.Window.FindFocus()
        logger.debug(log)
    
    #---------------------------------------------
    def OnCloseWindow(self, event):
        self.dying = True
        self.window = None
        self.mainmenu = None
        self.Infopanel.ImgPage.img.Destroy()
        if hasattr(self, "tbicon"):
            del self.tbicon
        self.Destroy()

    #---------------------------------------------
    def OnIdle(self, event):
        #if self.FocusManager.WhoIsFocused() is 'ProgressDialog':

        if self.stick is None: return

        mainwin = [
                   'MusicTree',
                   'ReportsTree',
                   'PlayList',
                   'TextPage',
		   'BurnMenu',
		   'BurnResultBox',
		   'JoyConf'
                  ]


        if self.FocusManager.WhoIsFocused() not in mainwin:
	    return

        self.OnJoystick(event)
        wx.WakeUpIdle()
        sleepTime = 0.001
        time.sleep(sleepTime)

        if self.otherWin:
            self.otherWin.Raise()
            self.window = self.otherWin
            self.otherWin = None

    #---------------------------------------------
    def ShowTip(self):
        try:
            showTipText = open(opj("data/showTips")).read()
            showTip, index = eval(showTipText)
        except IOError:
            showTip, index = (1, 0)
        if showTip:
            tp = wx.CreateFileTipProvider(opj("data/tips.txt"), index)
            ##tp = MyTP(0)
            showTip = wx.ShowTip(self, tp)
            index = tp.GetCurrentTip()
            open(opj("data/showTips"), "w").write(str( (showTip, index) ))

    #---------------------------------------------
    def nullEvent(self, evt):
        logmsg_info = "nullEvent() was called (maybe you forgot to call the real function?)"
        logger.info(logmsg_info)
    
    #---------------------------------------------
    def OnTaskBarActivate(self, evt):
        if self.IsIconized():
            self.Iconize(False)
        if not self.IsShown():
            self.Show(True)
        self.Raise()

    #---------------------------------------------
    TBMENU_RESTORE = 1000
    TBMENU_CLOSE   = 1001

    def OnTaskBarMenu(self, evt):
        menu = wx.Menu()
        menu.Append(self.TBMENU_RESTORE, "Restore wx.Python Demo")
        menu.Append(self.TBMENU_CLOSE,   "Close")
        self.tbicon.PopupMenu(menu)
        menu.Destroy()

    #---------------------------------------------
    def OnTaskBarClose(self, evt):
        self.Close()

        # because of the way wx.TaskBarIcon.PopupMenu is implemented we have to
        # prod the main idle handler a bit to get the window to actually close
        wx.GetApp().ProcessIdle()

    def OnImport(self, evt):
        self.publishPanel = Publish2.PublishPanel('publish')

    def OnEdit(self, evt):
        self.publishPanel = Publish2.PublishPanel('edit')

    def InitPlaylist(self):
        self.login = login.login()
        self.playlistID = self.login.NewPlaylistID
        self.GV.NewPlaylistID = self.playlistID

    def OnReinitAll(self, evt=None):
        '''Re-initialize playlist (to a new one) and reset trees'''
        self.InitPlaylist()
        self.Message.ResetTime()
        self.Playlist.Reload()
        self.OnResetTrees()

#---------------------------------------------------------------------------
class MySplashScreen(wx.SplashScreen):
    def __init__(self):
        bmp = wx.Image(config.bshome+"/img/burnlogo.png").ConvertToBitmap()
        wx.SplashScreen.__init__(self, bmp,
                                wx.SPLASH_CENTRE_ON_SCREEN|wx.SPLASH_TIMEOUT,
                                1000, None, -1,
                                style = wx.SIMPLE_BORDER|wx.FRAME_NO_TASKBAR|wx.STAY_ON_TOP)
	self.Bind(wx.EVT_CLOSE, self.OnClose)
    
    def OnClose(self, evt):
        global frame
        frame = MainFrame(None, -1, "      Burn Station      ")
	#frame.MusicPanel.OnFocusMusicTree(event=None)
        frame.Show(True)
        evt.Skip()  # Make sure the default handler runs too...
        #self.SetTopWindow(frame)


class MyApp(wx.App):
    def OnInit(self):
        """
        Create and show the splash screen.  It will then create and show
        the main frame when it is time to do so.
        """
        wx.InitAllImageHandlers()
        splash = MySplashScreen()
        splash.Show()
        return True

#---------------------------------------------------------------------------

class PopBurn(wx.Frame):
    def __init__(self, parent, types, playlistID, FocusManager):
        logger.debug("PopBurn instantiatied")

        self.parent = parent

        self.burnType = 'audio'
        self.FocusManager = FocusManager
        self.playlistID = playlistID

        if types is 'all':
            w = 300
            h = 160
        else:
            w = 435
            h = 180
   
	s = wx.Size(int(w), int(h))
	
	wx.Frame.__init__(self, None, -1, "BURN", pos=(300,300), size=s)
        self.w = wx.Window(self, style=wx.WANTS_CHARS)

        okID = wx.NewId()
        self.w.Bind(wx.EVT_MENU, self.BurnOk, id=okID)

        cancelID = wx.NewId()
        self.w.Bind(wx.EVT_MENU, self.BurnCancel, id=cancelID)

        # set the menu accellerator table...
        aTable = wx.AcceleratorTable([(wx.ACCEL_CTRL,  ord('l'), okID),
                                      (wx.ACCEL_CTRL,  ord('j'), cancelID)
                                     ])
	    
        self.w.SetAcceleratorTable(aTable)
        self.p = wx.Panel(self.w, -1, size=(450, 200))

        if types is 'all':
            self.chooseBurn()
        else:
            self.burnAudio()

    #-----------------------------------
    def chooseBurn(self):
        RBUT1 = wx.NewId()
        RBUT2 = wx.NewId()
        RBOX2 = wx.NewId()

        sizer = wx.BoxSizer(wx.VERTICAL)

        burnTypes = ['audio', 'data']
            
        txt = 'Choose the type of CD you prefer'
        txt += '\n%s' % config.doSwitch
        burnHelp = wx.StaticText(self.p, -1, txt, wx.Point(20, 10), style=wx.ALIGN_CENTRE)
            
        self.burn_rb = wx.RadioBox(self.p, RBOX2, "", wx.Point(80, 40), wx.DefaultSize,
                                       burnTypes, 2, wx.RA_SPECIFY_COLS | wx.NO_BORDER)
            
        def EvtRadioBox(event):
            BoxID = event.GetInt()
            if BoxID == 0:
                self.burnType = 'audio'
            if BoxID == 1:
                self.burnType = 'data'
            logmsg = "at burnMenu() -> %s mode <- was chosen" % self.burnType
            logger.debug(logmsg)
        
	txt2 = '\n%s' % config.doCancel
        txt2 += '\n'
        txt2 += '\n    %s' % config.doBurn
        burnHelp2 = wx.StaticText(self.p, -1, txt2, wx.Point(20, 80), style=wx.ALIGN_LEFT)
            
        sizer.Add(self.burn_rb, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM, 30)
        self.p.Bind(wx.EVT_RADIOBOX, EvtRadioBox, self.burn_rb)

        okBtn = wx.Button(self.p, -1, "Ok", wx.Point(20,125), wx.Size(60, 30))
        self.Bind(wx.EVT_BUTTON, self.BurnOk, id=okBtn.GetId())
        
	cancelBtn = wx.Button(self.p, -1, "Cancel", wx.Point(20, 90), wx.Size(60, 30))
        self.Bind(wx.EVT_BUTTON, self.BurnCancel, id=cancelBtn.GetId())
                
        buttonBox = wx.BoxSizer(wx.HORIZONTAL)
        buttonBox.AddMany([
            (okBtn, 0, wx.ALIGN_CENTER_HORIZONTAL | wx.ALL, 5),
            (cancelBtn, 0, wx.ALIGN_CENTER_HORIZONTAL | wx.ALL, 5),
            ])
        
    #-----------------------------------
    def burnAudio(self):
        txt = 'The size of your playlist is too large to create an AUDIO-CD.'
        txt += '\nIf you proceed with OK, a DATA-CD will be created.'
        txt += '\n'
        txt += '\nIf you CANCEL, you can delete contents from your playlist'
        txt += '\nto create an AUDIO-CD'
        burnHelp = wx.StaticText(self.p, -1, txt, wx.Point(20, 10))
        self.burnType = 'data'
        logmsg = 'on PopBurn() setting burnType to %s, as audio option is not possible' % self.burnType
        logger.debug(logmsg)

        logmsg = 'burnMenu() burnType = %s' % self.burnType
        logger.debug(logmsg)
        self.w.SetFocus()
        
        txt2 = '\n%s' % config.doCancel
        txt2 += '\n'
        txt2 += '\n    %s' % config.doBurn
        burnHelp2 = wx.StaticText(self.p, -1, txt2, wx.Point(20, 90), style=wx.ALIGN_LEFT)

	okBtn = wx.Button(self.p, -1, "Ok", wx.Point(20,135), wx.Size(60, 30))
        self.Bind(wx.EVT_BUTTON, self.BurnOk, id=okBtn.GetId())
        
	cancelBtn = wx.Button(self.p, -1, "Cancel", wx.Point(20, 100), wx.Size(60, 30))
        self.Bind(wx.EVT_BUTTON, self.BurnCancel, id=cancelBtn.GetId())
                
        buttonBox = wx.BoxSizer(wx.HORIZONTAL)
        buttonBox.AddMany([
            (okBtn, 0, wx.ALIGN_CENTER_HORIZONTAL | wx.ALL, 5),
            (cancelBtn, 0, wx.ALIGN_CENTER_HORIZONTAL | wx.ALL, 5),
            ])
        
    
    #-----------------------------------
    def BurnOk(self, event):
        self.Destroy()
	print "BurnOk() playlistID: %s" % str(self.playlistID)
        self.burnNow = BurnNow.BurnNow(self.parent, self.burnType, self.playlistID, self.FocusManager)
	    
    #-----------------------------------
    def BurnCancel(self, event):
        #self.GV.HasFocus = self.GV.HadFocus
        self.Destroy()

#-----------------------------------------------------------------------------------------------
def main():
    app = MyApp()
    app.MainLoop()

#----------------------------------------------------------------------------
if __name__ == '__main__':
    main()

