#!/usr/bin/python
# -*- coding: utf-8 -*-

from ErrorsHandler import *
logger.info("starting audio system using XMMS")

import os
import xmms.control

class OggPlayer:
    """XMMS Based audio player for BurnStation
    
    This use the xmms.control module to control an XMMS instance to
    play the music from the burnstation.

    In order to work you need xmms and xmms-python installed
    """

    def __init__(self):
        if not xmms.control.is_running():
            logger.info("Xmms not running yet, launching now...")
            command = ['xmms']
            xmmsPID = os.spawnvpe(os.P_NOWAIT, 'xmms', command, os.environ)
            # TODO : wait for xmms
        else:
            logger.info("Xmms already running...OK")

        if False:
            logger.info("Hiding xmms GUI now")
            xmms.control.main_win_toggle(0)
            xmms.control.pl_win_toggle(0)
            xmms.control.eq_win_toggle(0)
            logger.info("xmms GUI supposedly hidden at this point")

    def ClearPlaylist(self):
        xmms.control.playlist_clear()

    def AddToPlaylist(self, uri):
        xmms.control.playlist_ins_url_string(uri, 0)

    def Play(self):
        xmms.control.play()

    def Stop(self):
        xmms.control.stop()

    def Seek(self, time):
        xmms.control.jump_to_time(time)

    def Volume(self, level):
        xmms.control.set_volume(level, level)

    def getVolume(self):
        return xmms.control.get_main_volume()

    def VolUp(self):
        newvol= self.getVolume() + 2
        xmms.control.set_volume(newvol, newvol)

    def VolDown(self):
        newvol= self.getVolume() - 2
        xmms.control.set_volume(newvol, newvol)
