#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
sys.path.append('./lib')

from string import strip, find, split, lower, rjust, atoi, atof, replace, digits, zfill, join
from tools import cleanlist, which, filecopy, mkdirtree, touch, listmatch, rm, escapedfilename
from tools import get_username, get_tempdir, cmdexec
import os
import mp3info, ogg.vorbis

class convert2wav:
    def __init__(self, filename, targetPath):
        """ Converts mp3/ogg-files to wav-files. """
    
        #if (self.convmp3wav.get_active()):
        if (1):
            mp3count = 0
            oggcount = 0
            line = 0
            if (lower(filename[-4:]) == ".mp3"):
                mp3count = mp3count + 1
            if (lower(filename[-4:]) == ".ogg"):
                oggcount = oggcount + 1
            line = line + 1
    
            # Check whether mpg123 and oggdec exists
            mpg123_command = which("mpg123")
            oggdec_command = which("oggdec")
            if ((mp3count > 0) and (mpg123_command == "")):
                print "mpg123 not found for converting mp3 files"
            if ((oggcount > 0) and (oggdec_command == "")):
                print "oggdec not found for converting ogg files"
    
            print ("Converting %d file(s) now") % (mp3count + oggcount)
    
            if ((mp3count > 0) or (oggcount > 0)):
                line = 0
                if (lower(filename[-4:]) == ".mp3") or (lower(filename[-4:]) == ".ogg"):
                    wavfilename = "%s/%s.wav" % (targetPath, os.path.basename(filename)[:-4])
                print "wavfilename = " + wavfilename
    
                if (lower(filename[-4:]) == ".mp3"):
                    # Make sure that conversion is done with the correct sample rate
                    file = open(filename, "rb")
                    mpeg3info = mp3info.MP3Info(file)
                    file.close()
                    samplerate = mpeg3info.mpeg.samplerate
                    command = "(%s --stereo -s \"%s\" | sox -t raw -r %d  -w -s -c 2 - -r 44100 -t wav \"%s\") 2>&1" % (mpg123_command, escapedfilename(filename), samplerate, escapedfilename(wavfilename))
                elif (lower(filename[-4:]) == ".ogg"):
		    # get OGG samplerate
		    vf = ogg.vorbis.VorbisFile(filename)
		    vi = vf.info()
		    oggRate = vi.rate
		    oggChannels = vi.channels
		    print 'OGG rate: %s' % oggRate
		    print 'OGG channels: %s' % oggChannels
                    if oggRate != 44100:
		        print 'WARN: samplerate not 44100, using sox to resample'
                        command = "(%s -Q -o - \"%s\" | sox -t raw -r %d  -w -s -c 2 - -r 44100 -t wav \"%s\") 2>&1" % (oggdec_command, escapedfilename(filename), oggRate, escapedfilename(wavfilename))
                    elif oggChannels != 2:
		        print 'WARN: not stereo but mono, using sox to convert'
                        command = "(%s -Q -o - \"%s\" | sox -t raw -r %d  -w -s -c 2 - -r 44100 -t wav \"%s\") 2>&1" % (oggdec_command, escapedfilename(filename), oggRate, escapedfilename(wavfilename))
                    else:
                        command = "%s -Q -o \"%s\" \"%s\" 2>&1" % (oggdec_command, escapedfilename(wavfilename), escapedfilename(filename))
                print "Executing: %s" % command
                (result, (stdout_output, stderr_output)) = cmdexec(command)

                if (result != 0):
                    if (lower(filename[-4:]) == ".mp3"):
                        result = listmatch(output, "Playing")
                        output = output[result[0]:]

            line = line + 1
