#!/usr/bin/python
# -*- coding: utf-8 -*-

import dbus
import dbus.glib
import sys
import os
import os.path
import string
import wx
import images

class Drive:
    """ An Removable device abstraction """
    def __init__ (self, device, mp, name):
	self.device = device
	self.mountpoint = mp
	self.name = name

    def umount(self):
      return os.system("pumount %s" % self.device)

class DriveSelector(wx.Dialog):
    def __init__(self, parent):
        wx.Dialog.__init__(self, parent, style=wx.DEFAULT_DIALOG_STYLE, size=(-1,-1))

        sizer = wx.BoxSizer(wx.VERTICAL)

	btnSizer = wx.BoxSizer(wx.HORIZONTAL)
	label = wx.StaticText(self, -1, "Select Import source")
	btnSizer.Add(label, 1, wx.EXPAND)
	refresh = wx.Button(self, -1, "Refresh")
	refresh.Bind(wx.EVT_BUTTON, self.Refresh)
	btnSizer.Add(refresh, 0, wx.RIGHT)

	sizer.Add(btnSizer, 0, wx.EXPAND)
	sizer.Add((0, 10), 0, wx.EXPAND)

        self.list = wx.ListCtrl(self, -1, style=wx.LC_REPORT | wx.BORDER_SUNKEN | wx.BORDER_NONE)
        self.list.InsertColumn(0, "Label")
        self.list.InsertColumn(1, "Vendor")
        self.list.InsertColumn(2, "Type")
	self.list.SetColumnWidth(0, -1)
	self.list.SetColumnWidth(1, -1)
	self.list.SetColumnWidth(2, -1)
        sizer.Add(self.list, 1, wx.EXPAND)

	btnSizer = wx.BoxSizer(wx.HORIZONTAL)
	refresh = wx.Button(self, -1, "Select")
	btnSizer.Add(refresh, 1, wx.EXPAND)
	refresh.Bind(wx.EVT_BUTTON, self.Ok)
	sizer.Add((0, 10), 0, wx.EXPAND)
	sizer.Add(btnSizer, 0, wx.EXPAND)

	self.Refresh()

	self.SetSizer(sizer)
        self.SetAutoLayout(True)
        #sizer.Fit(self)
	self.Center()

    def GetDir(self):
	i = self.list.GetFirstSelected()
	return Drive(str(self.mounts[i][0]), str(self.mounts[i][1]), str(self.mounts[i][2]))

    def Ok(self, evt=None):
	if self.list.GetFirstSelected() < 0:
	    d = wx.MessageDialog(self, "Please select an import source", "No source selected", style=wx.OK)
	    d.ShowModal()
	    d.Destroy()
	    return
	self.EndModal(0)

    def Refresh(self, evt=None):
	# get a connection to the system bus
	bus = dbus.SystemBus ()

	# get a HAL object and an interface to HAL to make function calls
	hal_obj = bus.get_object ('org.freedesktop.Hal', '/org/freedesktop/Hal/Manager')
	hal = dbus.Interface (hal_obj, 'org.freedesktop.Hal.Manager')

	# find all devices that have the capability 'laptop_panel'
	udis = hal.FindDeviceByCapability ('volume')

	self.mounts = []
	self.list.DeleteAllItems()
	for udi in udis:
	    # Get Volume Object for this mount point
            dev_obj = bus.get_object ('org.freedesktop.Hal', udi)

	    # get an interface to the device
            dev = dbus.Interface (dev_obj, 'org.freedesktop.Hal.Device')
        
	    # Get the parent device
	    parent_obj = bus.get_object ('org.freedesktop.Hal', dev.GetProperty("info.parent"))
            parent = dbus.Interface (parent_obj, 'org.freedesktop.Hal.Device')

            # Get removable and CDROM media only
            if parent.GetProperty ('storage.hotpluggable') or 'storage.cdrom' in parent.GetProperty('info.capabilities'):
		name = dev.GetProperty ('volume.label') or parent.GetProperty("info.product")
                device = dev.GetProperty ('block.device')
		try:
		    vendor = parent.GetProperty ('info.vendor')
		except:
		    vendor = parent.GetProperty('info.product')
		if 'storage.cdrom' in parent.GetProperty('info.capabilities'):
		    mtype = "CD-ROM"
		else:
		    mtype = "Pendrive"
		if not dev.GetProperty('volume.is_mounted'):
		    #os.system("pmount -r %s %s" % (device, name.replace(" ", "_")))
		    os.system("pmount-hal %s" % (udi))
                mountpoint = dev.GetProperty ('volume.mount_point')
		index = self.list.InsertStringItem(999, name)
		self.list.SetStringItem(index, 1, vendor)
		self.list.SetStringItem(index, 2, mtype)
		self.mounts.append((device, mountpoint, name))
	self.list.SetColumnWidth(0, -1)
	self.list.SetColumnWidth(1, -1)
	self.list.SetColumnWidth(2, -1)
