#!/usr/bin/python
# -*- coding: utf-8 -*-


import  sys
sys.path.append('..')
from ErrorsHandler import *

import  LoadConfig
config = LoadConfig.LoadConfig()

from shutil import copy, move

from MiscTools import *
from ImageBrowser import *

import  wx
import os.path

#---------------------------------------------------------------------------

class InfoManager(wx.Frame):
    def OnSetFocus(self, evt):
        print "OnSetFocus"
        evt.Skip()
    def OnKillFocus(self, evt):
        print "OnKillFocus"
        evt.Skip()
    def OnWindowDestroy(self, evt):
        print "OnWindowDestroy"
        evt.Skip()


    def __init__(self, parent, tag, userInfo, selected=None):
        #wx.Panel.__init__(self, parent, -1)
	wx.Frame.__init__(self, None, -1, "Tags editor", pos=(-1,-1),
        #pos = wx.Point(self.config.guiPosX, self.config.guiPosY),
        size=wx.Size(config.guiSizeX, config.guiSizeY),
        style=wx.DEFAULT_FRAME_STYLE | wx.TAB_TRAVERSAL)

        self.ib = ImageBrowser(None)

        self.selected = selected

        self.tag      = tag
	self.userInfo = userInfo

	self.itemID   = None
        self.title    = {}
        self.title2   = {}
        self.tags     = {}
        self.cb       = {}
        self.info     = {}
        self.img      = {}
        self.imgPath  = None
        self.bt       = {}
        self.dirty    = False

        #--------- START ARTIST --------------------------------------------------------------#
        #combo = ['labels', 'artists', 'albums']
        #self.tags = ['labels']

        #for tag in self.tags:
        self.title = wx.StaticText(self, -1, self.tag)
        self.cb = wx.ComboBox(self, 500, '', (90, 50), (95, -1), '', wx.CB_DROPDOWN | wx.CB_SORT )
        self.populateCombo()
        self.cb.SetStringSelection(self.selected)
        self.Bind(wx.EVT_COMBOBOX, self.EvtComboBox, self.cb)

        self.img = wx.StaticBitmap(self, -1)
        image = '/usr/share/burnstation-client/img/burnlogo.png'
        image = convert2bitmap(image)
        self.img.SetBitmap(image)

        self.title2 = wx.StaticText(self, -1, "Info")
        self.info = wx.TextCtrl(self, -1, size=(150,150), style=wx.TE_MULTILINE)
        self.info.Bind(wx.EVT_TEXT, self.OnTextChanged)
  
        self.getSelectionData()

        #--------- END LABEL ------------------------------------------------------------------#

        #--------- START LICENSE --------------------------------------------------------------#
	'''
	combo = 'licenses'
        defaultLicense = "N/A"
        l5 = wx.StaticText(self, -1, "License")
        self.cb[combo] = wx.ComboBox(self, 500, '', (90, 50), (95, -1), '', wx.CB_DROPDOWN | wx.CB_READONLY | wx.CB_SORT )
        self.CopyLicenceID = wx.NewId()
        self.bt5 = wx.Button(self, self.CopyLicenceID, "Apply to all files in the directory")
        self.populateCombo(combo)
        self.cb[combo].SetStringSelection(defaultLicense)
        self.Bind(wx.EVT_COMBOBOX, self.EvtComboBox, self.cb[combo])
	'''
        #--------- END LICENSE --------------------------------------------------------------#

        #--------- START TAGS SIZER ---------------------------------------------------------#
        space = 8
        sizer = wx.FlexGridSizer(cols=2, hgap=space, vgap=space)
        sizer.AddGrowableCol(1, 1)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.title, 0, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.cb, 1, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.title2, 0, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.info, 1, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.img, 1, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
	'''
        sizer.Add(l5, 0, wx.EXPAND)
        sizer.Add(self.cb['licenses'], 1, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.bt5, 1, wx.EXPAND)
	'''
        #--------- END TAGS SIZER -----------------------------------------------------------#

        #--------- START BUTTONS ------------------------------------------------------------#
        self.ImageID = wx.NewId()
        b0 = wx.Button(self, self.ImageID, "Change image")
        b0.Bind(wx.EVT_BUTTON, self.OnChangeImage, id=self.ImageID)

        self.WriteID = wx.NewId()
        b1 = wx.Button(self, self.WriteID, "Save changes")
        b1.Bind(wx.EVT_BUTTON, self.OnSave, id=self.WriteID)

        #self.ImportID = wx.NewId()
        #b2 = wx.Button(self, self.ImportID, "Publish Now !")

        self.ExitID = wx.NewId()
        b3 = wx.Button(self, self.ExitID, "Finished.. exit.")

        #self.UnimportID = wx.NewId()
        #b4 = wx.Button(self, self.UnimportID, "Unimport.")

        '''
        self.SelectDriveID = wx.NewId()
        b5 = wx.Button(self, self.SelectDriveID, "Change Drive/Directory")
        '''
        #--------- START BUTTONS ------------------------------------------------------------#

        #--------- START BUTTONS SIZER ------------------------------------------------------#
        border = wx.BoxSizer(wx.VERTICAL)
        border.Add(sizer, 1, wx.EXPAND)
        #border.Add(b0, 0, wx.EXPAND, 25)
        border.Add(b0, 0, wx.EXPAND, 25)
        border.Add(b1, 0, wx.EXPAND, 25)
        #border.Add(b2, 0, wx.EXPAND, 25)
        border.Add(b3, 0, wx.EXPAND, 25)
        #border.Add(b4, 0, wx.EXPAND, 25)
        #border.Add(b5, 0, wx.EXPAND, 25)
        self.SetSizer(border)
        self.SetAutoLayout(True)
        #--------- END BUTTONS SIZER --------------------------------------------------------#

        self.Centre(wx.HORIZONTAL)
        self.Show(True)

    def populateCombo(self):
        if self.tag == 'label' or self.tag == 'artist' or self.tag == 'album':
            if self.tag is 'label' : type = 'labels'
            if self.tag is 'artist': type = 'artists'
            if self.tag is 'album' : type = 'albums'

            self.cb.Clear()
            for item in getList(type):
                itemData = {'type':self.tag, 'id':item[0], 'name':uniconvert2(item[1]), 'info':uniconvert2(item[2]), 'img':uniconvert2(item[3])}
                self.cb.Append(uniconvert2(item[1]), itemData)

    def EvtComboBox(self, evt=None):
        self.getSelectionData()

    def getSelectionData(self):
        data = self.cb.GetClientData(self.cb.GetSelection())

        self.info.SetValue(uniconvert2(data['info']))
        self.selected = self.cb.GetStringSelection()

	image = ValidateImage(data['img'], data['type'])
        self.imgPath = image
        image = convert2bitmap(image)
        self.img.SetBitmap(image)
	self.itemID = data['id']

    def OnTextChanged(self, event):
	#logger.debug2("in vorbismanager.OnTextChanged() metatags are dirty now!")
        #self.dirty = True
        pass

    def EvtTextEnter(self, event):
        #self.log.WriteText('EvtTextEnter\n')
        print 'EvtTextEnter\n'
        event.Skip()

    def EvtChar(self, event):
        keycode = event.GetKeyCode()
	
        if keycode == 13:
            self.OnGetValues(event)
        event.Skip()

    def OnChangeImage(self, evt):
        self.ib.pop()
	self.imgPath = self.ib.imgPath
        img = convert2bitmap(self.imgPath)
        self.img.SetBitmap(img)
    
    def OnGetValues(self, evt):
        data = {}
        data['type']      = self.tag
        data['id']        = self.itemID
        data['name']      = self.cb.GetValue()
        data['comments']  = self.info.GetValue()
        data['img_src']   = self.imgPath

        return data

    def OnSave(self, evt):
        data = self.OnGetValues(None)

        imgFile = data['img_src']
        if os.path.exists(imgFile):
            imgName = os.path.basename(imgFile)

            print "source file: " + imgFile
            dst = str(self.userInfo['home']) + "/" + str(self.tag) + "-" + str(data['id']) + "-" + str(imgName)
            print "dest file: " + dst
            data['img_src'] = removePathComponent(dst, config.musicPath)
            print "Img_src: " + data['img_src']

            copy(imgFile, dst)

	if saveToDB(data):
            logger.info("Saved to database.. reloading combo")
            self.populateCombo()
            self.cb.SetStringSelection(data['name'])
        else: logger.error("ERROR updating...")

    def OnTestWriteText(self, evt):
        self.t.WriteText("TEXT")

    def OnTestGetSelection(self, evt):
        start, end = self.t.GetSelection()
        text = self.t.GetValue()
        if wx.Platform == "__WXMSW__":  # This is why GetStringSelection was added
            text = text.replace('\n', '\r\n')

        #self.log.write("multi-line GetSelection(): (%d, %d)\n"
        print "multi-line GetSelection(): (%d, %d)\n\tGetStringSelection(): %s\n\tSelectedText: %s\n" % (start, end, self.t.GetStringSelection(), repr(text[start:end]))

        start, end = self.t1.GetSelection()
        text = self.t1.GetValue()

        if wx.Platform == "__WXMSW__":  # This is why GetStringSelection was added
            text = text.replace('\n', '\r\n')

        #self.log.write("single-line GetSelection(): (%d, %d)\n"
        print "single-line GetSelection(): (%d, %d)\n\tGetStringSelection(): %s\n\tSelectedText: %s\n" % (start, end, self.t1.GetStringSelection(), repr(text[start:end]))


    def OnT5LeftDown(self, evt):
        evt.Skip()
        wx.CallAfter(self.LogT5Position, evt)

    def LogT5Position(self, evt):
        text = self.t5.GetValue()
        ip = self.t5.GetInsertionPoint()
        lp = self.t5.GetLastPosition()
        #self.log.write("LogT5Position:\n"
        print "LogT5Position:\n\tGetInsertionPoint:\t%d\n\ttext[insertionpoint]:\t%s\n\tGetLastPosition:\t%d\n\tlen(text):\t\t%d\n" % (ip, text[ip], lp, len(text))

    def OnExit(self, evt):
        self.Show(False)
        self.Destroy()
		

#---------------------------------------------------------------------------

def runTest(frame, nb, log):
    win = InfoManager(nb, log)
    return win

#---------------------------------------------------------------------------


overview = """\
A TextCtrl allows text to be displayed and (possibly) edited. It may be single 
line or multi-line, support styles or not, be read-only or not, and even supports
text masking for such things as passwords.


"""

class MyApp(wx.App):
    def OnInit(self):
        #wx.InitAllImageHandlers()
        frame = wx.Frame(None, -1, "InfoManager: ", pos=(500,0), size=(640,600),
                        style=wx.DEFAULT_FRAME_STYLE)
        self.SetTopWindow(frame)
        frame.Show()
	panel = InfoManager(frame,-1)
        return True


if __name__ == '__main__':
    app = MyApp(0)
    app.MainLoop()

    #import sys,os
    #import run
    #run.main(['', os.path.basename(sys.argv[0])] + sys.argv[1:])

