#!/usr/bin/python
# -*- coding: utf-8 -*-

import  sys
sys.path.append('..')
from ErrorsHandler import *
import  LoadConfig
from ImportCommon import *

import  wx
import  wx.wizard as wiz
import  images
from UserRegister import UserRegister
from UserLogin import UserLogin
import dirlist

import FocusManager

#----------------------------------------------------------------------

class PublishPanel(wx.Frame):
    def __init__(self, mode='publish'):
	#wx.Frame.__init__(self, None, -1, title, size=s, style=wx.DEFAULT_FRAME_STYLE | wx.STAY_ON_TOP)

        logger.info("starting PublishPanel")
        self.config = LoadConfig.LoadConfig()

        if mode is 'publish': editMode = ''
        elif mode is 'edit': editMode = ' (edit mode)'

        self.mode = mode

	title = "Burn Station Publishing System" + editMode
	wx.Frame.__init__(self, None, -1, title, pos=(-1,-1),
                          #pos = wx.Point(self.config.guiPosX, self.config.guiPosY),
                          size=wx.Size(self.config.guiSizeX, self.config.guiSizeY),
                          style=wx.DEFAULT_FRAME_STYLE | wx.TAB_TRAVERSAL)

        FocusManager.manager.Register("Import", self)
        FocusManager.manager.SetFocus("Import")

        #------------------------------------------------------------------
        # Make a Top Bar Menu
        self.mainmenu = wx.MenuBar()

        # File menu
        menu = wx.Menu()

        exitID = wx.NewId()
        menu.Append(exitID, '&Quit\tCtrl-Q', 'Get the heck outta here!')
        self.Bind(wx.EVT_MENU, self.OnExit, id=exitID)

        self.mainmenu.Append(menu, '&File')

        # Options menu
        menu = wx.Menu()

        RipID = wx.NewId()
        menu.Append(RipID, '&Rip Audio-CD\tCtrl-R', 'Rip an audio CD')
        self.Bind(wx.EVT_MENU, self.OnRip, id=RipID)

        SelectDirID = wx.NewId()
        menu.Append(SelectDirID, '&Select Directory\tCtrl-S', 'Select directory to browse for music to be published')
        self.Bind(wx.EVT_MENU, self.OnSelectDir, id=SelectDirID)

        SelectDriveID = wx.NewId()
        menu.Append(SelectDriveID, '&Select Media Device\tCtrl-D', 'Select media device to browse for music to be published')
        self.Bind(wx.EVT_MENU, self.OnSelectDrive, id=SelectDriveID)

        self.mainmenu.Append(menu, '&Options')

        # Finally set the menu
        self.SetMenuBar(self.mainmenu)
        #-------------------------------------

        self.sizer = wx.BoxSizer(wx.VERTICAL)

        p = wx.Panel(self, -1)

        self.login = UserLogin(self, -1)
        self.Bind(wx.EVT_BUTTON, self.OnLogin, self.login.b)
        #self.Bind(wx.EVT_TEXT_ENTER, self.OnLogin, self.login.t1)
        self.sizer.Add((100, 0))
        self.sizer.Add(self.login, 1, wx.ALIGN_CENTER_VERTICAL|wx.ALIGN_CENTER_HORIZONTAL)
        self.sizer.Add((100, 0))

        self.SetSizer(self.sizer)
        self.SetAutoLayout(True)
        self.sizer.Fit(p)

        self.Centre(wx.HORIZONTAL)
        self.Show(True)

    def OnLogin(self, evt):
        #self.login.OnGetPassword(evt)
        self.userEmail = self.login.userData['email']
        check = self.login.CheckUser(self.login.OnGetEmail(None))
        if check:
            self.userEmail = self.login.OnGetEmail(None)
	    logger.debug2("should ask password now..")
            self.password = self.login.GetPassword(self)
            self.Bind(wx.EVT_BUTTON, self.__CheckPass, self.login.b)

        else:
            logger.debug2("should popup register win now")
            self.sizer.Detach (0)
            self.sizer.Detach (0)
            self.sizer.Detach (0)
            self.login.Destroy()
            self.register = UserRegister(self)
            self.sizer.Add((100, 0))
            self.sizer.Add(self.register, 1, wx.ALIGN_CENTER_VERTICAL|wx.ALIGN_CENTER_HORIZONTAL)
            self.sizer.Add((100, 0))
            self.sizer.Layout()
            self.sizer.RecalcSizes()

    def __CheckPass(self, evt):
        if self.login.CheckPass(self.login.OnGetPassword(evt)):
	    self.userInfo = {}
	    self.userInfo = self.login.GetUserInfo(self.userEmail)
            self.sizer.Detach (0)
            self.sizer.Detach (0)
            self.sizer.Detach (0)
            self.login.Destroy()
            self.dirlist = dirlist.DirList(self, self.mode)
            self.sizer.Add(self.dirlist, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.EXPAND)
            self.sizer.Layout()
            self.sizer.RecalcSizes()
	else: logger.debug1( "login failed" )
        #if self.login.CheckPass(evt): print "go to next screen"
	#else: print "login failed"

    def OnRip(self, evt):
        self.dirlist.OnRipCD(evt)
    
    def OnSelectDir(self, evt):
        self.dirlist.DirBrowser(evt)
    
    def OnSelectDrive(self, evt):
        self.dirlist.SelectDir(evt)
    
    def OnExit(self, evt):
	#self.Import.CleanCache()
        self.Show(False)
        self.Destroy()

#----------------------------------------------------------------------

