#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
sys.path.append('..')
from ImportCommon import *

from ErrorsHandler import *

import MySQLdb
import os
import wx
import LoadConfig
import dirlist

from DB import DB
DB = DB()

#---------------------------------------------------------------------------

class UserRegister(wx.Panel):
    def OnSetFocus(self, evt):
        print "OnSetFocus"
        evt.Skip()
    def OnKillFocus(self, evt):
        print "OnKillFocus"
        evt.Skip()
    def OnWindowDestroy(self, evt):
        print "OnWindowDestroy"
        evt.Skip()


    def __init__(self, parent):
        wx.Panel.__init__(self, parent, -1, size=wx.Size(500,500), pos=(0,0))

        self.config = LoadConfig.LoadConfig()

	self.userInfo = {
                         'name'     : '',
                         'nickname' : '',
                         'email'    : '',
                         'password' : ''
                        }

        agreementText  = "!!! VERY IMPORTANT !!!\n"
        agreementText += "\n"
        agreementText += "By registering you agree with the following:\n"
        agreementText += "\n"
        agreementText += "* You are _only_ publishing material you've created.\n"
        agreementText += "* You respect copyrights from others.\n"
        agreementText += "\n"

        agreement = wx.StaticText(self, -1, agreementText, pos=(0,0))

        l1 = wx.StaticText(self, -1, "Name", pos=(0,10))
        t1 = wx.TextCtrl(self, -1, self.userInfo['name'], size=(125, -1), pos=(50,10))
        wx.CallAfter(t1.SetInsertionPoint, 0)
        self.tc1 = t1

        #self.Bind(wx.EVT_TEXT, self.EvtText, t1)
        t1.Bind(wx.EVT_CHAR, self.EvtChar)
        #t1.Bind(wx.EVT_SET_FOCUS, self.OnSetFocus)
        #t1.Bind(wx.EVT_KILL_FOCUS, self.OnKillFocus)
        #t1.Bind(wx.EVT_WINDOW_DESTROY, self.OnWindowDestroy)

        l2 = wx.StaticText(self, -1, "Nickname", pos=(0,60))
        t2 = wx.TextCtrl(self, -1, self.userInfo['nickname'], size=(125, -1), pos=(50,60))
        wx.CallAfter(t1.SetInsertionPoint, 0)
        self.tc2 = t2

        l3 = wx.StaticText(self, -1, "E-mail", pos=(0,10))
        t3 = wx.TextCtrl(self, -1, self.userInfo['email'], size=(125, -1), pos=(50,10))
        wx.CallAfter(t1.SetInsertionPoint, 0)
        self.tc3 = t3

        l4 = wx.StaticText(self, -1, "Password", pos=(0,10))
        t4 = wx.TextCtrl(self, -1, self.userInfo['password'], size=(125, -1), pos=(50,10))
        wx.CallAfter(t1.SetInsertionPoint, 0)
        self.tc4 = t4

        b = wx.Button(self, -1, "Register", pos = wx.Point(80, 90))
        self.Bind(wx.EVT_BUTTON, self.OnRegister, b)

        space = 25

        self.sizer = wx.FlexGridSizer(cols=2, hgap=space, vgap=8)
        self.sizer.AddGrowableCol(1, 1)
        self.sizer.Add(agreement, 1, wx.ALIGN_CENTER)
        self.sizer.Add(agreement, 1, wx.ALIGN_CENTER)
        self.sizer.Add(l1, 1, wx.ALIGN_CENTER)
        self.sizer.Add(t1, 1, wx.GROW|wx.BOTTOM)
        self.sizer.Add(l2, 1, wx.ALIGN_CENTER)
        self.sizer.Add(t2, 1, wx.GROW|wx.BOTTOM)
        self.sizer.Add(l3, 1, wx.ALIGN_CENTER)
        self.sizer.Add(t3, 1, wx.GROW|wx.BOTTOM)
        self.sizer.Add(l4, 1, wx.ALIGN_CENTER)
        self.sizer.Add(t4, 1, wx.GROW|wx.BOTTOM)

        self.vsizer = wx.BoxSizer(wx.VERTICAL)
        self.vsizer.Add(self.sizer, 0, wx.EXPAND)
        self.vsizer.Add((0, 25))
        self.vsizer.Add(b, 0, wx.EXPAND, space)

        self.SetSizer(self.vsizer)
        self.SetAutoLayout(True)
        self.vsizer.Fit(self)

    def EvtText(self, event):
        #self.log.WriteText('EvtText: %s\n' % event.GetString())
        print 'EvtText: %s\n' % event.GetString()

    def EvtTextEnter(self, event):
        #self.log.WriteText('EvtTextEnter\n')
        print 'EvtTextEnter\n'
        event.Skip()

    def EvtChar(self, event):
        keycode = event.GetKeyCode()
	
        if keycode == 13:
            self.OnGetValues(event)
        event.Skip()

    def OnGetValues(self, evt):
        self.userInfo['name']     = self.tc1.GetValue()
        self.userInfo['nickname'] = self.tc2.GetValue()
        self.userInfo['email']    = self.tc3.GetValue()
        self.userInfo['password'] = self.tc4.GetValue()

    def OnRegister(self, evt):
        self.OnGetValues(evt)
        logger.debug2( "Should register to database now.." )

        email    = self.userInfo['email']
        password = self.userInfo['password']
        name     = self.userInfo['name']
        nickname = self.userInfo['nickname']

        db = DB.connect()
        cursor = db.cursor()
        sql  = "INSERT INTO netjuke_users SET email='"+email+"', password=md5('"+password+"'), name='"+name+"'"
        sql += ", gr_id=3, created=now(), updated=now(), nickname='"+nickname+"'"
	logger.debug99( "Using SQL query: " + sql )
        cursor.execute(sql)

        self.userInfo['ID']       = db.insert_id()
        self.userInfo['home']     = self.config.musicPath + self.userInfo['nickname']
        self.userInfo['spoolDir'] = self.config.spoolPath + self.userInfo['nickname']

        homedir = self.config.musicPath + nickname
        logger.debug2( "Creating home directory: " + self.userInfo['home'])
        os.mkdir(self.userInfo['home'])

        if True:
            self.vsizer.Detach (0)
            self.sizer.Detach (0)
            self.sizer.Detach (0)
            self.sizer.Detach (0)
            #self.login.Destroy()
            self.dirlist = dirlist.DirList(self)
            self.sizer.Add((100, 0))
            self.sizer.Add(self.dirlist, 1, wx.ALIGN_CENTER_HORIZONTAL|wx.EXPAND)
            self.sizer.Add((100, 0))
            self.sizer.Layout()
            self.sizer.RecalcSizes()

#---------------------------------------------------------------------------

def runTest(frame, nb, log):
    win = UserRegister(nb, log)
    return win

#---------------------------------------------------------------------------


overview = """\
A TextCtrl allows text to be displayed and (possibly) edited. It may be single 
line or multi-line, support styles or not, be read-only or not, and even supports
text masking for such things as passwords.


"""

class MyApp(wx.App):
    def OnInit(self):
        #wx.InitAllImageHandlers()
        frame = wx.Frame(None, -1, "RunDemo: ", pos=(50,50), size=(220,180),
                        style=wx.DEFAULT_FRAME_STYLE)
        self.SetTopWindow(frame)
        frame.Show()
	panel = UserRegister(frame)
        return True


if __name__ == '__main__':
    app = MyApp(0)
    app.MainLoop()

    #import sys,os
    #import run
    #run.main(['', os.path.basename(sys.argv[0])] + sys.argv[1:])

