#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys, os.path
sys.path.append('..')
import  LoadConfig
from ErrorsHandler import *
from ImportCommon import *
from ImportOGG import ImportOGG

from vorbismanager import VorbisManager
from AudioFile import *
from Import import Import
import os
import os.path
import string
import wx
import images
from DriveSelector import *
from MiscTools import *
import gv

import  MySQLdb
import Msg

#---------------------------------------------------------------------------

class MyTreeCtrl(wx.TreeCtrl):
    def __init__(self, parent, id, pos, size, style):
        wx.TreeCtrl.__init__(self, parent, id, pos, size, style)

#---------------------------------------------------------------------------

class DirList(wx.Panel):
    def __init__(self, parent, mode='publish'):
        # Use the WANTS_CHARS style so the panel doesn't eat the Return key.
        self.panel = wx.Panel.__init__(self, parent, style=wx.TAB_TRAVERSAL)

        self.mode     = mode

        self.parent   = parent
        self.userInfo = parent.userInfo
        self.GV       = gv.constants
        self.font     = wx.Font(config.fontSize, wx.FONTFAMILY_DEFAULT,wx.FONTSTYLE_NORMAL,wx.FONTWEIGHT_NORMAL)

        self.config = LoadConfig.LoadConfig()
	self.dir = ''
	self.drive = None
	self.md = {}
	self.Import = Import(self.userInfo)

	self.Import.CleanCache()

        if not os.path.isdir(self.userInfo['spoolDir']):
            logger.debug2( "creating spooldir: %s" % self.userInfo['spoolDir'] )
            os.mkdir(self.userInfo['spoolDir'])

        tID = wx.NewId()

        hsizer = wx.BoxSizer(wx.HORIZONTAL)

        # Tree control with removable media directories
        sizer = wx.BoxSizer(wx.VERTICAL)
        self.tree = MyTreeCtrl(self, tID, wx.DefaultPosition, wx.DefaultSize,
                               wx.TR_HAS_BUTTONS
                               )
        sizer.Add(self.tree, 1, wx.EXPAND)

        self.list = wx.ListCtrl(self, -1, style=wx.LC_REPORT | wx.BORDER_SUNKEN | wx.BORDER_NONE)
        self.list.InsertColumn(0, "Title")
        self.list.InsertColumn(1, "Artist")
        self.list.InsertColumn(2, "Album")
        self.list.InsertColumn(3, "Label")
        self.list.InsertColumn(4, "License")
        sizer.Add(self.list, 2, wx.EXPAND)

        self.Status = wx.StaticText(self, -1, "Status: ")
        sizer.Add(self.Status, 0, wx.EXPAND)
        hsizer.Add(sizer, 1, wx.EXPAND)

        # horizontal separator
        hsizer.Add((12, 0), 0, wx.EXPAND)

        # Vorbis Info panel
        self.vorbispanel = VorbisManager(self, self.mode)
        #self.Bind(wx.EVT_TEXT_ENTER, self.OnWriteComments, self.vorbispanel.t1)
        #self.Bind(wx.EVT_TEXT_ENTER, self.OnWriteComments, self.vorbispanel.t2)
        #self.Bind(wx.EVT_TEXT_ENTER, self.OnWriteComments, self.vorbispanel.t3)
        #self.Bind(wx.EVT_TEXT_ENTER, self.OnWriteComments, self.vorbispanel.t4)
        self.Bind(wx.EVT_BUTTON, self.OnWriteComments, id=self.vorbispanel.WriteID)
        self.Bind(wx.EVT_BUTTON, self.OnImport, id=self.vorbispanel.ImportID)
        #self.Bind(wx.EVT_BUTTON, self.OnRipCD, id=self.vorbispanel.RipCDID)
        self.Bind(wx.EVT_BUTTON, self.OnExit, id=self.vorbispanel.ExitID)
        self.Bind(wx.EVT_BUTTON, self.OnUnimport, id=self.vorbispanel.UnimportID)
        #self.Bind(wx.EVT_BUTTON, self.DirBrowser, id=self.vorbispanel.SelectDriveID)

        self.Bind(wx.EVT_BUTTON, self.Copy, id=self.vorbispanel.CopyArtistID)
        self.Bind(wx.EVT_BUTTON, self.Copy, id=self.vorbispanel.CopyAlbumID)
        self.Bind(wx.EVT_BUTTON, self.Copy, id=self.vorbispanel.CopyLicenceID)
        self.Bind(wx.EVT_BUTTON, self.Copy, id=self.vorbispanel.CopyLabelID)

        self.Bind(wx.EVT_BUTTON, self.vorbispanel.OnEditArtistTag, id=self.vorbispanel.editArtistTagID)
        self.Bind(wx.EVT_BUTTON, self.vorbispanel.OnEditAlbumTag, id=self.vorbispanel.editAlbumTagID)
        self.Bind(wx.EVT_BUTTON, self.vorbispanel.OnEditLabelTag, id=self.vorbispanel.editLabelTagID)

        hsizer.Add(self.vorbispanel, 1, wx.EXPAND)

        # Populate Tree control
        isz = (16,16)
        il = wx.ImageList(isz[0], isz[1])
        self.fldridx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FOLDER,      wx.ART_OTHER, isz))
        self.fldropenidx = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FILE_OPEN,   wx.ART_OTHER, isz))
        self.fileidx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_NORMAL_FILE, wx.ART_OTHER, isz))
        self.smileidx    = il.Add(images.getSmilesBitmap())
        self.sm_up       = il.Add(images.getSmallUpArrowBitmap())
        self.sm_dn       = il.Add(images.getSmallDnArrowBitmap())

        self.tree.SetImageList(il)
        self.il = il

	self.PopulateTree()

	self.tree.SetItemImage(self.root, self.fldridx, wx.TreeItemIcon_Normal)
        self.tree.SetItemImage(self.root, self.fldropenidx, wx.TreeItemIcon_Expanded)

        self.Bind(wx.EVT_TREE_SEL_CHANGED, self.OnActivate, self.tree)
        self.Bind(wx.EVT_TREE_BEGIN_LABEL_EDIT, self.OnBeginEdit, self.tree)
        self.Bind(wx.EVT_TREE_END_LABEL_EDIT, self.OnEndEdit, self.tree)
        self.Bind(wx.EVT_TREE_ITEM_ACTIVATED, self.OnActivate, self.tree)
        self.Bind(wx.EVT_LIST_ITEM_SELECTED, self.ShowFileTags, self.list)
        self.Bind(wx.EVT_LIST_ITEM_ACTIVATED, self.ShowFileTags, self.list)

        self.tree.Bind(wx.EVT_LEFT_DCLICK, self.OnLeftDClick)
        self.tree.Bind(wx.EVT_RIGHT_DOWN, self.OnRightDown)
        self.tree.Bind(wx.EVT_RIGHT_UP, self.OnRightUp)

        self.SetSizer(hsizer)
        self.SetAutoLayout(True)
        hsizer.Fit(self)

	self.Bind(wx.EVT_INIT_DIALOG, self.SelectDir)
	self.InitDialog()

    def Copy(self, evt=None):
        current = self.list.GetFirstSelected()
        if current < 0:
            return

        #self.musicdata[i] = (md['title'], md['artist'], md['license'], file)
	self.md = {}
        field = None
        if evt.GetId() == self.vorbispanel.CopyArtistID:
            field = self.vorbispanel.cb2
            tag = 'artist'
        elif evt.GetId() == self.vorbispanel.CopyAlbumID:
            field = self.vorbispanel.cb3
            tag = 'album'
        elif evt.GetId() == self.vorbispanel.CopyLabelID:
            field = self.vorbispanel.cb4
            tag = 'label'
        elif evt.GetId() == self.vorbispanel.CopyLicenceID:
            field = self.vorbispanel.cb5
            tag = 'license'
        else:
            raise "No fields selected to Copy!!"

        self.vorbispanel.dirty = False
        value = field.GetValue()
        count = self.list.GetItemCount()
        for i in range(count):
            file = self.musicdata[i][5]

            if self.mode is 'publish':
               (imported, metadata) = self.Import.isImported(self.userInfo['nickname'] + file)

               if imported:
                   print "on dirlist.Copy(): ALREADY IMPORTED !! DO NOTHING"
                   self.vorbispanel.dirty = False
                   continue

               # cache each file first, before writing metadata
               if os.path.splitext(file)[1] == ".ogg":
                   file = self.cacheToWrite(file, tag)
            logger.debug5( "in Copy() SetFile to %s!!" % file )
            self.vorbispanel.SetFile(file, "w")

            self.md[tag] = value

            writtenFile = self.vorbispanel.WriteComments(self.md, self.userInfo)

            if self.mode is 'edit':
                logger.debug4( "We are in EDIT mode! Updating database now!" )
                ImportOGG(self.Import, writtenFile, self.userInfo, 'edit')

	self.md = {}

	logger.debug4( "File reloaded!!" )
        self.PopulateList(self.itemData)
        self.list.Select(current)

    def SelectDir(self, evt, dir=None):
        if self.mode is 'edit':
            self.dir = self.userInfo['home']
        else:
            if dir is not None: self.dir = dir
            else: self.DirSelector(evt)

	self.currentDir = self.dir
	self.PopulateTree()
        self.PopulateList(self.dir)

    def DirSelector(self, evt):
	try:
	    dlg = DriveSelector(self)
	    dlg.ShowModal()
	    self.drive = dlg.GetDir()
	    self.dir = self.drive.mountpoint
	    dlg.Destroy()
	except Exception, e:
            logger.error("Trying to choose media device to browse for import, got EXCEPTION: %s" % e)
            self.DirBrowser(evt)

    def DirBrowser(self, evt):
        path = '/AUDIO2'
        srcDir = path
        dlg = wx.DirDialog(None, "Choose a directory:", style=wx.DD_DEFAULT_STYLE|wx.DD_NEW_DIR_BUTTON)
        dlg.SetPath(path)
        if dlg.ShowModal() == wx.ID_OK:
            srcDir = dlg.GetPath()
            logger.debug1( 'You selected: %s\n' % srcDir )
        dlg.Destroy()
        self.dir = srcDir
	self.currentDir = self.dir

        self.PopulateTree()

    def OnRipCD(self, evt):
        logger.debug1( "OnRipCD(): Importing from CD" )

        # check if it is an Audio-CD
        isAudioCD = "cdda2wav dev=%s -J -N -v toc 2>&1 | grep 'This disk has no audio tracks' > /dev/null ; echo $?" % self.config.burnDevice
        logger.debug1( "Checking if it is an Audio-CD... using command: %s" % isAudioCD )
	ret = os.popen(isAudioCD)
	isAudioCD = int( string.strip(ret.read(), "\n") )
	ret.close()
	logger.debug1("isAudioCD = %i" % isAudioCD)
        if isAudioCD == 0:
            Msg.Msg('Publish', 'ERROR: Not an Audio-CD ! Not ripping..', 'Imp', 330, 210, 0)
            logger.debug1( "ERROR: *NOT* an Audio-CD ... not ripping!" )
            return

        # get total amount of tracks
        cmdNumTracks = "cdda2wav dev=%s -J -N -v toc 2>&1 | grep '[0-9]\.(' | xargs --max-args=1 | grep '^[0-9]*\.' | sed 's/\..*$//g' | tail -1" % self.config.burnDevice
	ret = os.popen(cmdNumTracks)
	NumTracks = int( string.strip(ret.read(), "\n") )
	ret.close()
        logger.debug1( "About to rip %s tracks from Audio-CD" % str(NumTracks) )

        for i in range(0, int(NumTracks)):
            trackNumber = i+1
            self.Status.SetLabel("Status: Ripping track %i out of %i!" % (trackNumber, NumTracks))
	    wx.Yield()
	    self.CDRipper(evt, trackNumber)

    def CDRipper(self, evt, trackNumber):

        # we get the discID to create the target directory where the ripped tracks will live
        cmdGetDiscID = "cdda2wav dev=%s -J -N -v toc 2>&1 | grep 'CDDB discid' | awk -F' ' '{print $3}'" % self.config.burnDevice
	ret = os.popen(cmdGetDiscID)
	DiscID = string.strip(ret.read(), "\n")
	ret.close()
	logger.debug3( "Detected DiscID: " + DiscID )

        # set the tmpDir where to rip the files, and create it if not existing
	tmpDir = self.userInfo['spoolDir'] + "/" + DiscID
	self.currentDir = tmpDir
	if not os.path.exists(tmpDir):
            logger.debug3( "tmpDir for user does not exist.. creating: %s" % tmpDir )
            os.makedirs(tmpDir)

        bitrate = 256
	tracksList  = 'LIST="%s"' % trackNumber
        encoderOpts = 'MP_OPTIONS="-b %i"' % bitrate
	CDdrive     = 'CDDA_DEVICE="%s"' % self.config.burnDevice
        convertOpts = encoderOpts + " " + CDdrive
	#cmd = "cd " + tmpDir + " ; " + tracksList + " " + convertOpts + " " + "cdda2ogg"
        #cmd = "cd %s ; MP_OPTIONS=\"-b 256\" CDDA_DEVICE=%s cdda2ogg" % (tmpDir, self.config.burnDevice)
	#cmd = '#Ripping command disabled. Would be: %s"' % cmd

	cd2wav  = 'cdda2wav dev=%s -H -P0 -q -t%i - ' % (self.config.burnDevice, trackNumber)

        oggBitrate = 256
	wav2ogg = '/usr/bin/oggenc - -b %i -o %s/%i-audiotrack.ogg' % (oggBitrate, tmpDir, trackNumber)
	cmd     = cd2wav + ' | ' + wav2ogg
        logger.debug3( "Audio-CD ripping command: %s" % cmd )
	
	if os.system(cmd) == 0:
            logger.debug1( "Done! Successfully grabbed audio-CD" )
            logger.debug2( "Setting source dir to: %s" % tmpDir )
	    # it is an Audio-CD so, no subdirs, show what is on the root
            self.Status.SetLabel("Status: Ripped Audio-CD successfully!")
            self.SelectDir(evt, tmpDir)
            self.itemData = self.tree.GetPyData(self.root)
            self.PopulateList(self.itemData)
        else:
            logger.debug1( "ERROR ! There was a problem grabbing from audio-CD" )
    
    def OnImport(self, evt):
        logger.debug3( "dirlist: should import now... using current dir: %s" % self.currentDir )
	self.Import.Process(self.currentDir, self.Status)
        self.PopulateList(self.currentDir)
	if self.drive is not None:
	    self.drive.umount()
	self.drive = None
	self.dir = ''

    def OnExit(self, evt):
	self.Import.CleanCache()
        self.parent.Show(False)
        self.parent.Destroy()
        #sys.exit(0)

    def OnUnimport(self, evt):
	self.Import.Unimport(self.selectedFile)
        self.PopulateList(self.currentDir)

    def cacheToWrite(self, file, tag=None):
        '''
        cache the file, set to it, but get the user-edited tags before file tags are read in,
        so that we can save the user-edited tags into it
        '''

	name, ext  = os.path.splitext(file)

        if ext.lower() == '.ogg':
            cached = cacheToSpool(file, self.userInfo['spoolDir'])
	    if tag is None: self.rescueTags(cached)
	    return cached
        elif ext.lower() == '.mp3':
            self.md = self.vorbispanel.OnGetValues(None)

    def rescueTags(self, cached):
        if True:
                self.md = self.vorbispanel.OnGetValues(None)
                self.vorbispanel.dirty = False
		print "in rescueTags() setting file for writing to: %s" % cached
                self.vorbispanel.SetFile(cached, "w")

    def OnWriteComments(self, evt):
        '''if .ogg, we cache it to spoolDir!"
           ... if .mp3, let MP3File class do the job (caching tags in DB)
           file is: %s" % self.selectedFile
        '''

        if self.mode is 'publish':
            (imported, metadata) = self.Import.isImported(self.userInfo['nickname'] + self.selectedFile)
            if imported:
                print "on dirlist.OnWriteComments(): ALREADY IMPORTED !! DO NOTHING"
                self.vorbispanel.dirty = False
                return

            # assuming either that source files reside on a non-writeable media
            # or we don't want to alter his files directly, we cache them before
            # saving any metadata to them
            self.cacheToWrite(self.selectedFile)
        elif self.mode is 'edit':
            self.md = self.vorbispanel.OnGetValues(None)

        # perform tags writing to cached file
        writtenFile = self.vorbispanel.WriteComments(self.md, self.userInfo)
        #try: writtenFile = self.vorbispanel.WriteComments(self.userInfo)
        #except Exception, e: logger.debug1("ERROR: on dirlist.OnWriteComments() got exception: "+str(e))
        #self.PopulateTree() FIXME : disabled by rama.. remove?
        self.vorbispanel.SetFile(writtenFile)

        if self.mode is 'edit':
            logger.debug4( "We are in EDIT mode! Updating database now!" )
            ImportOGG(self.Import, writtenFile, self.userInfo, 'edit')

	logger.debug4( "File reloaded after writting metadata!!" )

        self.PopulateList(self.dir)

    def PopulateList(self, dir):
        dirlist = os.listdir(dir)

        self.list.DeleteAllItems()
        self.musicdata = {}
        i = 0
        for x in dirlist:
            name, ext  = os.path.splitext(x)

            if x != get_ascii_filename(x):
                continue

            if ext.lower() == '.ogg' or ext.lower() == '.mp3':
                file = dir +'/'+ x
		tmpfile = self.userInfo['spoolDir'] + file

                if os.path.isfile(tmpfile):
                    af = AudioFile(tmpfile)
                else:
                    af = AudioFile(file)

                md = af.read_comments()

                if md['title'] == '': md['title'] = os.path.basename(file)

                if self.mode is 'publish':
                    (imported, metadata) = self.Import.isImported(self.userInfo['nickname'] + file)
                    if imported == 1: md = metadata
                elif self.mode is 'edit':
                    imported = 1

                title = md['title']
                artist = md['artist']
                album = md['album']
                label = md['label']
                license = md['license']

                self.musicdata[i] = (title, artist, album, label, license, file, imported)
                i = i + 1

        items = self.musicdata.items()
        for key, data in items:
	    try: data0 = unicode(data[0], 'utf8')
	    except: data0 = data[0]

            index = self.list.InsertImageStringItem(sys.maxint, data0, self.smileidx)
            self.list.SetStringItem(index, 1, data[1])
            self.list.SetStringItem(index, 2, data[2])
            self.list.SetStringItem(index, 3, data[3])
            self.list.SetStringItem(index, 4, data[4])
            self.list.SetItemData(index, key)

	    green = wx.Colour(52, 212, 52)
	    yellow = wx.Colour(226, 227, 56)

            if data[6]:
                if data[0] == 'N/A' or data[2] == 'N/A' or data[4] == 'N/A':
                    self.list.SetItemTextColour(index, yellow)
                else:
                    self.list.SetItemTextColour(index, green)
            else:
                if data[0] == '' or data[1] == '' or data[4] == '' :
                    # this item has incomplete tags, set its colour to red
                    self.list.SetItemTextColour(index, wx.RED)
                else:
                    self.list.SetItemTextColour(index, wx.BLUE)

            # FIXME this sets black font to everything, not desired
            #self.list.SetItemFont(index, self.font)

        self.list.SetColumnWidth(0, wx.LIST_AUTOSIZE)
        self.list.SetColumnWidth(1, wx.LIST_AUTOSIZE)
        self.list.SetColumnWidth(2, wx.LIST_AUTOSIZE)
        self.list.SetColumnWidth(3, wx.LIST_AUTOSIZE)
        self.list.SetColumnWidth(4, wx.LIST_AUTOSIZE)

    def PopulateTree(self):
        # NOTE:  For some reason tree items have to have a data object in
        #        order to be sorted.  Since our compare just uses the labels
        #        we don't need any real data, so we'll just use None below for
        #        the item data.
        logger.debug4( "About to PopulateTree() using dir: %s" % self.dir )
        self.tree.DeleteAllItems()
        name = "Removable Device"
	if self.drive is not None:
	    name = self.drive.name
	self.root = self.tree.AddRoot(name, data = wx.TreeItemData(self.dir))
        self.tree.SetItemFont(self.root, self.font)

	if self.dir == '': return

        def _add_dir(root_item, current_dir):
            for d in os.listdir(current_dir):
                # FIXME files with special chars dont work

                #real_dir = os.path.join(current_dir, get_ascii_filename(d))
                real_dir = os.path.join(current_dir, uniconvert2(d))

                if d == '.' or d == '..': continue
                if not os.path.isdir(real_dir): continue
                if d[0] == '.': continue

                try:
                    child = self.tree.AppendItem(root_item, d, data = wx.TreeItemData(real_dir))
                    self.tree.SetItemImage(child, self.fldridx, wx.TreeItemIcon_Normal)
                    self.tree.SetItemImage(child, self.fldropenidx, wx.TreeItemIcon_Expanded)
                    self.tree.SetItemFont(child, self.font)
                    _add_dir(child, real_dir)
                except Exception, e:
                    logger.error("while trying to read: " + d + " . Got exception: " + str(e) + " " + str(Exception) )
                    logger.debug("ASCII-converted string follows: %s" % get_ascii_filename(d) )

        _add_dir(self.root, self.dir)
            
        self.tree.Expand(self.root)

    def HasRequiredFields(self, path):
        #required = ['TITLE', 'ARTIST', 'ALBUM', 'LABEL', 'LICENSE', 'COMMENT']
        required = ['TITLE', 'ARTIST', 'LICENSE']
        ogg = AudioFile(path)
        metadata = ogg.read_comments()
        ret = []
        for i in required:
            if i not in metadata.keys():
                ret.append(i)
        return ret

    def OnRightDown(self, event):
        pt = event.GetPosition();
        item, flags = self.tree.HitTest(pt)
        if item:
            self.tree.SelectItem(item)


    def OnRightUp(self, event):
        pt = event.GetPosition();
        item, flags = self.tree.HitTest(pt)
        if item:
            self.tree.EditLabel(item)

    def OnBeginEdit(self, event):
        # show how to prevent edit...
        item = event.GetItem()
        if item and self.tree.GetItemText(item) == "The Root Item":
            wx.Bell()

            # Lets just see what's visible of its children
            cookie = 0
            root = event.GetItem()
            (child, cookie) = self.tree.GetFirstChild(root)

            while child.IsOk():
                (child, cookie) = self.tree.GetNextChild(root, cookie)

            event.Veto()


    def OnEndEdit(self, event):
        # show how to reject edit, we'll not allow any digits
        for x in event.GetLabel():
            if x in string.digits:
                event.Veto()
                return


    def OnLeftDClick(self, event):
        pt = event.GetPosition();
        item, flags = self.tree.HitTest(pt)
        if item:
            parent = self.tree.GetItemParent(item)
            if parent.IsOk():
                self.tree.SortChildren(parent)
		self.tree.Expand(item)
        event.Skip()

    def OnSelChanged(self, event):
        self.item = event.GetItem()
        if self.item:
            if wx.Platform == '__WXMSW__': pass
            #items = self.tree.GetSelections()
        event.Skip()


    def OnActivate(self, event):
        logger.debug4("OnActivate")
        self.item = event.GetItem()
        if self.item:
            self.itemData = self.tree.GetPyData(self.item)
            print "itemData"
            print self.itemData
            self.currentDir = self.itemData
            logger.debug4( "Now browsing dir: %s" % self.currentDir )

            # set to no selected file and reset tags display
            self.vorbispanel.SetFile(None)

            self.PopulateList(self.itemData)
            self.tree.Expand(self.item)

    def ShowFileTags(self, l):
        current = self.list.GetFirstSelected()
        if current < 0: return

        data = self.list.GetItemData(current)
        f = self.musicdata[data][5]

        if self.mode is 'publish':
            self.selectedFile = self.Import.isCached(f)
            (imported, metadata) = self.Import.isImported(self.userInfo['nickname'] + f)
            if imported: self.selectedFile = self.userInfo['home'] + os.path.splitext(f)[0] + ".ogg"
        elif self.mode is 'edit':
            self.selectedFile = f

        try: self.vorbispanel.SetFile(self.selectedFile)
        except Exception, e: logger.debug1("ERROR: on dirlist.ShowFileTags() got exception: "+str(e))

        return True

#---------------------------------------------------------------------------

def runTest(frame, nb, log):
    win = DirList(nb, log)
    return win

#---------------------------------------------------------------------------





overview = """\
A TreeCtrl presents information as a hierarchy, with items that may be 
expanded to show further items. Items in a tree control are referenced by 
wx.TreeItemId handles.

"""


class MyApp(wx.App):
    def OnInit(self):
        #wx.InitAllImageHandlers()
        frame = wx.Frame(None, -1, "RunDemo: ", pos=(50,50), size=(640,480),
		                            style=wx.DEFAULT_FRAME_STYLE)
        self.SetTopWindow(frame)
        frame.Show()
        panel = DirList(frame,-1)
        return True

if __name__ == '__main__':
    app = MyApp(0)
    app.MainLoop()

