#!/usr/bin/python
# -*- coding: utf-8 -*-

import  sys
sys.path.append('..')
from ErrorsHandler import *
from ImportCommon import *

from AudioFile import *
from MiscTools import *

import  wx
import os.path

from InfoManager import *

#---------------------------------------------------------------------------

class VorbisManager(wx.Panel):
    def OnSetFocus(self, evt):
        print "OnSetFocus"
        evt.Skip()
    def OnKillFocus(self, evt):
        print "OnKillFocus"
        evt.Skip()
    def OnWindowDestroy(self, evt):
        print "OnWindowDestroy"
        evt.Skip()


    def __init__(self, parent, mode='publish'):
        wx.Panel.__init__(self, parent, -1)

	self.mode     = mode
	self.userInfo = parent.userInfo

        self.fn       = None
        self.metadata = {}
        self.dirty    = False

        #--------- START FILE ---------------------------------------------------------------#
        l0 = wx.StaticText(self, -1, "File")
        self.t0 = wx.StaticText(self, -1, "")
        #--------- END FILE -----------------------------------------------------------------#

        #--------- START TITLE --------------------------------------------------------------#
        l1 = wx.StaticText(self, -1, "Title")
        #t1 = wx.TextCtrl(self, -1, style=wx.TE_PROCESS_ENTER)
        t1 = wx.TextCtrl(self, -1)
        wx.CallAfter(t1.SetInsertionPoint, 0)
        t1.Bind(wx.EVT_TEXT, self.OnTextChanged)
        t1.Bind(wx.EVT_CHAR, self.EvtChar)
        self.t1 = t1
        #--------- END TITLE ----------------------------------------------------------------#

        #--------- START ARTIST --------------------------------------------------------------#
        defaultArtist = "N/A"
        l2 = wx.StaticText(self, -1, "Artist")
        self.cb2 = wx.ComboBox(self, 500, '', (90, 50), (95, -1), '', wx.CB_DROPDOWN | wx.CB_SORT )
        self.CopyArtistID = wx.NewId()
        self.bt2 = wx.Button(self, self.CopyArtistID, "Apply to all files in the directory")
        self.editArtistTagID = wx.NewId()
        self.editArtistTag = wx.Button(self, self.editArtistTagID, "Edit Artist Tag")
        self.populateCombo('artists')
        self.cb2.SetStringSelection(defaultArtist)
        self.Bind(wx.EVT_COMBOBOX, self.EvtComboBox, self.cb2)
        #--------- END ARTIST ----------------------------------------------------------------#

        #--------- START ALBUM ----------------------------------------------------------------#
        defaultAlbum = "N/A"
        l3 = wx.StaticText(self, -1, "Album")
        self.cb3 = wx.ComboBox(self, 500, '', (90, 50), (95, -1), '', wx.CB_DROPDOWN | wx.CB_SORT )
        self.CopyAlbumID = wx.NewId()
        self.bt3 = wx.Button(self, self.CopyAlbumID, "Apply to all files in the directory")
        self.editAlbumTagID = wx.NewId()
        self.editAlbumTag = wx.Button(self, self.editAlbumTagID, "Edit Album Tag")
        self.populateCombo('albums')
        self.cb3.SetStringSelection(defaultAlbum)
        self.Bind(wx.EVT_COMBOBOX, self.EvtComboBox, self.cb3)
        #--------- END ALBUM ------------------------------------------------------------------#

        #--------- START LABEL ----------------------------------------------------------------#
        defaultLabel = "N/A"
        l4 = wx.StaticText(self, -1, "Label")
        self.cb4 = wx.ComboBox(self, 500, '', (90, 50), (95, -1), '', wx.CB_DROPDOWN | wx.CB_SORT )
        self.CopyLabelID = wx.NewId()
        self.bt4 = wx.Button(self, self.CopyLabelID, "Apply to all files in the directory")
        self.editLabelTagID = wx.NewId()
        self.editLabelTag = wx.Button(self, self.editLabelTagID, "Edit Label Tag")
        self.populateCombo('labels')
        self.cb4.SetStringSelection(defaultLabel)
        self.Bind(wx.EVT_COMBOBOX, self.EvtComboBox, self.cb4)
        #--------- END LABEL ------------------------------------------------------------------#

        #--------- START LICENSE --------------------------------------------------------------#
        defaultLicense = "N/A"

        l5 = wx.StaticText(self, -1, "License")
        cb5 = wx.ComboBox(self, 500, '', (90, 50), (95, -1), '', wx.CB_DROPDOWN | wx.CB_READONLY | wx.CB_SORT )
        self.cb5 = cb5
        self.CopyLicenceID = wx.NewId()
        self.bt5 = wx.Button(self, self.CopyLicenceID, "Apply to all files in the directory")
        self.populateCombo('licenses')
        self.cb5.SetStringSelection(defaultLicense)
        self.Bind(wx.EVT_COMBOBOX, self.EvtComboBox, self.cb5)
        #--------- END LICENSE --------------------------------------------------------------#

        #--------- START COMMENTS -----------------------------------------------------------#
        l20 = wx.StaticText(self, -1, "Comments")
        t20 = wx.TextCtrl(self, -1, style=wx.TE_MULTILINE)
        t20.Bind(wx.EVT_TEXT, self.OnTextChanged)
        self.t20 = t20
        #--------- END COMMENTS -------------------------------------------------------------#
  
        #--------- START TAGS SIZER ---------------------------------------------------------#
        space = 8
        sizer = wx.FlexGridSizer(cols=2, hgap=space, vgap=space)
        sizer.AddGrowableCol(1, 1)

        sizer.Add(l0, 0, wx.EXPAND)
        sizer.Add(self.t0, 1, wx.EXPAND)

        sizer.Add(l1, 0, wx.EXPAND)
        sizer.Add(t1, 1, wx.EXPAND)

        sizer.Add(l2, 0, wx.EXPAND)
        sizer.Add(self.cb2, 1, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.bt2, 1, wx.EXPAND)

        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.editArtistTag, 1, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add((1,1), 1, wx.EXPAND)

        sizer.Add(l3, 0, wx.EXPAND)
        sizer.Add(self.cb3, 1, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.bt3, 1, wx.EXPAND)

        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.editAlbumTag, 1, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add((1,1), 1, wx.EXPAND)

        sizer.Add(l4, 0, wx.EXPAND)
        sizer.Add(self.cb4, 1, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.bt4, 1, wx.EXPAND)

        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.editLabelTag, 1, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add((1,1), 1, wx.EXPAND)

        sizer.Add(l5, 0, wx.EXPAND)
        sizer.Add(cb5, 1, wx.EXPAND)
        sizer.Add((1,1), 0, wx.EXPAND)
        sizer.Add(self.bt5, 1, wx.EXPAND)

        sizer.Add(l20, 0, wx.EXPAND)
        sizer.Add(t20, 1, wx.EXPAND)
        #--------- END TAGS SIZER -----------------------------------------------------------#

        #--------- START BUTTONS ------------------------------------------------------------#
        '''
        self.RipCDID = wx.NewId()
        b0 = wx.Button(self, self.RipCDID, "Get from Audio-CD")
        '''

        self.WriteID = wx.NewId()
        b1 = wx.Button(self, self.WriteID, "Save (write tags) to file")

        self.ImportID = wx.NewId()
        b2 = wx.Button(self, self.ImportID, "Publish Now !")

        self.ExitID = wx.NewId()
        b3 = wx.Button(self, self.ExitID, "Finished.. exit.")

        self.UnimportID = wx.NewId()
        b4 = wx.Button(self, self.UnimportID, "Unimport.")

        '''
        self.SelectDriveID = wx.NewId()
        b5 = wx.Button(self, self.SelectDriveID, "Change Drive/Directory")
        '''
        #--------- START BUTTONS ------------------------------------------------------------#

        #--------- START BUTTONS SIZER ------------------------------------------------------#
        border = wx.BoxSizer(wx.VERTICAL)
        border.Add(sizer, 1, wx.EXPAND)
        #border.Add(b0, 0, wx.EXPAND, 25)
        border.Add(b1, 0, wx.EXPAND, 25)
        border.Add(b2, 0, wx.EXPAND, 25)
        border.Add(b3, 0, wx.EXPAND, 25)
        border.Add(b4, 0, wx.EXPAND, 25)
        #border.Add(b5, 0, wx.EXPAND, 25)
        self.SetSizer(border)
        self.SetAutoLayout(True)
        #--------- END BUTTONS SIZER --------------------------------------------------------#

    def OnEditArtistTag(self, evt):
        self.im = InfoManager(None, 'artist', self.userInfo, self.itemLabel)
        self.im.Bind(wx.EVT_BUTTON, self.im.OnExit, id=self.im.ExitID)

    def OnEditAlbumTag(self, evt):
        self.im = InfoManager(None, 'album', self.userInfo, self.itemLabel)
        self.im.Bind(wx.EVT_BUTTON, self.im.OnExit, id=self.im.ExitID)

    def OnEditLabelTag(self, evt):
        self.im = InfoManager(None, 'label', self.userInfo, self.itemLabel)
        self.im.Bind(wx.EVT_BUTTON, self.im.OnExit, id=self.im.ExitID)

    def populateCombo(self, combo):
        if combo == 'artists':
            self.cb2.Clear()
            for artist in getList(combo): self.cb2.Append(uniconvert2(artist[1]), artist[0])
        elif combo == 'albums':
            self.cb3.Clear()
            for album in getList(combo): self.cb3.Append(uniconvert2(album[1]), album[0])
        elif combo == 'labels':
            self.cb4.Clear()
            for label in getList(combo): self.cb4.Append(uniconvert2(label[1]), label[0])
        elif combo == 'licenses':
            self.cb5.Clear()
            for license in getList(combo): self.cb5.Append(uniconvert2(license[1]), license[0])

    def EvtComboBox(self, evt):
        cb = evt.GetEventObject()
        data = cb.GetClientData(cb.GetSelection())
        self.itemLabel = evt.GetString()
        #print('EvtComboBox: %s / ClientData: %s\n' % (label, data))

    def SetFile(self, fn, mode='r'):
        ret = False
        if self.dirty:
            dlg = wx.MessageDialog(self, "Save metadata?", "Metadata has changed!")
            if dlg.ShowModal() == wx.ID_OK:
                self.WriteComments(self.userInfo)
                ret = True

        if True:# self.fn is not None:
            if fn is None:
                self.fn = fn

                for key in self.metadata.keys():
                    self.metadata[key] = ''

                self.t0.SetLabel('')
                self.t1.SetValue('')
                self.cb2.SetStringSelection('')
                self.cb3.SetStringSelection('')
                self.cb4.SetStringSelection('')
                self.cb5.SetStringSelection('')
                self.t20.SetValue('')

                return
        
        self.fn   = fn
        self.file = os.path.basename(fn)

	# open ogg file
        self.open_ogg(mode)

        self.t0.SetLabel(self.file)

        if len(self.metadata['title']) == 0: self.metadata['title'] = os.path.basename(fn)
        self.t1.SetValue(self.metadata['title'])
        wx.CallAfter(self.t1.SetInsertionPoint, 0)

        #-----------------------------------------
        artist = ''
        if 'artist' in self.metadata.keys():
            artist = self.metadata['artist']
            artistID = getID('artists', artist)
            self.populateCombo('artists')
            if artist is '': artist = "N/A"
	logger.debug2( "setting artist to: %s (ID=%s)" % (artist,artistID) )
        self.cb2.SetStringSelection(artist)
        #-----------------------------------------
        album = ''
        if 'album' in self.metadata.keys():
            album = self.metadata['album']
            albumID = getID('albums', album)
            self.populateCombo('albums')
            if album is '': album = "N/A"
	logger.debug2( "setting album to: %s (ID=%s)" % (album,albumID) )
        self.cb3.SetStringSelection(album)
        #-----------------------------------------
        label = ''
        if 'label' in self.metadata.keys():
            label = self.metadata['label']
            labelID = getID('labels', label)
            self.populateCombo('labels')
            if label is '': label = "N/A"
	logger.debug2( "setting label to: %s (ID=%s)" % (label,labelID) )
        self.cb4.SetStringSelection(label)
        #-----------------------------------------
        license = ''
        if 'license' in self.metadata.keys():
            license = self.metadata['license']
            self.populateCombo('licenses')
            licenseID = getID('licenses', license)
            if license is '': license = "N/A"
	logger.debug2( "setting license to: %s (ID=%s)" % (license,licenseID) )
        self.cb5.SetStringSelection(license)
        #-----------------------------------------

        if 'comment' in self.metadata.keys() and self.metadata['comment'] is not None:
            self.t20.SetValue(self.metadata['comment'])

        #self.Bind(wx.EVT_TEXT, self.EvtText, t20)
        #self.Bind(wx.EVT_TEXT_ENTER, self.EvtTextEnter, t20)
        self.dirty = False
        return ret

    def open_ogg(self, mode="r"):
	logger.debug2( "in vorbismanager.open_ogg() about to open %s" % self.fn )
        self.af = AudioFile(self.fn, self.mode)

        if mode == 'r':
            # read current vorbiscomments (metadata) from the file
            # otherwise for writing into the file, we do not read them.
            self.metadata = self.af.read_comments()

    def OnTextChanged(self, event):
	#logger.debug2("in vorbismanager.OnTextChanged() metatags are dirty now!")
        #self.dirty = True
        pass

    def EvtTextEnter(self, event):
        #self.log.WriteText('EvtTextEnter\n')
        print 'EvtTextEnter\n'
        event.Skip()

    def EvtChar(self, event):
        keycode = event.GetKeyCode()
	
        if keycode == 13:
            self.OnGetValues(event)
        event.Skip()

    def OnGetValues(self, evt):
        metadata = {}
        metadata['title']   = self.t1.GetValue()
        metadata['artist']  = self.cb2.GetValue()
        metadata['album']   = self.cb3.GetValue()
        metadata['label']   = self.cb4.GetValue()
        metadata['license'] = self.cb5.GetValue()
        metadata['comment'] = self.t20.GetValue()

        return metadata

    def WriteComments(self, metadata, userInfo):
        '''Will copy exact tree to tmp before writing VorbisComments to file'''

        #self.OnGetValues(evt=None)

        # write the vorbiscomments to vorbisfile
        writtenFile = self.af.write_comments(metadata, userInfo)
        self.dirty = False

	return writtenFile

    def OnTestWriteText(self, evt):
        self.t.WriteText("TEXT")

    def OnTestGetSelection(self, evt):
        start, end = self.t.GetSelection()
        text = self.t.GetValue()
        if wx.Platform == "__WXMSW__":  # This is why GetStringSelection was added
            text = text.replace('\n', '\r\n')

        #self.log.write("multi-line GetSelection(): (%d, %d)\n"
        print "multi-line GetSelection(): (%d, %d)\n\tGetStringSelection(): %s\n\tSelectedText: %s\n" % (start, end, self.t.GetStringSelection(), repr(text[start:end]))

        start, end = self.t1.GetSelection()
        text = self.t1.GetValue()

        if wx.Platform == "__WXMSW__":  # This is why GetStringSelection was added
            text = text.replace('\n', '\r\n')

        #self.log.write("single-line GetSelection(): (%d, %d)\n"
        print "single-line GetSelection(): (%d, %d)\n\tGetStringSelection(): %s\n\tSelectedText: %s\n" % (start, end, self.t1.GetStringSelection(), repr(text[start:end]))


    def OnT5LeftDown(self, evt):
        evt.Skip()
        wx.CallAfter(self.LogT5Position, evt)

    def LogT5Position(self, evt):
        text = self.t5.GetValue()
        ip = self.t5.GetInsertionPoint()
        lp = self.t5.GetLastPosition()
        #self.log.write("LogT5Position:\n"
        print "LogT5Position:\n\tGetInsertionPoint:\t%d\n\ttext[insertionpoint]:\t%s\n\tGetLastPosition:\t%d\n\tlen(text):\t\t%d\n" % (ip, text[ip], lp, len(text))


#---------------------------------------------------------------------------

def runTest(frame, nb, log):
    win = VorbisManager(nb, log)
    return win

#---------------------------------------------------------------------------


overview = """\
A TextCtrl allows text to be displayed and (possibly) edited. It may be single 
line or multi-line, support styles or not, be read-only or not, and even supports
text masking for such things as passwords.


"""

class MyApp(wx.App):
    def OnInit(self):
        #wx.InitAllImageHandlers()
        frame = wx.Frame(None, -1, "RunDemo: ", pos=(50,50), size=(640,480),
                        style=wx.DEFAULT_FRAME_STYLE)
        self.SetTopWindow(frame)
        frame.Show()
	panel = VorbisManager(frame,-1,'test3.ogg')
        return True


if __name__ == '__main__':
    app = MyApp(0)
    app.MainLoop()

    #import sys,os
    #import run
    #run.main(['', os.path.basename(sys.argv[0])] + sys.argv[1:])

