#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, os.path
import MySQLdb
import wx
import wx.html
import gv
import urllib
import re

import  LoadConfig
config = LoadConfig.LoadConfig()

from Audio import AudioPlayer
Player = AudioPlayer()

import FocusManager
from ImageAlpha import *
from InfoPage import *
from InfoPage2 import *

import Msg

# Add an extra an useful method to wxTreeCtrl :)
def _TreeMoveNextItem(self):
    current = self.GetSelection()
    new = None
    if self.GetChildrenCount(current, False) == 0:
	# Item is a leaf
        new = self.GetNextSibling(current)
        while not new:
	    new = self.GetItemParent(current)
	    current = new
	    new = self.GetNextSibling(new)
    else:
	if self.IsExpanded(current):
	    # Move to the first child
	    new = self.GetFirstChild(current)[0]
	else:
	    # Move to the next brother
	    new = self.GetNextSibling(current)
            if not new:
		new = self.GetItemParent(current)
		new = self.GetNextSibling(new)

    # Set selection
    if new:
        self.SelectItem(new)
wx.TreeCtrl.MoveNext = _TreeMoveNextItem

def _TreeMovePrevItem(self):
    current = self.GetSelection()
    new = self.GetPrevSibling(current)
    if not new:
	new = self.GetItemParent(current)
    if new:
	self.SelectItem(new)
wx.TreeCtrl.MovePrev = _TreeMovePrevItem

def _TreeJoyRight(self):
    current = self.GetSelection()
    if current:
        itemData = self.GetPyData(current)
	itemType = itemData['type']
	if itemType != 'song':
	    if self.IsExpanded(current):
		#self.Collapse(current)
		# don't collapse it again if already open
		pass
	    else:
		self.Expand(current)
	else:
	    raise Exception, "Play"
wx.TreeCtrl.JoyRight= _TreeJoyRight

def _TreeJoyLeft(self):
    current = self.GetSelection()
    if current:
        itemData = self.GetPyData(current)
        itemType = itemData['type']
        if itemType != 'song':
            # if not a song, might be label, artist or album, so might be expanded to display children
            if self.IsExpanded(current):
                logger.debug2("item is expanded.. collapsing\n\n")
                self.Collapse(current)
            else:
                logger.debug2("item is collapsed.. stopping\n\n")
                raise Exception, "Stop"
        else: 
           logger.debug2("item is a song, not collapsable.. stopping")
           raise Exception, "Stop"
wx.TreeCtrl.JoyLeft = _TreeJoyLeft

def _InfoPanelJoyLeft(self):
    raise Exception, "Stop"
wx.Panel.JoyLeft = _InfoPanelJoyLeft

def _InfoPanelJoyRight(self):
    raise Exception, "Play"
wx.Panel.JoyRight = _InfoPanelJoyRight

def _ListMovePrevItem(self):
    current = self.GetFirstSelected()
    if current == -1: return

    new = current - 1
    if new >= 0:
        self.Select(new)
wx.ListView.MovePrev = _ListMovePrevItem

def _ListJoyRight(self):
    current = self.GetFirstSelected()
    if current == -1: return
    raise Exception, "Play"
wx.ListView.JoyRight = _ListJoyRight

def _ListJoyLeft(self):
    current = self.GetFirstSelected()
    if current == -1: return
    raise Exception, "Stop"
wx.ListView.JoyLeft = _ListJoyLeft

def _ListMoveNextItem(self):
    current = self.GetFirstSelected()
    if current == -1: return

    new = current + 1
    if new > self.GetItemCount(): return

    self.Select(new)
wx.ListView.MoveNext = _ListMoveNextItem

#
# Panels from here!
#

class PlayListPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

	self.SelectedTrack  = None
        self.lastSelection  = None
	self.count          = 0
	self.length         = int(0)
	self.MaxLength      = int(config.MaxPlLength)
	self.size           = int(0)
	self.MaxSize        = float(config.MaxPlSize)
        self.AudioWarned    = 0
        self.AudioOversized = 0
        self.SizeWarned     = 0
        self.DataOversized  = 0

        sizer = wx.BoxSizer(wx.VERTICAL)

        # Title Label
        self.title = wx.StaticText(self)
        self.title.SetLabel("Playlist #%i" % gv.constants.NewPlaylistID)
        font = self.title.GetFont()
        font.SetPointSize(int(font.GetPointSize() * 1.2))
        font.SetWeight(wx.FONTWEIGHT_BOLD)
        self.title.SetFont(font)
        self.title.SetBackgroundStyle(wx.BG_STYLE_COLOUR)
        self.title.SetBackgroundColour(self.GetBackgroundColour())
        sizer.Add(self.title, 0, wx.EXPAND)

        # ListView to show the playlist
        self.list = wx.ListView(self, -1, style=wx.LC_REPORT | wx.LC_SINGLE_SEL)
	self.list.Bind(wx.EVT_LIST_ITEM_SELECTED, self.OnTrackSelected)
	self.list.Bind(wx.EVT_SET_FOCUS, lambda x: FocusManager.manager.SetFocus("PlayList"))
	FocusManager.manager.Register("PlayList", self.list)

        sizer.Add(self.list, 1, wx.EXPAND)

        # Player volume
        self.PlayVolume  = wx.Slider(self, 0, 0, 0, 100, (0, 0), (250, -1), wx.SL_HORIZONTAL | wx.SL_AUTOTICKS)
        # Set position according to current volume
        self.PlayVolume.SetValue(Player.getVolume())
        sizer.Add(self.PlayVolume, 0, wx.EXPAND)
        self.PlayVolume.Bind(wx.EVT_SCROLL_THUMBTRACK, self.OnPlayVolume)

        # Player status bar
        self.playbar  = wx.Slider(self, 0, 0, 0, 100, (0, 0), (250, -1),
	            wx.SL_HORIZONTAL | wx.SL_AUTOTICKS)
        sizer.Add(self.playbar, 0, wx.EXPAND)

        # ProgressBar to show the % complete
        self.capacity = wx.Gauge(self, -1, float(gv.constants.config.MaxPlSize), size=(10, 10))
        sizer.Add(self.capacity, 0, wx.EXPAND)

        # A human-redeable legend
        self.legend= wx.StaticText(self, size=(500,20))
        sizer.Add(self.legend, 0, wx.EXPAND)

        # Playlist control buttons
	self.RemoveID = wx.NewId()
	#self.RefreshID = wx.NewId() # FIXME should probably be not here
	#self.ImportID = wx.NewId() # FIXME should probably be not here
	#self.EditID = wx.NewId() # FIXME should probably be not here
	self.PlayID = wx.NewId()
	self.StopID = wx.NewId()
	self.SeekID = wx.NewId()
	self.RandomID = wx.NewId()
	self.PlayContID = wx.NewId()
        buttonBox       = wx.Panel(self)
        #self.Refresh    = wx.Button(buttonBox, self.RefreshID, "Refresh")
        #self.Import     = wx.Button(buttonBox, self.ImportID, "Import")
        #self.Edit       = wx.Button(buttonBox, self.EditID, "Edit")
        self.Play       = wx.Button(buttonBox, self.PlayID, "Play")
        self.Stop       = wx.Button(buttonBox, self.StopID, "Stop")
        self.Remove     = wx.Button(buttonBox, self.RemoveID, "Remove")
        self.Seek       = wx.Button(buttonBox, self.SeekID, "Seek")
        self.Random     = wx.Button(buttonBox, self.RandomID, "Random")
        self.PlayCont   = wx.CheckBox(buttonBox, self.PlayContID, "Continued Play")
        buttonSizer = wx.BoxSizer(wx.HORIZONTAL)
        buttonSizer.AddMany([
            #(self.Refresh, 0, wx.SHAPED, 2),
            #((6,0), 0, wx.SHAPED, 2),
            #(self.Import, 0, wx.SHAPED, 2),
            #((6,0), 0, wx.SHAPED, 2),
            #(self.Edit, 0, wx.SHAPED, 2),
            #((6,0), 0, wx.SHAPED, 2),
            (self.Play, 0, wx.SHAPED, 2),
            ((6,0), 0, wx.SHAPED, 2),
            (self.Stop, 0, wx.SHAPED, 2),
            ((6,0), 0, wx.SHAPED, 2),
            (self.Remove, 0, wx.SHAPED, 2),
            ((6,0), 0, wx.SHAPED, 2),
            (self.Seek, 0, wx.SHAPED, 2),
            ((6,0), 0, wx.SHAPED, 2),
            (self.Random, 0, wx.EXPAND, 2),
            ((6,0), 0, wx.SHAPED, 2),
            (self.PlayCont, 0, wx.EXPAND, 2),
            ])
        buttonBox.SetSizer(buttonSizer)
        buttonBox.SetAutoLayout(1)
        buttonSizer.Fit(buttonBox)
        sizer.Add((0, 6), 0, wx.SHAPED)
        sizer.Add(buttonBox, 0, wx.EXPAND)
        
        # Set window layout
        self.SetSizer(sizer)
        self.SetAutoLayout(1)
        sizer.Fit(self)
        self.SetLegend("")

    def OnPlayVolume(self, evt):
        Player.Volume(self.PlayVolume.GetValue())

    def OnSliderScroll(self, evt):
        newPos = self.playbar.GetValue()
        print "Slider scrolled to position:" + str(newPos)
    
    def ItemCount(self):
	return self.list.GetItemCount()

    def Refresh(self):
        print "refreshed..............."

    def OnTrackSelected(self, ev):
	currentItem = self.list.GetFirstSelected()
	if currentItem == -1: return
        else: self.currentItem = currentItem

    def GetItemData(self, item):
        return self.list.GetItemData(item)

    def GetCurrentItemData(self):
        return self.list.GetItemData(self.currentItem)

    def Build(self):
        self.list.InsertColumn(0, "Song name", width=180)
        self.list.InsertColumn(1, "Album", width=180)
        self.list.InsertColumn(1, "Artist", width=180)
        self.list.InsertColumn(3, "Duration", wx.LIST_FORMAT_RIGHT, width=72)

    def PopulateData(self):
        # Get NewPlaylistID playlist from DB
        db = MySQLdb.connect(host=gv.constants.config.DBhost, user=gv.constants.config.DBuser, passwd=gv.constants.config.DBpass, db=gv.constants.config.DB)
        cursor = db.cursor()
        sql = '''SELECT title, date_format(created, '%%e/%%c/%%y %%H:%%d') FROM netjuke_plists
	    WHERE id="%(id)s" ORDER BY id''' % {"id": gv.constants.NewPlaylistID}
        cursor.execute(sql)
        result = cursor.fetchall()

        for record in result:
            playlistName = record[0]
            playlistCreateDate = record[1]

            cursor = db.cursor(MySQLdb.cursors.DictCursor)
            sql = 'SELECT sum(tr.size) / (1024*1024) size,'
            #sql += ''' time_format(sec_to_time(sum(tr.time)), "%H:%i:%S"),'''
	    sql += ''' time_format(sec_to_time(sum(tr.time)), "%i:%S") minutes,'''
            sql += ' sum(tr.time) length'
            sql += ' FROM netjuke_tracks tr, netjuke_plists_tracks pl WHERE pl.tr_id=tr.id'
            sql += ' AND pl.pl_id=%s' % gv.constants.NewPlaylistID
            cursor.execute(sql)
            result = cursor.fetchall()
            details = None
            self.playlistCount = 0
            
            for record in result:
                if record['size'] is not None   : self.size = float(record['size'])
                else: self.size = float(0)
                if record['minutes'] is not None: self.minutes = record['minutes'].strip()
                if record['length'] is not None: self.length  = int(record['length'])

            if self.size > 0 and self.minutes > 0:
                details = 'AUDIO-CD: %smin/%smin :: DATA-CD: %3.0fMB/%3.0fMB' % (self.length / 60, self.MaxLength / 60, self.size, self.MaxSize)
                self.playlistCount = self.playlistCount + 1

            if self.length < self.MaxLength:
                self.AudioWarned    = 0
                self.AudioOversized = 0
                 
            if details is None:
                details = "Your playlist is empty for the moment"
                playlistData = ['playlist', gv.constants.NewPlaylistID]

            # Set fancy-control information
            playlistInfo = "Details: %s" % (details)
            self.SetLegend (playlistInfo)
            self.capacity.SetValue (self.size)

            self.SelectedPlaylistID = gv.constants.NewPlaylistID

            cursor2 = db.cursor()
            sql = 'SELECT tr.id trackID, ar.name artist, al.name album, tr.name name'
            sql += ''' , time_format(sec_to_time(tr.time), "%H:%i:%S") duration'''
            sql += ', tr.location, tr.time'
            sql += ' FROM netjuke_artists ar, netjuke_albums al, netjuke_tracks tr, netjuke_plists_tracks pl, netjuke_plists pl_owner WHERE tr.ar_id=ar.id AND tr.al_id=al.id AND tr.id=pl.tr_id AND pl.pl_id=pl_owner.id AND pl_owner.id="%s" AND pl.pl_id=pl_owner.id ORDER BY pl.id DESC' % (gv.constants.NewPlaylistID)
            cursor2.execute(sql)
            result2 = cursor2.fetchall()

            i = 0
            SelectMe = None
            for record2 in result2:
                trackID = record2[0]
                trackName = record2[1]
                albumName = record2[2]
                artistName = record2[3]
                trackDuration = record2[4]
                trackLocation = record2[5]
                trackLength = record2[6]
                #trackRow = trackName + "(%s)" % trackDuration + ",\n" + albumName + ",\n" + artistName
                trackRowRAW = trackName
                #trackRow = unicode(trackRowRAW, 'iso-8859-1') + ' by %s (%s)' % (artistName, trackDuration)
                songName = unicode(trackRowRAW, 'iso-8859-1')
                trackRow = unicode(trackRowRAW, 'iso-8859-1') + " [%s]" % trackDuration

                plItemData = ['song', trackID, trackLocation, trackLength]
                self.list.InsertStringItem(i, unicode(artistName, 'iso-8859-1'))
                self.list.SetStringItem(i, 1, unicode(albumName, 'iso-8859-1'))
                self.list.SetStringItem(i, 2, songName)
                self.list.SetStringItem(i, 3, trackDuration)
		self.list.SetItemData(i, trackID)

        db.close()

        self.list.currentItem = self.lastSelection

        self.count = self.ItemCount()

        if self.lastSelection is not None:
            self.list.Select(self.lastSelection)

    def DeleteSelected(self):
	currentItem = self.list.GetFirstSelected()
	if currentItem < 0: return

	songID = self.list.GetItemData(currentItem)

	db = MySQLdb.connect(host=gv.constants.config.DBhost, user=gv.constants.config.DBuser, passwd=gv.constants.config.DBpass, db=gv.constants.config.DB)
        cursor = db.cursor()
        deletion = cursor.execute("DELETE FROM netjuke_plists_tracks WHERE tr_id=%s AND pl_id=%s", (songID, gv.constants.NewPlaylistID))
	db.close()
	self.Clear()
	self.PopulateData()

	if currentItem == self.count: self.list.Select(currentItem - 1)

    def LengthWarning(self):
        if self.AudioWarned:
            print "**  WARNED, NOT WARNING AGAIN"
            return
        txt = 'ATTENTION ! If you continue to add this track'
        txt += '\nyou will NOT BE ABLE to burn an AUDIO-CD'
        txt += '\n'
        txt += '\nYou can continue until you have NOT MORE than'
        txt += '\n700MB and burn a DATA-CD then'
        txt += '\n'
        txt += '\nIf you want to proceed to add this track anyway'
        txt += '\nclose this window and add this track again.'
	    
        self.Msg = Msg.Msg('WARNING:: AUDIO-CD Oversized', txt, 'BurnResultBox', 330, 210, 0)

        self.AudioWarned    = True
        self.AudioOversized = True

    def SizeWarning(self):
        txt = "You've reached the size limit for burning a DATA-CD"
        txt += "\nso adding this track to your playlist is not possible."
        txt += "\n"
        txt += "\nYou must remove some tracks if you really want"
        txt += "\nto include this one on your selection."
        txt += "\n"
        txt += "\nOr if you are ready, you can BURN the CD!"
        txt += "\n"

        self.Msg = Msg.Msg('ERROR:: DATA-CD Oversized', txt, 'BurnResultBox', 400, 300, 0)
        self.DataOversized = True

    def Add(self, trackLocation, trackID):
	db = MySQLdb.connect(host=gv.constants.config.DBhost, user=gv.constants.config.DBuser, passwd=gv.constants.config.DBpass, db=gv.constants.config.DB)

        print "trackLocation on Playlist.Add(): %s / trackID: %i" % (trackLocation, trackID)
	filePath = gv.constants.config.musicPath + trackLocation
        filePath = urllib.url2pathname(filePath)
	if False and not os.path.isfile(filePath):
	    raise IOError, "File not found."

        
	# FIXME validate size here before inserting to playlist
	# get current playlist size/length, popup warn....etc
	
	cursor = db.cursor()
	sql = "INSERT IGNORE INTO netjuke_plists_tracks SET tr_id=%s, pl_id=%s" % (trackID, gv.constants.NewPlaylistID)
        try: ret = cursor.execute(sql)
        except Exception, e: print "SQL ERROR: %s , trying query: %s" % (str(e), sql)
	db.close()

        # if track already in playlist, print a warning?
        #if ret == 0:
        #    Msg.Msg('Add to PlayList', 'This track is already in your playlist!', 'AddToPlaylist', 330, 210, 0, None)

	# rebuild Playlist
	self.Clear()
	self.PopulateData()

    def Clear(self):
        # Save the current selected item, if any
        self.lastSelection = self.list.GetFirstSelected()
        self.list.DeleteAllItems()

    def SetFocus(self):
	self.list.SetFocus()
	FocusManager.manager.SetFocus("PlayList")
        if (self.lastSelection is None) and (self.count > 0) :
            print self.list.Select(0)

    def SetLegend(self, msg):
        self.legend.SetLabel(msg)

    def Reload(self):
        logger.info("Reloading playlist.. ID: %i" % gv.constants.NewPlaylistID)
        self.Clear()
        self.title.SetLabel("Playlist #%i" % gv.constants.NewPlaylistID)
        self.PopulateData()

class InfoPanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

        self.sizer = wx.BoxSizer(wx.VERTICAL)

	self.currentLine = 0
        self.ReachedBottom = False
        self.ReachedTop    = True

        title = wx.StaticText(self)
        title.SetLabel("""Info Panel""")
        font = title.GetFont()
        font.SetPointSize(int(font.GetPointSize() * 1.2))
        font.SetWeight(wx.FONTWEIGHT_BOLD)
        title.SetFont(font)
        title.SetBackgroundStyle(wx.BG_STYLE_COLOUR)
        title.SetBackgroundColour(self.GetBackgroundColour())
        self.sizer.Add(title, 0, wx.EXPAND)

	logo = config.bshome+'/img/burnlogo_small.png'

        welcomeFile = config.bshome+'/data/welcome.txt'
	f = open(welcomeFile)
        welcome = unicode(f.read(), 'iso-8859-1')
	f.close()

        self.InfoPage = wx.Panel(self)
	self.TextPage = InfoPage2(self.InfoPage, welcome)
	self.ImgPage  = Img(self.InfoPage, logo)
        FocusManager.manager.Register("TextPage", self.TextPage)

        pageSizer = wx.BoxSizer(wx.HORIZONTAL)
        pageSizer.AddMany([
            ((6,0), 0, wx.SHAPED, 2),
            (self.TextPage, 0, wx.EXPAND, 2),
            ((6,0), 0, wx.SHAPED, 2),
            (self.ImgPage, 0, wx.EXPAND, 2),
            ])
        self.InfoPage.SetSizer(pageSizer)
        self.InfoPage.SetAutoLayout(1)
        pageSizer.Fit(self.InfoPage)
        self.sizer.Add((0, 6), 0, wx.SHAPED)
        self.sizer.Add(self.InfoPage, 0, wx.EXPAND)

        # control buttons
        buttonBox  = wx.Panel(self)
        self.AddID = wx.ID_ADD
        self.Add   = wx.Button(buttonBox, self.AddID) #, "Add to Playlist")
        buttonSizer = wx.BoxSizer(wx.HORIZONTAL)
        buttonSizer.Add(self.Add, 1, wx.EXPAND)
        buttonBox.SetSizer(buttonSizer)
        buttonBox.SetAutoLayout(1)
        buttonSizer.Fit(buttonBox)
        self.sizer.Add((0, 6), 0, wx.SHAPED)
        self.sizer.Add(buttonBox, 0, wx.EXPAND)

        self.SetSizer(self.sizer)
        self.SetAutoLayout(1)
        self.sizer.Fit(self)

    def ScrollDown(self):
        self.currentLine = self.currentLine + 1
	if not self.ReachedBottom:
            logger.debug("scrolling down")
            if not self.TextPage.body.ScrollLines(1):
                self.ReachedBottom = True
                self.ReachedTop    = False
        if not self.ReachedTop:
            logger.debug("scrolling up")
            if not self.TextPage.body.ScrollLines(-1):
                self.ReachedTop    = True
                self.ReachedBottom = False
 
    def LoadPage(self, itemData, type=None, playlist=-1):
        # when we load a page at the InfoPage for the InfoPanel, we load the item data as if we owned it
        self.InfoPage.itemData = itemData

        if type is 'welcome': page = 'Welcome to Burn Station...\nhave a lot of fun !!'
        else:
            self.TextPage.SetText('', None, 'title')
            try:
	        self.TextPage.AddText(itemData['type'] + ": ", 'title')
                self.TextPage.AddText(itemData['name'], 'normal')

                if itemData['type'] is 'song':
                    self.TextPage.AddRow('\nArtist: ', uniconvert2(itemData['artist']))
                    self.TextPage.AddRow('\nAlbum: ', uniconvert2(itemData['album']))
                    self.TextPage.AddRow('\nLabel: ', uniconvert2(itemData['label']))
                    self.TextPage.AddRow('\nSize: ', str(itemData['size']) + ' MB')
                    self.TextPage.AddRow('\nLength: ', str(itemData['length']))
    
                if itemData['info'] is not None:
                    self.TextPage.AddText('\nInfo: ', 'title')
                    self.TextPage.AddText(uniconvert2(html2text(urllib.unquote(itemData['info']))), 'normal')
    
                img = ValidateImage(itemData['img'], itemData['type'])
		print "IMG IS:"
		print img
                self.ImgPage.SetImage(img)
                self.TextPage.body.SetInsertionPoint(0)
            except Exception, e: logger.info("No page to load: %s" % str(e))

    def GetInfo(self, id, type, playlist=-1):
        return

        if   type is 'label'  : return self.GetLabelInfo(id, type)
        elif type is 'artist' : return self.GetArtistInfo(id, type)
        elif type is 'album'  : return self.GetAlbumInfo(id, type)
        elif type is 'song'   : return self.GetSongInfo(id, type, playlist)

    def GetLabelInfo(self, id, type):
        db = MySQLdb.connect(host=gv.constants.config.DBhost, user=gv.constants.config.DBuser, passwd=gv.constants.config.DBpass, db=gv.constants.config.DB)

        sql = 'SELECT la.name label, la.comments, la.img_src img FROM netjuke_labels la WHERE la.id = %i' % id
        cursor = db.cursor()
        cursor.execute(sql)
        result = cursor.fetchall()
        
        itemInfo = {'page:':''}
        for record in result:
            img = ValidateImage(record[2], type)

            self.InfoPage.SetText('', None, 'title')
            self.InfoPage.AddText('Label: ', 'title')
            self.InfoPage.AddText(record[0], 'normal')

            if record[1] is not None:
                self.InfoPage.AddText('\nInfo: ', 'title')
                self.InfoPage.AddText(html2text(urllib.unquote(record[1])), 'normal')

        bitmap = convert2bitmap(img)

        self.InfoPage.ShowImage(img)

        #if bitmap is not False: self.image.SetBitmap(bitmap)
        #if bitmap is not False: image = bitmap

        return (itemInfo, bitmap)

    def GetArtistInfo(self, id, type):
        db = MySQLdb.connect(host=gv.constants.config.DBhost, user=gv.constants.config.DBuser, passwd=gv.constants.config.DBpass, db=gv.constants.config.DB)

        sql = 'SELECT ar.name artist, ar.img_src imagen, ar.comments comments, ar.home home FROM netjuke_artists ar WHERE ar.id = %i' % id
        cursor = db.cursor()
        cursor.execute(sql)
        result = cursor.fetchall()

        itemInfo = {'page:':''}
        itemInfo['page'] = ''
        for record in result:
            itemInfo['page'] += '\n'
            itemInfo['page'] += 'Artist: %s'    % record[0]
	    if record[2] is not None:
                itemInfo['page'] += '\n\n'
                itemInfo['page'] += '%s' % urllib.unquote(record[2])
            img = ValidateImage(record[1], type)

            self.InfoPage.SetText('', None, 'title')
            self.InfoPage.AddText('Artist: ', 'title')
            self.InfoPage.AddText(record[0], 'normal')
            if record[2] is not None:
                self.InfoPage.AddText('\nInfo: ', 'title')
                self.InfoPage.AddText(html2text(urllib.unquote(record[2])), 'normal')

        self.InfoPage.ShowImage(img)

        bitmap = convert2bitmap(img)
        #if bitmap is not False: self.image.SetBitmap(bitmap)

        return (itemInfo, bitmap)

    def GetAlbumInfo(self, id, type):
        db = MySQLdb.connect(host=gv.constants.config.DBhost, user=gv.constants.config.DBuser, passwd=gv.constants.config.DBpass, db=gv.constants.config.DB)

        sql = 'SELECT al.name album, al.comments, al.img_src img FROM netjuke_albums al WHERE al.id = %i' % id
        cursor = db.cursor()
        cursor.execute(sql)
        result = cursor.fetchall()
        
        itemInfo = {'page:':''}
        itemInfo['page'] = ''
        for record in result:
            itemInfo['page'] += '\n'
            itemInfo['page'] += 'Album: %s'    % record[0]
	    if record[1] is not None:
                itemInfo['page'] += '\n\n'
                itemInfo['page'] += '%s' % urllib.unquote(record[1])
            img = ValidateImage(record[2], type)

            self.InfoPage.SetText('', None, 'title')
            self.InfoPage.AddText('Album: ', 'title')
            self.InfoPage.AddText(record[0], 'normal')
            if record[1] is not None:
                self.InfoPage.AddText('\nInfo: ', 'title')
                self.InfoPage.AddText(html2text(urllib.unquote(record[1])), 'normal')

        self.InfoPage.ShowImage(img)

        bitmap = convert2bitmap(img)
        #if bitmap is not False: self.image.SetBitmap(bitmap)

        return (itemInfo, bitmap)

    def GetSongInfo(self, id, type, playlist=-1):
        db = MySQLdb.connect(host=gv.constants.config.DBhost, user=gv.constants.config.DBuser, passwd=gv.constants.config.DBpass, db=gv.constants.config.DB)

        sql = 'SELECT tr.id, ar.name artist, al.name album, tr.name song, tr.img_src tr_img, al.img_src al_img, tr.comments comments, SEC_TO_TIME(tr.time), ((tr.size / 1024) / 1024) + 0.1, la.name, li.name FROM netjuke_artists ar, netjuke_albums al, netjuke_tracks tr, netjuke_labels la, licenses li WHERE ar.id=tr.ar_id AND al.id=tr.al_id AND tr.id = %i AND tr.la_id=la.id AND tr.license=li.id' % id
        cursor = db.cursor()
        cursor.execute(sql)
        result = cursor.fetchall()
        
	imgTr = ''
	imgAl = ''
        itemInfo = {'page:':''}
        itemInfo['page'] = ''
        for record in result:
            # check if this tracks is in current playlist
            itemInfo['inPlaylist'] = self.inPlaylist(record[0], playlist)

            if record[6] is not None:
                itemInfo['page'] += '\n'
                itemInfo['page'] += 'Extra   : %s'    % urllib.unquote(record[6])
            imgTr   = ValidateImage(record[4], type)
            imgAl   = ValidateImage(record[5], "al")

            self.InfoPage.SetText('', None, 'title')
            self.InfoPage.AddText('Track: ', 'title')
            self.InfoPage.AddText(record[3], 'normal')
            self.InfoPage.AddText('\nAlbum: ', 'title')
            self.InfoPage.AddText(record[2], 'normal')
            self.InfoPage.AddText('\nArtist: ', 'title')
            self.InfoPage.AddText(record[1], 'normal')
            self.InfoPage.AddText('\nLength: ', 'title')
            self.InfoPage.AddText(str(record[7]), 'normal')
            self.InfoPage.AddText('\nSize: ', 'title')
            self.InfoPage.AddText(str(record[8]), 'normal')
            self.InfoPage.AddText('\nLabel: ', 'title')
            self.InfoPage.AddText(record[9], 'normal')
            self.InfoPage.AddText('\nLicense: ', 'title')
            self.InfoPage.AddText(record[10], 'normal')
            self.InfoPage.AddText('\nInfo: ', 'title')
            if record[6] is not None:
                self.InfoPage.AddText(html2text(urllib.unquote(record[6])), 'normal')

            if itemInfo['inPlaylist']: itemInfo['page'] += '\n\n !! This track is on your PlayList !! ;) \n'

        if imgTr == '': img = imgAl
	else: img = imgTr

        self.InfoPage.ShowImage(img)

        #if bitmap is not False: self.image.SetBitmap(bitmap)
        if 0: pass
        else:
            bitmap = convert2bitmap(imgAl)
            #if bitmap is not False: self.image.SetBitmap(bitmap)

        return (itemInfo, bitmap)

    def inPlaylist(self, trackID, playlistID):
        db = MySQLdb.connect(host=gv.constants.config.DBhost, user=gv.constants.config.DBuser, passwd=gv.constants.config.DBpass, db=gv.constants.config.DB)

        sql = 'SELECT tr_id FROM netjuke_plists_tracks WHERE tr_id = %i AND pl_id = %i' % (trackID, playlistID)
        cursor = db.cursor()
        cursor.execute(sql)
	if cursor.rowcount > 0: return True
        else: return False

    def SetFocus(self):
        print "xxxxxxxxxxxxxxxxxxxxx"


class MusicPanel(wx.Panel):

    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

        self.trackID = None
        self.tab = {}
        self.tabs = {} 
        self.tabs = {
                     0 : 'MusicTree'
                     #1 : 'ReportsTree'
                     #2 : 'NewMusicTree'
                    }

        sizer = wx.BoxSizer(wx.VERTICAL)

        self.nb = wx.Notebook(self, -1, style=wx.CLIP_CHILDREN)
        self.nb.Bind(wx.EVT_NOTEBOOK_PAGE_CHANGED, self.OnPageChanged)
	
	#------------------------------------------------------------------------------
        # set the MusicTree inside the first nb0 page
	for tab in self.tabs.values():
            self.tab[tab+'ID'] = wx.NewId()
            self.tab[tab] = wx.TreeCtrl(self.nb, self.tab[tab+'ID'],
            size=(400, 620),
            style=wx.TR_HAS_BUTTONS | wx.TR_HAS_VARIABLE_ROW_HEIGHT |
            wx.TR_HIDE_ROOT
            )
            # Bind the movePrev function
            self.tab[tab].Bind(wx.EVT_SET_FOCUS, lambda x: self.tab[tab].SetBackgroundColour(gv.constants.SelPanelColor))
            self.tab[tab].Bind(wx.EVT_KILL_FOCUS, lambda x: self.tab[tab].SetBackgroundColour(gv.constants.NorPanelColor))
            #self.tab[tab].Bind(wx.EVT_SET_FOCUS, lambda x: FocusManager.manager.SetFocus(tab))
            #print "binding %s to %s" % (tab,self.tab[tab])
            FocusManager.manager.Register(tab, self.tab[tab])

            # add MusicTree to first nb page
            self.nb.AddPage(self.tab[tab], tab)

        sizer.Add(self.nb, 1, wx.EXPAND)

        # defaul focused tab
        self.nb.SetSelection(0)

        # control buttons
        buttonBox       = wx.Panel(self)
	self.BurnID     = wx.NewId()
        self.Burn       = wx.Button(buttonBox, self.BurnID, "Burn!")
        buttonSizer = wx.BoxSizer(wx.HORIZONTAL)
        buttonSizer.Add(self.Burn, 1, wx.EXPAND)
        buttonBox.SetSizer(buttonSizer)
        buttonBox.SetAutoLayout(1)
        buttonSizer.Fit(buttonBox)
        sizer.Add((0, 6), 0, wx.SHAPED)
        sizer.Add(buttonBox, 0, wx.EXPAND)

        self.SetSizer(sizer)
        self.SetAutoLayout(1)
        sizer.Fit(self)

    def SetSelection(self, i):
        self.nb.SetSelection(i)

    def OnPageChanged(self, evt):
        NewPage = evt.GetSelection()
        if   NewPage is 0: self.FocusTree('MusicTree')
        elif NewPage is 1: self.FocusTree('ReportsTree')
        elif NewPage is 2: self.FocusTree('NewMusicTree')
        evt.Skip()

    def FocusTree(self, tree):
        #self.tab[tree].SetFocus()
        #self.tab[tree].SetBackgroundColour(gv.constants.SelPanelColor)

        FocusManager.manager.SetFocus(tree)

        item = self.tab[tree].GetSelection()
        itemData = self.GetItemData(tree, item)
	self.i = itemData

	try:
            self.tab[tree].itemData = itemData
        except Exception, e:
            logger.debug("no itemData: %s" % str(e))

    def OnMusicTreeExpanding(self, event):
        tree = 'MusicTree'
        item = self.tab[tree].GetSelection()
	last = self.tab[tree].GetLastChild(item)
	self.tab[tree].EnsureVisible(last)
	self.tab[tree].EnsureVisible(item)

    def OnNewMusicTreeExpanding(self, event):
        tree = 'NewMusicTree'
        item = self.tab[tree].GetSelection()
	last = self.tab[tree].GetLastChild(item)
	self.tab[tree].EnsureVisible(last)
	self.tab[tree].EnsureVisible(item)

    def OnReportsTreeExpanding(self, event):
        tree = 'ReportsTree'
        item = self.tab[tree].GetSelection()
	last = self.tab[tree].GetLastChild(item)
	self.tab[tree].EnsureVisible(last)
	self.tab[tree].EnsureVisible(item)

    def OnFocusMusicTree(self, event):
        self.FocusTree('MusicTree')

    def OnFocusNewMusicTree(self, event):
        self.FocusTree('NewMusicTree')

    def OnFocusReportsTree(self, event):
        self.FocusTree('ReportsTree')

    def GetItemData(self, tab, item):
        itemData = self.tab[tab].GetPyData(item)

	self.ItemData = itemData

	return itemData

    def SetFocus(self):
	self.MusicTree.SetFocus()

class MessagePanel(wx.Panel):
    def __init__(self, parent):
        wx.Panel.__init__(self, parent)

        sizer = wx.BoxSizer(wx.HORIZONTAL)

        self.label = wx.StaticText(self)
        self.label.SetBackgroundStyle(wx.BG_STYLE_COLOUR)
        self.label.SetBackgroundColour(self.GetBackgroundColour())
	self.label.SetLabel("Message : Press CTRL+H for more info")
        sizer.Add(self.label, 1, wx.EXPAND)

        self.timer = wx.StaticText(self)
        self.timer.SetBackgroundStyle(wx.BG_STYLE_COLOUR)
        self.timer.SetBackgroundColour(self.GetBackgroundColour())
	self.timer.SetLabel("Session Time : 00:00:00")
        sizer.Add(self.timer, 0, wx.EXPAND)

	self.currentTick = 0;
	self.tickID = wx.NewId()
	self.tick = wx.Timer(self, self.tickID)
	wx.EVT_TIMER(self, self.tickID, self.OnTick)
	self.tick.Start(1000)

	self.SetSizer(sizer)
        self.SetAutoLayout(1)
        sizer.Fit(self)

    def ResetTime(self):
	self.currentTick = 0

    def OnTick(self,evet):
	self.currentTick += 1
	h = int(self.currentTick/3600)
	m = int((self.currentTick-h*3600)/60)
	s = self.currentTick - h*3600-m*60
	self.timer.SetLabel ("""Session Time : %02d:%02d:%02d""" % (h, m, s))

    def SetMessage(self, msg):
	self.label.SetLabel(msg)

