#/usr/bin/env python
"""
burnstation - free media distribution system
"""

#Import Modules
import os, pygame
from pygame.locals import *

from scroller import Scroller
from Browser import *
from text import *
from player import Player
from burner import Burner
from MiscTools import *

#import virtkeyboard
#mykeys = virtkeyboard.VirtualKeyboard()
#userinput = mykeys.run(screen, "text")

if not pygame.font: logger.info('Warning, fonts disabled')
if not pygame.mixer: logger.info('Warning, sound disabled')

APP_NAME="Burn Station 2.0-beta"

SCREENWIDTH=1024
SCREENHEIGHT=768
#STARTFULLSCREEN=True
BLACK=(0,0,0)
GREY=(100,100,100)
RED=(200, 10, 10)
RED1=(100, 10, 10)
RED2=(150, 10, 10)
RED3=(200, 10, 10)
RED4=(250, 10, 10)

burn=0

def main():
    """this function is called when the program starts.
       it initializes everything it needs, then runs in
       a loop until the function returns."""
#Initialize Everything
    pygame.init()
    screen = pygame.display.set_mode((SCREENWIDTH, SCREENHEIGHT))
    pygame.display.set_caption(APP_NAME)
    pygame.mouse.set_visible(1)

#Create The Backgound
    #background2 = pygame.Surface(screen.get_size())
    #background1 = pygame.Surface((1000,49))
    #background1 = background1.convert()
    #background1.fill((30, 30, 30))

    # create music browser background
    music_bg = pygame.Surface((1000,500))
    music_bg = music_bg.convert()
    music_bg.fill(BLACK)

    # create burnlist background
    playlist_bg = pygame.Surface((600,100))
    playlist_bg = playlist_bg.convert()
    playlist_bg.fill(BLACK)

    # create player control background
    player_bg = pygame.Surface((395,100))
    player_bg = player_bg.convert()
    player_bg.fill(RED)

    # create burn control background
    burner_bg = pygame.Surface((395,100))
    burner_bg = burner_bg.convert()
    burner_bg.fill(RED)

#Display The Background
    screen.blit(music_bg, (0, 0))
    pygame.display.flip()

#Prepare Game Objects
    clock = pygame.time.Clock()

    # app title - init values: string, size, x, y, color
    t = Text(APP_NAME, 36, 580, 50, RED)
    title = t.Show()

    # label name display
    la = Text("", 28, 580, 50, RED1)
    label = la.Show()

    # artist name display
    ar = Text("", 28, 580, 50, RED2)
    artist = ar.Show()

    # album name display
    al = Text("", 28, 580, 50, RED3)
    album = al.Show()

    # album name display
    tr = Text("", 28, 580, 50, RED4)
    track = tr.Show()

    # content browser
    musicbrowser    = Scroller(Browser(), music_bg, 400, BLACK, 60, 15)

    # create a new burnlist
    playlistID = Database.CreatePlaylist()
    logger.info("Created new playlist ID = %i" % playlistID)
    title = t.UpdateText(APP_NAME+" :: Playlist #%i" % playlistID)

    # build burnlist
    playlistbrowser = Scroller(Browser('playlist', playlistID), playlist_bg, 30, BLACK, 36, 10)

    # player controls
    player = Player(player_bg)

    # burner controls
    burner = Burner(burner_bg, RED1)

    # update all sprites
    allsprites = pygame.sprite.RenderPlain((playlistbrowser, musicbrowser, player))

    musicbrowser.SetSelected()
    browser = musicbrowser

    #if STARTFULLSCREEN: pygame.display.toggle_fullscreen()

#Main Loop
    while 1:
        clock.tick(60)

    #Handle Input Events
        for evt in pygame.event.get():
            if evt.type == QUIT:
                return
            elif evt.type == MOUSEBUTTONDOWN:
                print "mouse button down"
                mousepos = pygame.mouse.get_pos()
                player.Click(mousepos)
            elif evt.type is MOUSEBUTTONUP:
                print "mouse button up"

            if evt.type == pygame.JOYBUTTONDOWN:
                logger.debug( "Joy: %i Button: %i DOWN" % (evt.joy,evt.button) )
                if evt.button == 4:
                    browser.goUp()
                if evt.button == 1:
                    browser.goDown()
            if evt.type == pygame.JOYBUTTONUP:
                browser.stopMoving()
    
            # keyboard events
            if evt.type == KEYDOWN:
                logger.debug( "Got keypress: " + str(evt.key) )
    
                if evt.key == K_UP:
                    browser.goUp()
                if evt.key == K_DOWN:
                    browser.goDown()
                    #playlistbrowser.goDown()

                if evt.key == K_RETURN or evt.key == K_SPACE or evt.key == 275: # enter, space or arrow-right
                    '''An item was selected'''
                    if browser.browser.level == 'labels':
                        label = la.UpdateText("@ Label: " + browser.list[browser.selected]['name'])
                        artist = ar.UpdateText("")
                        album = al.UpdateText("")
                    if browser.browser.level == 'artists':
                        artist = ar.UpdateText("@ Artist: " + browser.list[browser.selected]['name'])
                        album = al.UpdateText("")
                    if browser.browser.level == 'albums':
                        album = al.UpdateText("@ Album: " + browser.list[browser.selected]['name'])
                    if browser.browser.level == 'tracks':
                        track = tr.UpdateText("Now playing: " + browser.list[browser.selected]['name'])
                    browser.BrowseForward()

                if evt.key == 276: # arrow-left
                    browser.BrowseBack()
                    if browser.browser.level == 'albums':
                        album = al.UpdateText("")
                    if browser.browser.level == 'artists':
                        artist = ar.UpdateText("")
                    if browser.browser.level == 'labels':
                        label = la.UpdateText("")
    
                ### PlayList controls ###
                if evt.key == 97: # a
                    browser.AddToRemoveFromPlaylist(playlistID)
                    playlistbrowser.Refresh()
                #########################
    
                ### Playback controls ###
                # STOP
                if evt.key == 120: # x = stop playback
                    pygame.mixer.music.stop()
                    track = tr.UpdateText("Now playing: nothing")
                # SEEK forward
                if evt.key == 99:
                    browser.Seek('fwd')
                # SEEK backward
                if evt.key == 122:
                    browser.Seek('rew')
                #########################
    

                ### Burner controls ###
                if evt.key == 98: # b = burn
                    logger.info("About to burn playlist #%i" % playlistID)
                    
                    # player controls browser background at position x,y
                    BURN = True
                    burner.SetSelected()

                if evt.key == 49: # b = burn
                    logger.info("Starting to burn Audio CD")
                    burner.BurnCD()
                #########################
                    
                ### Navigation controls ###
                if evt.key == 9: # TAB
                    if browser == musicbrowser:
                        browser.SetUnSelected()
                        playlistbrowser.SetSelected()
                        browser = playlistbrowser
                    elif browser == playlistbrowser:
                        browser.SetUnSelected()
                        musicbrowser.SetSelected()
                        browser = musicbrowser
                ###########################

                if evt.key == 27: # ESC
                    logger.info("Requested quit... come back soon, bye!")
                    return

        if evt.type == KEYUP:
            browser.stopMoving()

        browser.loop()
        allsprites.update()

    #Draw Everything
        # title browser background
        screen.blit(title, (0, 0))

        # label display background
        screen.blit(label, (10, 25))

        # artist display background
        screen.blit(artist, (20, 45))

        # album display background
        screen.blit(album, (30, 65))

        # album display background
        screen.blit(track, (40, 85))

        # music browser background
        screen.blit(music_bg, (0, 105))

        # burnlist browser background
        screen.blit(playlist_bg, (0, 605))

        # player controls browser background at position x,y
        screen.blit(player_bg, (605, 605))

        # burner controls browser background at position x,y
        if burn: musicbrowser.surface.blit(burner_bg, (200, 200))

        #allsprites.draw(screen)
        pygame.display.flip()

#Game Over


#this calls the 'main' function when this script is executed
if __name__ == '__main__': main()


