#!/BIn/env python
# -*- coding: utf-8 -*-

import pygame
from pygame.locals import *
import math
import time

import pygame
import pygame.joystick
import pygame.display

import os, os.path
from MiscTools import *
import urllib

RED=(200,0,0)
BLUE1=(10,20,50)

from text import Text 

pygame.display.init()
pygame.joystick.init() #initialize joystick module
pygame.joystick.get_init() #verify initialization (boolean)

def load_image(name, colorkey=None):
    fullname = os.path.join('data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()

#--------------------------------------------------------------------
class FontCache:
    def __init__(self, face, size):
        self.face = face
        self.size = size
        self.cache = {}

        num_joysticks = pygame.joystick.get_count()
        if num_joysticks > 0:
            self.stick = pygame.joystick.Joystick(0)
            self.stick.init() # now we will receive events for the joystick

    #--------------------------------------------------------------------
    def get(self, scale):
        font = self.cache.get(scale)
        if font is None:
            font = self.cache[scale] = pygame.font.Font(self.face, int(round(self.size * scale)))
        return font

#--------------------------------------------------------------------
class Player(pygame.sprite.Sprite):
    def __init__(self, surface):
        pygame.sprite.Sprite.__init__(self)

        self.items=[]

        # start browsing at the labels level
        self.image, self.rect = load_image('play.png', -1)

        self.surface = surface
        self.mustRender = True

        self.render()

    #--------------------------------------------------------------------
    def Redraw(self, index=-1):
        self.items=[]
        for record in self.list:
            self.items.append(record['name'])
        self.getSelected(self.list, index)
        self.mustRender = True

    #--------------------------------------------------------------------
    def goUp(self):
        self.keystart = time.time()
        self.selected -= 1
        self.velocidad = -1.0
        self.mustRender = True

    #--------------------------------------------------------------------
    def goDown(self):
        self.keystart = time.time()
        self.selected += 1
        self.velocidad = 1.0
        self.mustRender = True
        try: self.itemID = self.list[self.selected]['id']
        except: logger.warn("Invalid index")

    #--------------------------------------------------------------------
    def stopMoving(self):
        self.velocidad = 0.0
        self.selected = int(round(self.selected))

    #--------------------------------------------------------------------
    def BrowseForward(self):
        # identify which item was selected to be browse
        self.itemID = self.list[self.selected]['id']
        if self.browser.level == 'labels':
            #self.labelName = self.list[self.selected]['name']
            print self.list[self.selected]['name']
        if self.browser.level != 'tracks' and self.browser.level != 'playlist_tracks':
            self.list = self.browser.getList(self.itemID, self.selected)
            self.Redraw()
        else:
            self.Play()

    #--------------------------------------------------------------------
    def BrowseBack(self):
        if self.browser.level != 'labels' and self.browser.level != 'playlist_tracks':
            goBack = self.browser.Back()
            self.list = goBack['list']
            self.Redraw(goBack['index'])

    #--------------------------------------------------------------------
    def PlayBtn(self):
        self.ShowText("string", 40, 0, 0, (30,70,140), self.surface)

    #--------------------------------------------------------------------
    def Play(self):
        '''Play the file'''
        filepath = self.list[self.selected]['location']
        file = urllib.url2pathname(filepath)
        logger.debug( "Play file : " + file )
        try:
            pygame.mixer.music.load(file)
            self.playtime = 0
            pygame.mixer.music.play()
        except Exception, e:
            logger.error( "File not found: " + str(e) )

    #--------------------------------------------------------------------
    def Click(self, pos):
        print self.rect
        print pos

    #--------------------------------------------------------------------
    def Seek(self, direction):
        curpos = pygame.mixer.music.get_pos()
        if direction == 'fwd':
            self.playtime += float(curpos) / 1000
            newpos = self.playtime * 2
        elif direction == 'rew':
            self.playtime -= float(curpos) / 1000
            newpos = self.playtime / 2
        logger.debug( "Current playback to position: %s" % str(curpos) )
        logger.debug( "Seeking playback to position: %s" % str(newpos) )
        pygame.mixer.music.play(0, newpos)

    #--------------------------------------------------------------------
    def update(self):
        if self.mustRender:
            self.render()
            self.mustRender = False

    #--------------------------------------------------------------------
    def render(self):
        # player background
        self.surface.fill(BLUE1)

        ######################################################
        # build play button text label
        t = Text("[enter] = play", 22, 95, 15, RED)
        playlabel = t.Show()
        # play button image
        self.playimage = self.surface.blit(self.image, (0, 0))
        # render text at position
        self.surface.blit(playlabel, (0, 30))
        ######################################################

        ######################################################
        # build play button text label
        t2 = Text("[X] = stop", 22, 75, 15, RED)
        stoplabel = t2.Show()
        # stop button image
        self.stopimage = self.surface.blit(self.image, (90, 0))
        # render text at position
        self.surface.blit(stoplabel, (110, 30))
        ######################################################


        print "rendering player"

    #--------------------------------------------------------------------
    def getLabel(self, number):
        number = int(round(number))
        if number < 0 or number >= len(self.items):
            return
        return self.items[number]

    #--------------------------------------------------------------------
    def SetSelected(self):
        self.bgcolor = BG_SELECTED
        self.mustRender = True

    #--------------------------------------------------------------------
    def SetUnSelected(self):
        self.bgcolor = BLACK
        self.mustRender = True

    #--------------------------------------------------------------------
    def loop(self):
        if self.velocidad and time.time() > self.keystart + DELAY:
            self.selected = self.selected + self.velocidad
            if( math.fabs(self.velocidad) < MAXSPEED) :
                self.velocidad *= ACELERACION
            self.mustRender = True

#--------------------------------------------------------------------
