import pygame
from pygame.locals import *

class Text:
    def __init__(self, string, size, x, y, color, bgcolor=(0,0,0)):
        self.string = string
        self.size = size
        self.x = x
        self.y = y 
        self.color = color
        self.bgcolor = bgcolor
        self.CreateSurface()

    def Clear(self):
        return self.CreateSurface()

    def CreateSurface(self):
        self.bg = pygame.Surface((self.x, self.y))
        self.bg = self.bg.convert()
        self.bg.fill(self.bgcolor)
        #logger.debug("created surface text...")
        return self.bg

    def UpdateText(self, string):
        self.string = string
        return self.Show()

    def Show(self):
        #logger.debug("Displaying text: %s" % self.string)
        self.Clear()
        font = pygame.font.Font(None, self.size)
        text = font.render(self.string, 1, self.color)
        textpos = text.get_rect()
        textpos.x = 0
        textpos.y = 0
        self.bg.blit(text, textpos)
        return self.bg
