#!/usr/bin/env python

import sys, os, string, MySQLdb, getopt, os.path
sys.path.append('..')
sys.path.append('../import')
sys.path.append('../lib')
import LoadConfig
config=LoadConfig.LoadConfig()
db = MySQLdb.connect(host=config.DBhost, user=config.DBuser, passwd=config.DBpass, db=config.DB)
from RecursiveParser import RecursiveParser
from mutagen.oggvorbis import OggVorbis
import time

def label_tagger(basedir=''):

    print
    print "-------------------------------------------------------------------------------"
    print " !!! NOTICE !!!  !!! NOTICE !!!  !!! NOTICE !!!  !!! NOTICE !!!  !!! NOTICE !!!"
    print "-------------------------------------------------------------------------------"
    print
    print "This script will tag ALL your Burn Station OGG files with their proper"
    print "'Label' tag (metadata)..."
    print
    print "Please, be patient and while until finished......."
    print
    print "-------------------------------------------------------------------------------"

    for i in range(10):
        n = 10 - i
        print "STARTING in %i seconds.." % n
        time.sleep(1)

    print "NOW !"
    time.sleep(5)

    list = ()
           
    list = (
            [ "20kbps", config.musicPath + "music/20kbps" ],
            [ "Grand Moffworks", config.musicPath + "music/Grand Moffworks" ],
            [ "Soulseek Records", config.musicPath + "music/Soulseek Records" ],
            [ "Test Tube", config.musicPath + "music/TestTube" ],
            [ "Trastienda", config.musicPath + "music/Trastienda" ],
            [ "Alku", config.musicPath + "music/alku" ],
            [ "Autoplate", config.musicPath + "music/autoplate" ],
            [ "cleanscenecuts.net", config.musicPath + "music/cleanscenecuts.net" ],
            [ "Comatronic", config.musicPath + "music/comatronic" ],
            [ "Fukkgod", config.musicPath + "music/fukkgod" ],
            [ "iDeal Recordings", config.musicPath + "music/idealrecordings" ],
            [ "Jahtari", config.musicPath + "music/jahtari" ],
            [ "Kikapu", config.musicPath + "music/kikapu" ],
            [ "Microbio", config.musicPath + "music/microbio" ],
            [ "MP3Death", config.musicPath + "music/mp3death.us" ],
            [ "Musica Para Espias", config.musicPath + "music/musica_para_espias" ],
            [ "nolabel", config.musicPath + "music/nolabel" ],
            [ "No Type", config.musicPath + "music/notype" ],
            [ "Plataforma LTW", config.musicPath + "music/plataforma_ltw" ],
            [ "Pueblo Nuevo", config.musicPath + "music/pueblo_nuevo" ],
            [ "Push the Button", config.musicPath + "music/pushthebutton.tk" ],
            [ "Stasisfield", config.musicPath + "music/stasisfield.com" ],
            [ "Sweet Smelling Surfaces", config.musicPath + "music/sumodehouse" ],
            [ "Synergy Networks", config.musicPath + "music/synergy-networks" ],
            [ "Thinner", config.musicPath + "music/thinner" ],
            [ "Walnutdoor", config.musicPath + "music/walnutdoor" ]
           )

    for item in list:
        label = item[0]
        dir = item[1]
        print
        print "--------------------------------------------------------"
        print "Processing directory: %s" % dir 
        print "Setting 'label' tag to: %s" % label
        print "--------------------------------------------------------"
        print

        try:
            print "* starting"
            parser = RecursiveParser()
            supportedFormats = ['ogg']

            files = parser.getRecursiveFileList(dir, supportedFormats)
            for file in files:

                audio = OggVorbis(file)
                audio["label"] = label
                audio.pprint()
                audio.save()
		print "saved file: %s" % file
		time.sleep(1)
            print
            print "Finished !!!"
            print
        except Exception, e: print "ERROR. There was an exception: %s" % str(e)

if __name__ == "__main__":
    if len(sys.argv) > 1:
        basedir = sys.argv[1]
    else:
        print "* Detected musicPath = %s" % config.musicPath
	basedir = config.musicPath

    print "* Using basedir: %s" % basedir

    label_tagger(basedir)

