#!/usr/bin/env python

from UpgradeCommon import *

import sys, os, shutil, time, string, MySQLdb, urllib, time
sys.path.append('..')
sys.path.append('.')

import LoadConfig
from label_tagger import *

config=LoadConfig.LoadConfig()
db = MySQLdb.connect(host=config.DBhost, user=config.DBuser, passwd=config.DBpass, db=config.DB)

#----------------------------------------------------------
def createOldID(table):

    if table == 'netjuke_labels': after = 'exclude'
    if table == 'netjuke_artists': after = 'exclude'
    if table == 'netjuke_albums': after = 'la_id'
    if table == 'netjuke_tracks': after = 'enabled'

    message = "* Creating 'old_id' field for table: %s .." % table
    sql = "ALTER TABLE `%s` ADD `old_id` INT NOT NULL AFTER `%s`" % (table, after)
    sqlExec(sql, message)


'''
SYNC IDs
---------

- walk netjuke_tracks
  - SELECT la_id WHERE labels.old_id = trackID, ar_id, al_id


'''

#----------------------------------------------------------
def setNewIDs(trackID):
    '''
    Sets the newID for trackID on each of relation fields
    '''

    global db

    fields = ['la_id', 'ar_id', 'al_id']

    for field in fields:
        if field == 'la_id': table = 'netjuke_labels'
        if field == 'ar_id': table = 'netjuke_artists'
        if field == 'al_id': table = 'netjuke_albums'

	print
	print "HERE ::: field = %s / table = %s" % (field,table)
	print

	print
	print "------------------------------------------------------"
	print " ** Processing table : " + table
	print

        newID = getCurrentID(trackID, field, table)
	print
	print "99 got newID = %i for trackID = %i on field = %s" % (newID, trackID, field)
	print
	#print "***** trackID = %i had la_id = %i , now will be la_id = %i" % (trackID, )

        sql  = "UPDATE netjuke_tracks SET %s = '%i' WHERE id='%i'" % (field, newID, trackID)
	print "! About to update 'netjuke_tracks' table to corresponding new IDs on related tables ! ..."
	print "in setNewIDs using SQL query: " + sql
        try:
            cursor = db.cursor()
            cursor.execute(sql)
	
            print "UPDATED OK!"

        except Exception, e:
            print ".. got ERROR: " + str(e)

#----------------------------------------------------------
def getCurrentID(trackID, field, table):

    global db

    # get oldID for field from tracks
    sql  = "SELECT %s FROM netjuke_tracks WHERE id='%i'" % (field, trackID)
    cursor = db.cursor()
    cursor.execute(sql)
    result = cursor.fetchall()
    record = None
    for record in result:
        oldID = record[0]

        # now get new ID from table, where old_id = netuke_tracks.field
        sql  = "SELECT id FROM %s WHERE old_id='%i'" % (table, oldID)
        print "RUNNING SQL TO GET CURRENT ID FOR '%s' TABLE : %s" % (table, sql)
        cursor2 = db.cursor()
        try:
            cursor2.execute(sql)
            result2 = cursor2.fetchall()
            record2 = None
            for record2 in result2:
                currentID = record2[0]

            return currentID
	
        except Exception, e:
            error = e.args
            print "Using SQL query: " + sql
            print ".. got ERROR: " + str(e)

	    return -2

#----------------------------------------------------------
def walkTracks():
    '''
    Iterate over every track ID, and get its current la_id, ar_id, al_id,
    match each of them against the 'old_id' field in corresponding table
    (that is netjuke_labels, _artists and _albums) to get the new ID,
    and update each track entry.
    '''

    global db

    sql  = "SELECT id FROM netjuke_tracks ORDER BY id ASC"

    cursor = db.cursor()
    cursor.execute(sql)
    result = cursor.fetchall()
    record = None
    for record in result:
        trackID = record[0]

        # set newID to related tables (labels, artists, albums)
        setNewIDs(trackID)

    print
    print "!! FINISHED !!"
    print

#----------------------------------------------------------
def removeIDfromFields(table):
    '''
    return fields list for table, excluding id, in order to sed the dump,
    to remove the ID field, so that it gets re-generated (re-indexed)
    '''

    sql = "SELECT * from %s LIMIT 1" % table
    cursor = db.cursor()
    cursor.execute(sql)
    desc = cursor.description

    numFields = len(desc)
    tableFields = "("

    i = 1 
    for item in desc:
        if item[0] != 'id':
            tableFields += item[0]
            if i < numFields: tableFields += ", "
        i = i + 1

    tableFields += ")"
    
    return tableFields

#----------------------------------------------------------
#----------------------------------------------------------
#-------- BELOW WE CREATE FIELDS, AND UPDATE THEM ---------
#----------------------------------------------------------
#----------------------------------------------------------

def reIndex(table):
        sql = "ALTER TABLE `%s` DROP `id`" % table
	try:
            cursor = db.cursor()
            cursor.execute(sql)
        except Exception, e:
            print "ERROR: running SQL: %s" % sql

        sql = "ALTER TABLE `%s` ADD `id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST" % table
	try:
            cursor = db.cursor()
            cursor.execute(sql)
	    print "* succesfully re-indexed table: %s" % table
        except Exception, e:
            print "ERROR: running SQL: %s" % sql

        if table != 'netjuke_tracks':
            sql = "SELECT id FROM %s WHERE name='N/A'" % table
            try:
                cursor = db.cursor()
                cursor.execute(sql)
                result = cursor.fetchall()
                record = None
                for record in result:
                    naID = record[0]
                    print "* N/A GOT ID ... for table: %s: %i" % (table, naID)

            except Exception, e:
                print "ERROR: running SQL: %s\nexception: %s" % (sql, str(e))

            message = "* Swapping IDs to give N/A ID = 1"

            # move entry using ID = 1 out of the way
            sql = "UPDATE %s SET id = -1 WHERE id = 1" % table
            sqlExec(sql, message)

            # give N/A the ID = 1
            sql = "UPDATE %s SET id = 1 WHERE name = 'N/A'" % table
            sqlExec(sql, message)

            # give previous entry the ID which N/A had before
            sql = "UPDATE %s SET id = %i WHERE id = -1" % (table, naID)
            sqlExec(sql, message)


def walk_tables():
    
    global db

    tables = ['netjuke_labels', 'netjuke_artists', 'netjuke_albums', 'netjuke_tracks']

    for table in tables:
        print
        print "------------------------------------------------"
        print "* in walk_tables() processing table: %s" % table
        print

        # first create 'old_id* field to hold its current/old ID before being re-indexed
	# in order to keep sync
	createOldID(table)

        # now select all IDs for this table, and save them into its 'old_id' field
        sql = "SELECT id,name FROM %s ORDER BY id" % table
        cursor = db.cursor()
        try:
            cursor.execute(sql)
            result = cursor.fetchall()
            record = None
            for record in result:
                id = record[0]

                sql = "UPDATE %s SET old_id = '%i' WHERE id = '%i'" % (table, id, id)
		print "* Saving current ID into 'old_id' field.."
		print ".. using SQL query: " + sql
                cursor2 = db.cursor()
                cursor2.execute(sql)


				
        except Exception, e:
	    error = e.args[1]
	    print "Using SQL query: " + sql
	    print ".. got ERROR: " + str(e)

        tableFields = removeIDfromFields(table)

        reIndex(table)

        '''
        print "**** Drop and re-load dump for table: %s" % table
	dumpfile = "/tmp/" + table + ".id_sync.sql"
	cmd = "mysqldump -u%s -p%s %s %s | sed \"s/([0-9]*,/(/g\" | sed \"s/\(INSERT INTO.*%s.*\) VALUES/\\1 %s VALUES/g\" > %s " % (config.DBuser, config.DBpass, config.DB, table, table, tableFields, dumpfile)
	print "!!! dump command: " + cmd

	ret = os.system(cmd)
	if ret == 0:
            print
            print "dump OK ! ... now drop and reload"
            print
	else:
            print "ERROR doing dump!!"
	    return False

	cmd = "mysql -u%s -p%s -e \"DROP TABLE %s\" %s" % (config.DBuser, config.DBpass, table, config.DB)
	ret = os.system(cmd)
	if ret == 0:
            print
            print "* dropped table: %s !" % table
            print

	cmd = "cat %s | mysql -u%s -p%s %s" % (dumpfile, config.DBuser, config.DBpass, config.DB)
	ret = os.system(cmd)
	if ret == 0:
            print
            print "* re-indexed dump loaded OK !"
            print
        '''

#----------------------------------------------------------------------------------------------------------
'''Execute upgrade'''
#----------------------------------------------------------------------------------------------------------

walk_tables()

for i in range(10):
    print

walkTracks()

db.close()
