#!/usr/bin/env python

from UpgradeCommon import *

import sys, os, shutil, time, string, MySQLdb, urllib, time
sys.path.append('..')
sys.path.append('.')

import LoadConfig
from label_tagger import *

config=LoadConfig.LoadConfig()
db = MySQLdb.connect(host=config.DBhost, user=config.DBuser, passwd=config.DBpass, db=config.DB)

backupDump = '~/burnstation.sql.PRE_UPGRADE'
cmd = "mysqldump -u%s -p%s %s > %s" % (config.DBuser, config.DBpass, config.DB, backupDump)
print "* Doing backupDump (%s) before starting !" % backupDump
os.system(cmd)

#----------------------------------------------------------
def queries():
    '''Queries to update the database'''

    message = "* Creating file_uploader table..."
    sql = "CREATE TABLE IF NOT EXISTS `file_uploader` ( \
                 `file` INT NOT NULL , \
    	         `uploader` INT NOT NULL , \
    	   PRIMARY KEY ( `file` ) \
          ) ENGINE = MYISAM"
    sqlExec(sql, message)

    message = "* Adding 'enabled' field to netjuke_tracks..."
    sql = "ALTER IGNORE TABLE `netjuke_tracks` ADD `enabled` INT( 1 ) NOT NULL DEFAULT '1'"
    sqlExec(sql, message)

    message = "* Dropping 'licenses' table..."
    sql = "DROP TABLE licenses"
    sqlExec(sql, message)

    message = "* Adding 'license' table..."
    sql = "CREATE TABLE IF NOT EXISTS `licenses` ( \
                  `id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY , \
                  `name` VARCHAR( 255 ) NOT NULL , \
                  `description` LONGTEXT NOT NULL \
          ) ENGINE = MYISAM"
    sqlExec(sql, message)

    licenses = [
                 "N/A",
                 "CC Attribution",
                 "CC Attribution No Derivatives",
                 "CC Attribution Non-commercial No Derivatives",
                 "CC Attribution Non-commercial Share Alike",
                 "CC Attribution Non-commercial",
                 "CC Attribution Share Alike",
                 "Aire Incondicional",
                 "Licence Art Libre",
                 "GNU GPL",
                 "Public Domain"
               ]

    for license in licenses:
        message = "* Inserting license '%s' into licenses table ..." % license
        sql = "INSERT INTO `licenses` ( `id` , `name` , `description` )  VALUES ( '0', '%s', 'license text here maybe ... ?')" % license
        sqlExec(sql, message)

    message = "* Dropping 'mp3tmp' table..."
    sql = "DROP TABLE mp3tmp"
    sqlExec(sql, message)

    message = "* Adding mp3tmp table..."
    sql = "CREATE TABLE IF NOT EXISTS `mp3tmp` ( \
                   `title` VARCHAR( 255 ) NOT NULL, \
                   `artist` VARCHAR( 255 ) NOT NULL, \
                   `license` VARCHAR( 255 ) NOT NULL, \
                   `label` VARCHAR( 255 ) NOT NULL, \
                   `album` VARCHAR( 255 ) NOT NULL, \
                   `composer` VARCHAR( 255 ) NOT NULL, \
                   `comment` LONGTEXT NULL, \
                   `year` INT NOT NULL DEFAULT '0', \
                   `genre` VARCHAR( 255 ) NOT NULL, \
                   `tracknumber` INT NOT NULL DEFAULT '0', \
                   `uploader` INT NOT NULL, \
                   `location` MEDIUMTEXT NULL, \
                   `imported` INT NOT NULL DEFAULT '0'\
	   ) ENGINE = MYISAM"
    sqlExec(sql, message)

#----------------------------------------------------------
def walkFilesID():
    '''
    Walk list of files in netjuke_tracks to check for relation with uploader
    and create if not existing.
    '''

    global db

    sql = "SELECT id FROM netjuke_tracks ORDER BY id"
    cursor = db.cursor()
    cursor.execute(sql)
    result = cursor.fetchall()

    for record in result:
	id = record[0]
	make_relation(id, 1)

#----------------------------------------------------------
def make_relation(fileID, userID):
    '''Make a relation between fileID and userID as uploader'''

    global db

    if not RelationExists(fileID):
        print "relation not existing, making it"

        sql = "INSERT INTO file_uploader SET file = '%i', uploader = '%i'" % (fileID, userID)
        print sql

        cursor = db.cursor()
        cursor.execute(sql)
    else:
        print "Relation exists.. doing nothing"


#----------------------------------------------------------
def RelationExists(fileID):
    '''Check if there is a relation between the fileID and any uploaderID'''

    global db

    sql = "SELECT file FROM file_uploader WHERE file = %i" % fileID
    cursor = db.cursor()
    cursor.execute(sql)
    result = cursor.fetchall()

    exists = None
    for record in result:
	exists = record[0]

    print "* Checking if relation exists for file with ID: %s" % str(exists)

    if exists is None: return False
    else: return True

#walkFilesID()
#----------------------------------------------------------------------------------------------------------
'''Execute upgrade'''
#----------------------------------------------------------------------------------------------------------

os.system("./reindexIDs.py")

queries()

time.sleep(1)

walkFilesID()

label_tagger()

db.close()
